package pwc.taxtech.atms.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.LoginOutputDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.user.UserPasswordDto;
import pwc.taxtech.atms.service.impl.UserAccountServiceImpl;

@RestController
@RequestMapping("/api/v1/Account/")
public class AccountController {
    private static final Logger logger = LoggerFactory.getLogger(AccountController.class);

    @Autowired
    private UserAccountServiceImpl userAccountService;

//    @ApiOperation(value = "修改密码")
    @RequestMapping(value = "userPassword", method = RequestMethod.PUT, produces = MediaType.APPLICATION_JSON_UTF8_VALUE, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public OperationResultDto<LoginOutputDto> changeExternalUserPassword(
            @RequestBody(required = false) UserPasswordDto userPasswordDto) {
        logger.debug("enter changeExternalUserPassword");
        OperationResultDto<LoginOutputDto> result = userAccountService.changeExternalUserPassword(userPasswordDto);
        return result;
    }

//    @ApiOperation(value = "忘记密码")
    @RequestMapping(value = "ForgetPassword", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public OperationResultDto<Object> forgetPassword(@RequestParam(name = "mail") String mail) {
        logger.debug("enter forgetPassword");
        return userAccountService.forgetPassword(mail);
    }
}
