package pwc.taxtech.atms.controller;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.dto.input.CamelPagingResultDto;
import pwc.taxtech.atms.dto.revenuconf.RevConfAddDto;
import pwc.taxtech.atms.dto.revenuconf.RevenueConfParam;
import pwc.taxtech.atms.dto.revenuconf.RevenueConfResult;
import pwc.taxtech.atms.service.impl.RevenueConfService;
import pwc.taxtech.atms.vat.entity.RevenueConfig;

import javax.annotation.Resource;

@RestController
@RequestMapping(value = "api/v1/revenueConf")
public class RevenueConfController extends BaseController {

    @Resource
    private RevenueConfService revenueConfService;

    @PostMapping("queryPage")
    public CamelPagingResultDto<RevenueConfResult> queryPage(@RequestBody RevenueConfParam param) {
        return new CamelPagingResultDto<>(revenueConfService.queryPage(param));
    }

    @PostMapping("add")
    public ApiResultDto addConf(@RequestBody RevConfAddDto addDto) {
        revenueConfService.addConfig(addDto);
        return ApiResultDto.success();
    }

    @PostMapping("update")
    public ApiResultDto updateConf(@RequestBody RevenueConfig config) {
        revenueConfService.updateConfig(config);
        return ApiResultDto.success();
    }

}
