package pwc.taxtech.atms.dao;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.entity.EnterpriseAccountSetOrg;
import pwc.taxtech.atms.entity.EnterpriseAccountSetOrgExample;

import java.util.Date;
import java.util.List;
import java.util.Optional;

@Service
public class EnterpriseAccountSetOrgDao {
    @Autowired
    private EnterpriseAccountSetOrgMapper mapper;

    public List<EnterpriseAccountSetOrg> getByOrgIdAndAccountSetId(String orgId, String accountSetId) {
        EnterpriseAccountSetOrgExample example = new EnterpriseAccountSetOrgExample();
        EnterpriseAccountSetOrgExample.Criteria criteria = example.createCriteria();
        criteria.andOrganizationIdEqualTo(orgId);
        criteria.andEnterpriseAccountSetIdEqualTo(accountSetId);
        return mapper.selectByExample(example);
    }

    /**
     * 查询当前有效配置
     *
     * @param orgId orgId
     * @return Optional<EnterpriseAccountSetOrg>
     */
    public Optional<EnterpriseAccountSetOrg> getByOrganization(String orgId) {
        Date now = new Date();
        EnterpriseAccountSetOrgExample example = new EnterpriseAccountSetOrgExample();
        example.createCriteria().andOrganizationIdEqualTo(orgId).andEffectiveDateLessThanOrEqualTo(now)
                .andExpiredDateGreaterThan(now);
        return mapper.selectByExample(example).stream().findFirst();
    }
}
