package pwc.taxtech.atms.service;

import pwc.taxtech.atms.dto.ebsdto.*;

import java.util.List;

public interface EbsApiService {

    /**
     * EBS 日记账同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateJE(List<JournalEntryQueryDto> items);

    /**
     * ebs 科目余额表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateTB(List<TrialBalanceQueryDto> items);

    /**
     * ebs 现金流量表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateCF(List<CashFlowQueryDto> items);

    /**
     * ebs 资产负债表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateBS(List<BalanceSheetQueryDto> items);

    /**
     * ebs 资产负债表PRC同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateBSprc(List<BalanceSheetPrcQueryDto> items);

    /**
     * ebs 利润表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdatePL(List<ProfitLossStatementQueryDto> items);

    /**
     * ebs 利润表PRC同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdatePLprc(List<ProfitLossStatementPrcQueryDto> items);

    /**
     * ebs 汇率表同步更新
     *
     * @param items
     */
    void queryRemoteServerThenUpdateOAR(List<OrganizationAccountingRateQueryDto> items);
}
