package pwc.taxtech.atms.dao;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;

import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.entity.EnterpriseAccount;

@Mapper
public interface CustomAccountMapper extends MyMapper {

    @Select("SELECT ea.id,ea.code,ea.name,ea.parent_code,ea.full_name,"
            + "CASE WHEN am.standard_account_code=\"0000\" THEN am.standard_account_code ELSE sa.code END StdCode,"
            + "sa.name name,sa.parent_code StdParentCode "
            + "FROM (SELECT * FROM enterprise_account where parent_code=#{parentCode} and enterprise_account_set_id=#{accountSetId}) ea "
            + "LEFT JOIN (SELECT * FROM account_mapping WHERE organization_id=#{orgId} AND industry_id=#{industryId} AND enterprise_account_set_id=#{accountSetId}) am ON ea.code=am.enterprise_account_code "
            + "LEFT JOIN (SELECT * FROM standard_account WHERE industry_id=#{industryId}) sa ON am.standard_account_code=sa.code "
            + "ORDER BY ea.code")
    @Results({
        @Result(id = true, column = "id", property = "id"),
        @Result(column = "code", property = "code"),
        @Result(column = "name", property = "name"),
        @Result(column = "parent_code", property = "parentCode"),
        @Result(column = "full_name", property = "fullName"),
        @Result(column = "StdCode", property = "stdCode"),
        @Result(column = "StdName", property = "stdName")
        //@Result(column = "StdParentCode", property = "stdParentCode")
    })
    List<EnterpriseAccount> getMappingResult(@Param(value="accountSetId") String accountSetId,
            @Param(value="industryId") String industryId, @Param(value="orgId") String orgId,
            @Param(value="parentCode") String parentCode);
    
    
    
    @Select("SELECT COUNT(1) FROM account_mapping "
            + "WHERE enterprise_account_code=#{enterpirseAccountCode} "
            + "AND enterprise_account_set_id=#{enterpriseAccountSetId} "
            + "AND organization_id=#{organizationId} "
            + "AND industry_id=#{organizationId} "
            + "AND standard_account_code<>\"0000\"")
    Long countStandardAccounts(@Param(value="enterpriseAccountSetId") String enterpriseAccountSetId,
            @Param(value="enterpirseAccountCode") String enterpirseAccountCode, 
            @Param(value="industryId") String industryId,
            @Param(value="organizationId") String organizationId);
}
