package pwc.taxtech.atms.dao;

import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.session.RowBounds;
import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.dpo.RoleInfo;
import pwc.taxtech.atms.dpo.UserDto;
import pwc.taxtech.atms.dpo.UserOrgRoleDto;
import pwc.taxtech.atms.entity.User;
import pwc.taxtech.atms.entity.UserExample;

@Mapper
public interface UserMapper extends MyMapper {
    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    long countByExample(UserExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int deleteByExample(UserExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int deleteByPrimaryKey(String id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int insert(User record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int insertSelective(User record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    List<User> selectByExampleWithRowbounds(UserExample example, RowBounds rowBounds);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    List<User> selectByExample(UserExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    User selectByPrimaryKey(String id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int updateByExampleSelective(@Param("record") User record, @Param("example") UserExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int updateByExample(@Param("record") User record, @Param("example") UserExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int updateByPrimaryKeySelective(User record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table user
     *
     * @mbg.generated
     */
    int updateByPrimaryKey(User record);

    /**
     * select one user record by user name
     */
    User selectByUserName(String userName);

    /**
     * select one user record by user name with ingore case
     */
    User selectByUserNameIgnoreCase(String userName);

    /**
     * select one user record by user name with ingore case and different user id
     */
    User selectUserWithSameUserName(UserDto userDto);

    /**
     * select one user record by email with ingore case and different user id
     */
    User selectUserWithSameEmail(UserDto userDto);

    /**
     * select one user record by email with ingore case
     */
    User selectByEmailIgnoreCase(String email);

    /**
     * select one user record with its related organization information by user id
     */
    @Select("select u.user_name as userName, o.id as organizationId, o.name as organizationName, "
            + "u.email as email, u.status as status, u.attempt_times as attemptTimes, u.create_time as createTime, "
            + "u.expiration_date as expirationDate, u.is_admin as isAdmin, u.id as id, u.locked_time as lockedTime, "
            + "u.login_type as loginType, u.password as password, u.password_update_time as passwordUpdateTime, u.update_time as updateTime from user u "
            + "left join organization o on u.organization_id = o.id "
            + "where u.id = #{userId}")
    List<UserDto> selectUserWithOrgInfoById(@Param(value = "userId") String userId);

    @Select("select R.id AS id, R.name AS name FROM user_role U "
            + "JOIN role R ON U.role_id = R.id "
            + "WHERE U.user_id = #{userId}")
    List<RoleInfo> selectUserRoleInfoById(@Param(value = "userId") String userId);

    @Select("select udv.role_id as roleID, r.name as roleName, udv.user_dimension_value_id as id "
            + "FROM user_dimension_value_role udv "
            + "JOIN role r ON udv.role_id = r.ID")
    List<UserOrgRoleDto> selectUserDimensionValueRole();

    @Select("select q.role_id as roleID, r.name as roleName, q.user_organization_id as id "
            + "from user_organization_role q "
            + "join role r on q.role_id = r.id")
    List<UserOrgRoleDto> selectUserOrganizationRole();
}