package pwc.taxtech.atms.dpo;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.Date;
import java.util.List;


public class OrganizationDto {
    //@JsonProperty("ID")
    private String id;
    private String clientCode;
    private String name;
    private String englishName;
    private String abbreviation;
    private String code;
    private String invoiceType;
    @JsonProperty("parentID")
    private String parentId;
    private String taxPayerNumber;
    @JsonProperty("regionID")
    private String regionId; // City
    @JsonProperty("parentRegionID")
    private String parentRegionId; // Province
    @JsonProperty("structureID")
    private String structureId;
    @JsonProperty("industryID")
    private String industryId;
    public Date createTime;
    public Date updateTime;
    private String parentName;
    private String areaName;
    @JsonProperty("areaID")
    private String areaId;
    @JsonProperty("businessUnitID")
    private String businessUnitId;
    public List<OrganizationDto> subOrgs;
    // for cargill
    private String legalPersonName;
    private String manufactureAddress;
    private String registerAddress;
    private String bankAccountName;
    private String bankAccountNumber;
    private String phoneNumber;
    private String registrationType;
    private String structureName;
    private String regionName;
    private String industryName;
    private String businessUnitName;
    @JsonProperty("dimensionID")
    private String dimensionId;
    private String dimensionName;
    private String dimensionValueName;
    @JsonProperty("dimensionValueID")
    private String dimensionValueId;
    @JsonProperty("attributeID")
    private String attributeId;
    private String attributeName;
    public Boolean isSystemDimension;
    // 用于UI GRId Tree Level
    public Integer level;
    // 用于机构层级本身的上下级
    public Integer pLevel;
    private String remark;

    private Boolean isActive;

    private String vehicleRoutingLocation;

    private String ratepayer;

    private String address;

    private Date foundationDate;

    private Date registrationDate;

    private String registrationLocation;

    private String registrationCapital;

    private Date businessAllottedTimeFrom;

    private Date businessAllottedTimeTo;

    private String legalCode;

    private String vehicleroutinglocation;

    private String businessScope;

    private String architectureType;

    private String nationalEconomicIndustry;

    private Boolean engageNationalProhibitIndustry;

    private Integer numOfBranches;

    private Boolean apiUpdateFlag;

    private Date effecTimeOfGeneralTaxpayers;

    private String registrationLocationEn;

    private String paidInCapital;

    private Date generalTaxPayerEffectiveTime;

    private String actualBusinessAddress;

    private String regStatus;

    private Date logoutTime;

    private Boolean oversea;

    public List<EnterpriseAccountSetOrgDto> enterpriseAccountSetOrgList;
    public List<OrganizationServiceTemplateGroupDto> organizationServiceTemplateGroupList;
    public List<DimensionValueOrgDto> dimensionValueOrgList;
    public List<UserRoleInfo> userRoleList;
    public List<OrganizationDto> sameVehicleroutinglocationList;
    public List<TaxControlDiskDto> taxControlDiskList;

    public String getId() {
        return this.id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getClientCode() {
        return clientCode;
    }

    public void setClientCode(String clientCode) {
        this.clientCode = clientCode;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    public String getAbbreviation() {
        return abbreviation;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(String invoiceType) {
        this.invoiceType = invoiceType;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getTaxPayerNumber() {
        return taxPayerNumber;
    }

    public void setTaxPayerNumber(String taxPayerNumber) {
        this.taxPayerNumber = taxPayerNumber;
    }

    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getParentRegionId() {
        return parentRegionId;
    }

    public void setParentRegionId(String parentRegionId) {
        this.parentRegionId = parentRegionId;
    }

    public String getStructureId() {
        return structureId;
    }

    public void setStructureId(String structureId) {
        this.structureId = structureId;
    }

    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public String getAreaName() {
        return areaName;
    }

    public void setAreaName(String areaName) {
        this.areaName = areaName;
    }

    public String getAreaId() {
        return areaId;
    }

    public void setAreaId(String areaId) {
        this.areaId = areaId;
    }

    public String getBusinessUnitId() {
        return businessUnitId;
    }

    public void setBusinessUnitId(String businessUnitId) {
        this.businessUnitId = businessUnitId;
    }

    public List<OrganizationDto> getSubOrgs() {
        return subOrgs;
    }

    public void setSubOrgs(List<OrganizationDto> subOrgs) {
        this.subOrgs = subOrgs;
    }

    public String getLegalPersonName() {
        return legalPersonName;
    }

    public void setLegalPersonName(String legalPersonName) {
        this.legalPersonName = legalPersonName;
    }

    public String getRegStatus() {
        return regStatus;
    }

    public void setRegStatus(String regStatus) {
        this.regStatus = regStatus;
    }

    public Date getLogoutTime() {
        return logoutTime;
    }

    public void setLogoutTime(Date logoutTime) {
        this.logoutTime = logoutTime;
    }

    public String getManufactureAddress() {
        return manufactureAddress;
    }

    public void setManufactureAddress(String manufactureAddress) {
        this.manufactureAddress = manufactureAddress;
    }

    public String getRegisterAddress() {
        return registerAddress;
    }

    public void setRegisterAddress(String registerAddress) {
        this.registerAddress = registerAddress;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNumber() {
        return bankAccountNumber;
    }

    public void setBankAccountNumber(String bankAccountNumber) {
        this.bankAccountNumber = bankAccountNumber;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public String getRegistrationType() {
        return registrationType;
    }

    public void setRegistrationType(String registrationType) {
        this.registrationType = registrationType;
    }

    public String getStructureName() {
        return structureName;
    }

    public void setStructureName(String structureName) {
        this.structureName = structureName;
    }

    public String getRegionName() {
        return regionName;
    }

    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }

    public String getIndustryName() {
        return industryName;
    }

    public void setIndustryName(String industryName) {
        this.industryName = industryName;
    }

    public String getBusinessUnitName() {
        return businessUnitName;
    }

    public void setBusinessUnitName(String businessUnitName) {
        this.businessUnitName = businessUnitName;
    }

    public String getDimensionId() {
        return dimensionId;
    }

    public void setDimensionId(String dimensionId) {
        this.dimensionId = dimensionId;
    }

    public String getDimensionName() {
        return dimensionName;
    }

    public void setDimensionName(String dimensionName) {
        this.dimensionName = dimensionName;
    }

    public String getDimensionValueName() {
        return dimensionValueName;
    }

    public void setDimensionValueName(String dimensionValueName) {
        this.dimensionValueName = dimensionValueName;
    }

    public String getDimensionValueId() {
        return dimensionValueId;
    }

    public void setDimensionValueId(String dimensionValueId) {
        this.dimensionValueId = dimensionValueId;
    }

    public String getAttributeId() {
        return attributeId;
    }

    public void setAttributeId(String attributeId) {
        this.attributeId = attributeId;
    }

    public String getAttributeName() {
        return attributeName;
    }

    public void setAttributeName(String attributeName) {
        this.attributeName = attributeName;
    }

    public Boolean getIsSystemDimension() {
        return isSystemDimension;
    }

    public void setIsSystemDimension(Boolean isSystemDimension) {
        this.isSystemDimension = isSystemDimension;
    }

    public Integer getLevel() {
        return level;
    }

    public void setLevel(Integer level) {
        this.level = level;
    }

    public Integer getpLevel() {
        return pLevel;
    }

    public void setpLevel(Integer pLevel) {
        this.pLevel = pLevel;
    }

    public Integer getPLevel() {
        return pLevel;
    }

    public void setPLevel(Integer pLevel) {
        this.pLevel = pLevel;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getVehicleRoutingLocation() {
        return vehicleRoutingLocation;
    }

    public void setVehicleRoutingLocation(String vehicleRoutingLocation) {
        this.vehicleRoutingLocation = vehicleRoutingLocation;
    }

    public String getRatepayer() {
        return ratepayer;
    }

    public void setRatepayer(String ratepayer) {
        this.ratepayer = ratepayer;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public Date getFoundationDate() {
        return foundationDate;
    }

    public void setFoundationDate(Date foundationDate) {
        this.foundationDate = foundationDate;
    }

    public Date getRegistrationDate() {
        return registrationDate;
    }

    public void setRegistrationDate(Date registrationDate) {
        this.registrationDate = registrationDate;
    }

    public String getRegistrationLocation() {
        return registrationLocation;
    }

    public void setRegistrationLocation(String registrationLocation) {
        this.registrationLocation = registrationLocation;
    }

    public String getRegistrationCapital() {
        return registrationCapital;
    }

    public void setRegistrationCapital(String registrationCapital) {
        this.registrationCapital = registrationCapital;
    }

    public Date getBusinessAllottedTimeFrom() {
        return businessAllottedTimeFrom;
    }

    public void setBusinessAllottedTimeFrom(Date businessAllottedTimeFrom) {
        this.businessAllottedTimeFrom = businessAllottedTimeFrom;
    }

    public Date getBusinessAllottedTimeTo() {
        return businessAllottedTimeTo;
    }

    public void setBusinessAllottedTimeTo(Date businessAllottedTimeTo) {
        this.businessAllottedTimeTo = businessAllottedTimeTo;
    }

    public String getLegalCode() {
        return legalCode;
    }

    public void setLegalCode(String legalCode) {
        this.legalCode = legalCode;
    }

    public String getVehicleroutinglocation() {
        return vehicleroutinglocation;
    }

    public void setVehicleroutinglocation(String vehicleroutinglocation) {
        this.vehicleroutinglocation = vehicleroutinglocation;
    }

    public String getBusinessScope() {
        return businessScope;
    }

    public void setBusinessScope(String businessScope) {
        this.businessScope = businessScope;
    }

    public String getArchitectureType() {
        return architectureType;
    }

    public void setArchitectureType(String architectureType) {
        this.architectureType = architectureType;
    }

    public String getNationalEconomicIndustry() {
        return nationalEconomicIndustry;
    }

    public void setNationalEconomicIndustry(String nationalEconomicIndustry) {
        this.nationalEconomicIndustry = nationalEconomicIndustry;
    }

    public Boolean getEngageNationalProhibitIndustry() {
        return engageNationalProhibitIndustry;
    }

    public void setEngageNationalProhibitIndustry(Boolean engageNationalProhibitIndustry) {
        this.engageNationalProhibitIndustry = engageNationalProhibitIndustry;
    }

    public Integer getNumOfBranches() {
        return numOfBranches;
    }

    public void setNumOfBranches(Integer numOfBranches) {
        this.numOfBranches = numOfBranches;
    }

    public Boolean getApiUpdateFlag() {
        return apiUpdateFlag;
    }

    public void setApiUpdateFlag(Boolean apiUpdateFlag) {
        this.apiUpdateFlag = apiUpdateFlag;
    }

    public Date getEffecTimeOfGeneralTaxpayers() {
        return effecTimeOfGeneralTaxpayers;
    }

    public void setEffecTimeOfGeneralTaxpayers(Date effecTimeOfGeneralTaxpayers) {
        this.effecTimeOfGeneralTaxpayers = effecTimeOfGeneralTaxpayers;
    }

    public String getRegistrationLocationEn() {
        return registrationLocationEn;
    }

    public void setRegistrationLocationEn(String registrationLocationEn) {
        this.registrationLocationEn = registrationLocationEn;
    }

    public String getPaidInCapital() {
        return paidInCapital;
    }

    public void setPaidInCapital(String paidInCapital) {
        this.paidInCapital = paidInCapital;
    }

    public Date getGeneralTaxPayerEffectiveTime() {
        return generalTaxPayerEffectiveTime;
    }

    public void setGeneralTaxPayerEffectiveTime(Date generalTaxPayerEffectiveTime) {
        this.generalTaxPayerEffectiveTime = generalTaxPayerEffectiveTime;
    }

    public String getActualBusinessAddress() {
        return actualBusinessAddress;
    }

    public void setActualBusinessAddress(String actualBusinessAddress) {
        this.actualBusinessAddress = actualBusinessAddress;
    }

    public Boolean getOversea() {
        if(null == oversea){
            return false;
        }
        return oversea;
    }

    public void setOversea(Boolean oversea) {
        this.oversea = oversea;
    }

    public List<EnterpriseAccountSetOrgDto> getEnterpriseAccountSetOrgList() {
        return enterpriseAccountSetOrgList;
    }

    public void setEnterpriseAccountSetOrgList(List<EnterpriseAccountSetOrgDto> enterpriseAccountSetOrgList) {
        this.enterpriseAccountSetOrgList = enterpriseAccountSetOrgList;
    }

    public List<OrganizationServiceTemplateGroupDto> getOrganizationServiceTemplateGroupList() {
        return organizationServiceTemplateGroupList;
    }

    public void setOrganizationServiceTemplateGroupList(List<OrganizationServiceTemplateGroupDto> organizationServiceTemplateGroupList) {
        this.organizationServiceTemplateGroupList = organizationServiceTemplateGroupList;
    }

    public List<DimensionValueOrgDto> getDimensionValueOrgList() {
        return dimensionValueOrgList;
    }

    public void setDimensionValueOrgList(List<DimensionValueOrgDto> dimensionValueOrgList) {
        this.dimensionValueOrgList = dimensionValueOrgList;
    }

    public List<UserRoleInfo> getUserRoleList() {
        return userRoleList;
    }

    public void setUserRoleList(List<UserRoleInfo> userRoleList) {
        this.userRoleList = userRoleList;
    }

    public List<OrganizationDto> getSameVehicleroutinglocationList() {
        return sameVehicleroutinglocationList;
    }

    public void setSameVehicleroutinglocationList(List<OrganizationDto> sameVehicleroutinglocationList) {
        this.sameVehicleroutinglocationList = sameVehicleroutinglocationList;
    }

    public List<TaxControlDiskDto> getTaxControlDiskList() {
        return taxControlDiskList;
    }

    public void setTaxControlDiskList(List<TaxControlDiskDto> taxControlDiskList) {
        this.taxControlDiskList = taxControlDiskList;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        result = prime * result + ((abbreviation == null) ? 0 : abbreviation.hashCode());
        result = prime * result + ((areaId == null) ? 0 : areaId.hashCode());
        result = prime * result + ((areaName == null) ? 0 : areaName.hashCode());
        result = prime * result + ((attributeId == null) ? 0 : attributeId.hashCode());
        result = prime * result + ((attributeName == null) ? 0 : attributeName.hashCode());
        result = prime * result + ((bankAccountName == null) ? 0 : bankAccountName.hashCode());
        result = prime * result + ((bankAccountNumber == null) ? 0 : bankAccountNumber.hashCode());
        result = prime * result + ((businessUnitId == null) ? 0 : businessUnitId.hashCode());
        result = prime * result + ((businessUnitName == null) ? 0 : businessUnitName.hashCode());
        result = prime * result + ((clientCode == null) ? 0 : clientCode.hashCode());
        result = prime * result + ((code == null) ? 0 : code.hashCode());
        result = prime * result + ((createTime == null) ? 0 : createTime.hashCode());
        result = prime * result + ((dimensionId == null) ? 0 : dimensionId.hashCode());
        result = prime * result + ((dimensionName == null) ? 0 : dimensionName.hashCode());
        result = prime * result + ((dimensionValueId == null) ? 0 : dimensionValueId.hashCode());
        result = prime * result + ((dimensionValueName == null) ? 0 : dimensionValueName.hashCode());
        result = prime * result + ((dimensionValueOrgList == null) ? 0 : dimensionValueOrgList.hashCode());
        result = prime * result + ((englishName == null) ? 0 : englishName.hashCode());
        result = prime * result + ((enterpriseAccountSetOrgList == null) ? 0 : enterpriseAccountSetOrgList.hashCode());
        result = prime * result + ((industryId == null) ? 0 : industryId.hashCode());
        result = prime * result + ((industryName == null) ? 0 : industryName.hashCode());
        result = prime * result + ((invoiceType == null) ? 0 : invoiceType.hashCode());
        result = prime * result + ((isActive == null) ? 0 : isActive.hashCode());
        result = prime * result + ((isSystemDimension == null) ? 0 : isSystemDimension.hashCode());
        result = prime * result + ((legalPersonName == null) ? 0 : legalPersonName.hashCode());
        result = prime * result + ((level == null) ? 0 : level.hashCode());
        result = prime * result + ((manufactureAddress == null) ? 0 : manufactureAddress.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((organizationServiceTemplateGroupList == null) ? 0
                : organizationServiceTemplateGroupList.hashCode());
        result = prime * result + ((pLevel == null) ? 0 : pLevel.hashCode());
        result = prime * result + ((parentId == null) ? 0 : parentId.hashCode());
        result = prime * result + ((parentName == null) ? 0 : parentName.hashCode());
        result = prime * result + ((parentRegionId == null) ? 0 : parentRegionId.hashCode());
        result = prime * result + ((phoneNumber == null) ? 0 : phoneNumber.hashCode());
        result = prime * result + ((regionId == null) ? 0 : regionId.hashCode());
        result = prime * result + ((regionName == null) ? 0 : regionName.hashCode());
        result = prime * result + ((registerAddress == null) ? 0 : registerAddress.hashCode());
        result = prime * result + ((registrationType == null) ? 0 : registrationType.hashCode());
        result = prime * result + ((remark == null) ? 0 : remark.hashCode());
        result = prime * result
                + ((sameVehicleroutinglocationList == null) ? 0 : sameVehicleroutinglocationList.hashCode());
        result = prime * result + ((structureId == null) ? 0 : structureId.hashCode());
        result = prime * result + ((structureName == null) ? 0 : structureName.hashCode());
        result = prime * result + ((subOrgs == null) ? 0 : subOrgs.hashCode());
        result = prime * result + ((taxControlDiskList == null) ? 0 : taxControlDiskList.hashCode());
        result = prime * result + ((taxPayerNumber == null) ? 0 : taxPayerNumber.hashCode());
        result = prime * result + ((updateTime == null) ? 0 : updateTime.hashCode());
        result = prime * result + ((userRoleList == null) ? 0 : userRoleList.hashCode());
        result = prime * result + ((vehicleroutinglocation == null) ? 0 : vehicleroutinglocation.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        OrganizationDto other = (OrganizationDto) obj;
        if (id == null) {
            if (other.id != null)
                return false;
        } else if (!id.equals(other.id))
            return false;
        if (abbreviation == null) {
            if (other.abbreviation != null)
                return false;
        } else if (!abbreviation.equals(other.abbreviation))
            return false;
        if (areaId == null) {
            if (other.areaId != null)
                return false;
        } else if (!areaId.equals(other.areaId))
            return false;
        if (areaName == null) {
            if (other.areaName != null)
                return false;
        } else if (!areaName.equals(other.areaName))
            return false;
        if (attributeId == null) {
            if (other.attributeId != null)
                return false;
        } else if (!attributeId.equals(other.attributeId))
            return false;
        if (attributeName == null) {
            if (other.attributeName != null)
                return false;
        } else if (!attributeName.equals(other.attributeName))
            return false;
        if (bankAccountName == null) {
            if (other.bankAccountName != null)
                return false;
        } else if (!bankAccountName.equals(other.bankAccountName))
            return false;
        if (bankAccountNumber == null) {
            if (other.bankAccountNumber != null)
                return false;
        } else if (!bankAccountNumber.equals(other.bankAccountNumber))
            return false;
        if (businessUnitId == null) {
            if (other.businessUnitId != null)
                return false;
        } else if (!businessUnitId.equals(other.businessUnitId))
            return false;
        if (businessUnitName == null) {
            if (other.businessUnitName != null)
                return false;
        } else if (!businessUnitName.equals(other.businessUnitName))
            return false;
        if (clientCode == null) {
            if (other.clientCode != null)
                return false;
        } else if (!clientCode.equals(other.clientCode))
            return false;
        if (code == null) {
            if (other.code != null)
                return false;
        } else if (!code.equals(other.code))
            return false;
        if (createTime == null) {
            if (other.createTime != null)
                return false;
        } else if (!createTime.equals(other.createTime))
            return false;
        if (dimensionId == null) {
            if (other.dimensionId != null)
                return false;
        } else if (!dimensionId.equals(other.dimensionId))
            return false;
        if (dimensionName == null) {
            if (other.dimensionName != null)
                return false;
        } else if (!dimensionName.equals(other.dimensionName))
            return false;
        if (dimensionValueId == null) {
            if (other.dimensionValueId != null)
                return false;
        } else if (!dimensionValueId.equals(other.dimensionValueId))
            return false;
        if (dimensionValueName == null) {
            if (other.dimensionValueName != null)
                return false;
        } else if (!dimensionValueName.equals(other.dimensionValueName))
            return false;
        if (dimensionValueOrgList == null) {
            if (other.dimensionValueOrgList != null)
                return false;
        } else if (!dimensionValueOrgList.equals(other.dimensionValueOrgList))
            return false;
        if (englishName == null) {
            if (other.englishName != null)
                return false;
        } else if (!englishName.equals(other.englishName))
            return false;
        if (enterpriseAccountSetOrgList == null) {
            if (other.enterpriseAccountSetOrgList != null)
                return false;
        } else if (!enterpriseAccountSetOrgList.equals(other.enterpriseAccountSetOrgList))
            return false;
        if (industryId == null) {
            if (other.industryId != null)
                return false;
        } else if (!industryId.equals(other.industryId))
            return false;
        if (industryName == null) {
            if (other.industryName != null)
                return false;
        } else if (!industryName.equals(other.industryName))
            return false;
        if (invoiceType == null) {
            if (other.invoiceType != null)
                return false;
        } else if (!invoiceType.equals(other.invoiceType))
            return false;
        if (isActive == null) {
            if (other.isActive != null)
                return false;
        } else if (!isActive.equals(other.isActive))
            return false;
        if (isSystemDimension == null) {
            if (other.isSystemDimension != null)
                return false;
        } else if (!isSystemDimension.equals(other.isSystemDimension))
            return false;
        if (legalPersonName == null) {
            if (other.legalPersonName != null)
                return false;
        } else if (!legalPersonName.equals(other.legalPersonName))
            return false;
        if (level == null) {
            if (other.level != null)
                return false;
        } else if (!level.equals(other.level))
            return false;
        if (manufactureAddress == null) {
            if (other.manufactureAddress != null)
                return false;
        } else if (!manufactureAddress.equals(other.manufactureAddress))
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        } else if (!name.equals(other.name))
            return false;
        if (organizationServiceTemplateGroupList == null) {
            if (other.organizationServiceTemplateGroupList != null)
                return false;
        } else if (!organizationServiceTemplateGroupList.equals(other.organizationServiceTemplateGroupList))
            return false;
        if (pLevel == null) {
            if (other.pLevel != null)
                return false;
        } else if (!pLevel.equals(other.pLevel))
            return false;
        if (parentId == null) {
            if (other.parentId != null)
                return false;
        } else if (!parentId.equals(other.parentId))
            return false;
        if (parentName == null) {
            if (other.parentName != null)
                return false;
        } else if (!parentName.equals(other.parentName))
            return false;
        if (parentRegionId == null) {
            if (other.parentRegionId != null)
                return false;
        } else if (!parentRegionId.equals(other.parentRegionId))
            return false;
        if (phoneNumber == null) {
            if (other.phoneNumber != null)
                return false;
        } else if (!phoneNumber.equals(other.phoneNumber))
            return false;
        if (regionId == null) {
            if (other.regionId != null)
                return false;
        } else if (!regionId.equals(other.regionId))
            return false;
        if (regionName == null) {
            if (other.regionName != null)
                return false;
        } else if (!regionName.equals(other.regionName))
            return false;
        if (registerAddress == null) {
            if (other.registerAddress != null)
                return false;
        } else if (!registerAddress.equals(other.registerAddress))
            return false;
        if (registrationType == null) {
            if (other.registrationType != null)
                return false;
        } else if (!registrationType.equals(other.registrationType))
            return false;
        if (remark == null) {
            if (other.remark != null)
                return false;
        } else if (!remark.equals(other.remark))
            return false;
        if (sameVehicleroutinglocationList == null) {
            if (other.sameVehicleroutinglocationList != null)
                return false;
        } else if (!sameVehicleroutinglocationList.equals(other.sameVehicleroutinglocationList))
            return false;
        if (structureId == null) {
            if (other.structureId != null)
                return false;
        } else if (!structureId.equals(other.structureId))
            return false;
        if (structureName == null) {
            if (other.structureName != null)
                return false;
        } else if (!structureName.equals(other.structureName))
            return false;
        if (subOrgs == null) {
            if (other.subOrgs != null)
                return false;
        } else if (!subOrgs.equals(other.subOrgs))
            return false;
        if (taxControlDiskList == null) {
            if (other.taxControlDiskList != null)
                return false;
        } else if (!taxControlDiskList.equals(other.taxControlDiskList))
            return false;
        if (taxPayerNumber == null) {
            if (other.taxPayerNumber != null)
                return false;
        } else if (!taxPayerNumber.equals(other.taxPayerNumber))
            return false;
        if (updateTime == null) {
            if (other.updateTime != null)
                return false;
        } else if (!updateTime.equals(other.updateTime))
            return false;
        if (userRoleList == null) {
            if (other.userRoleList != null)
                return false;
        } else if (!userRoleList.equals(other.userRoleList))
            return false;
        if (vehicleroutinglocation == null) {
            if (other.vehicleroutinglocation != null)
                return false;
        } else if (!vehicleroutinglocation.equals(other.vehicleroutinglocation))
            return false;
        return true;
    }
}
