package pwc.taxtech.atms.vat.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.session.RowBounds;
import org.springframework.stereotype.Repository;
import pwc.taxtech.atms.MyVatMapper;
import pwc.taxtech.atms.vat.dpo.OutputInvoiceDataSourceDto;
import pwc.taxtech.atms.vat.dpo.OutputVATInvoiceDto;
import pwc.taxtech.atms.vat.dpo.OutputVATInvoiceInfoDto;
import pwc.taxtech.atms.vat.dpo.QueryOutputDto;
import pwc.taxtech.atms.vat.entity.OutputVatInvoice;
import pwc.taxtech.atms.vat.entity.OutputVatInvoiceExample;

import java.util.List;

@Mapper
@Repository
public interface OutputVatInvoiceMapper extends MyVatMapper {
    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    long countByExample(OutputVatInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int deleteByExample(OutputVatInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int deleteByPrimaryKey(String invoiceId);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int insert(OutputVatInvoice record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int insertSelective(OutputVatInvoice record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    List<OutputVatInvoice> selectByExampleWithRowbounds(OutputVatInvoiceExample example, RowBounds rowBounds);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    List<OutputVatInvoice> selectByExample(OutputVatInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    OutputVatInvoice selectByPrimaryKey(String invoiceId);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int updateByExampleSelective(@Param("record") OutputVatInvoice record, @Param("example") OutputVatInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int updateByExample(@Param("record") OutputVatInvoice record, @Param("example") OutputVatInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int updateByPrimaryKeySelective(OutputVatInvoice record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. OUTPUT_VAT_INVOICE
     *
     * @mbg.generated
     */
    int updateByPrimaryKey(OutputVatInvoice record);

    List<OutputVATInvoiceInfoDto> selectOutputVATInvoiceInfoLeftJoinItem(@Param("queryDto") QueryOutputDto queryDto);

    @Select("SELECT  " +
            "    o.period_id as periodId, " +
            "    o.invoice_type as invoiceType, " +
            "    o.class_code as classCode, " +
            "    o.invoice_number as invoiceNumber, " +
            "    o.buyer_name as buyerName, " +
            "    o.buyer_tax_number as buyerTaxNumber, " +
            "    o.bank_account as bankAccount, " +
            "    o.phone_num as phoneNum, " +
            "    o.invoice_date as invoiceDate, " +
            "    oi.code_version as codeVersion, " +
            "    oi.product_name as productName, " +
            "    oi.document_num as documentNum, " +
            "    oi.product_standard as productStandard, " +
            "    oi.unit as unit, " +
            "    oi.quantity as quantity, " +
            "    oi.unit_price as unitPrice, " +
            "    oi.amount as amount, " +
            "    oi.tax_rate as taxRate, " +
            "    oi.tax_amount as taxAmount, " +
            "    oi.tax_class_code  as taxClassCode " +
            "FROM " +
            "    output_vat_invoice o, " +
            "    output_vat_invoice_item oi, " +
            "    (SELECT  " +
            "        invoice_id as INVOICE_ID, MIN(seq_no) MIN_SEQ_NO " +
            "    FROM " +
            "        output_vat_invoice_item " +
            "    GROUP BY invoice_id) m " +
            "WHERE " +
            "    o.invoice_id = oi.invoice_id " +
            "        AND o.invoice_id = m.INVOICE_ID " +
            "        AND oi.SEQ_NO = m.MIN_SEQ_NO  " +
            "        AND o.period_id = #{period}" +
            " UNION SELECT  " +
            "    o2.period_id as periodID, " +
            "    NULL AS invoiceType, " +
            "    \"\" AS classCode, " +
            "    \"\" AS invoiceNumber, " +
            "    \"\" AS buyerName, " +
            "    \"\" AS buyerTaxNumber, " +
            "    \"\" AS bankAccount, " +
            "    \"\" AS phoneNum, " +
            "    NULL AS invoiceDate, " +
            "    oi2.code_version as codeVersion, " +
            "    oi2.product_name as productName, " +
            "    oi2.document_num as documentNum, " +
            "    oi2.product_standard as productStandard, " +
            "    oi2.unit as unit, " +
            "    oi2.quantity as quantity, " +
            "    oi2.unit_price as unitPrice, " +
            "    oi2.amount as amount, " +
            "    oi2.tax_rate as amount, " +
            "    oi2.tax_amount as taxAmount, " +
            "    oi2.tax_class_code as taxClassCode" +
            "FROM " +
            "    output_vat_invoice o2, " +
            "    output_vat_invoice_item oi2, " +
            "    (SELECT  " +
            "        invoice_id as INVOICE_ID, MIN(seq_no) MIN_SEQ_NO " +
            "    FROM " +
            "        output_vat_invoice_item " +
            "    GROUP BY invoice_id) m2 " +
            "WHERE " +
            "    o2.invoice_id = oi2.invoice_id " +
            "        AND o2.invoice_id = m2.INVOICE_ID " +
            "        AND oi2.seq_no != m2.MIN_SEQ_NO " +
            "        AND o2.period_id = #{period}" +
            " ")
    List<OutputVATInvoiceInfoDto> queryOutputDetailWithItem(Integer period);

    List<OutputVATInvoiceDto> getVatInvoiceWithItems(@Param("dbName") String dbName);

    List<OutputInvoiceDataSourceDto> selectOutputInvoiceAndItem();
}