package pwc.taxtech.atms.vat.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.session.RowBounds;
import pwc.taxtech.atms.MyVatMapper;
import pwc.taxtech.atms.vat.dpo.VoucherAccountMto;
import pwc.taxtech.atms.vat.dpo.VoucherBalanceDto;
import pwc.taxtech.atms.vat.entity.ValidationInfo;
import pwc.taxtech.atms.vat.entity.ValidationInfoExample;

import java.util.List;

@Mapper
public interface ValidationInfoMapper extends MyVatMapper {
    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    long countByExample(ValidationInfoExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int deleteByExample(ValidationInfoExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int deleteByPrimaryKey(String id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int insert(ValidationInfo record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int insertSelective(ValidationInfo record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    List<ValidationInfo> selectByExampleWithRowbounds(ValidationInfoExample example, RowBounds rowBounds);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    List<ValidationInfo> selectByExample(ValidationInfoExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    ValidationInfo selectByPrimaryKey(String id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int updateByExampleSelective(@Param("record") ValidationInfo record, @Param("example") ValidationInfoExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int updateByExample(@Param("record") ValidationInfo record, @Param("example") ValidationInfoExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int updateByPrimaryKeySelective(ValidationInfo record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_PROJECT. VALIDATION_INFO
     *
     * @mbg.generated
     */
    int updateByPrimaryKey(ValidationInfo record);

    @Select("SELECT  " +
            "    c.ACCT_CODE as AccountCode, COUNT(1) as Count " +
            "FROM " +
            "    COMPANY_BALANCE c " +
            "        LEFT JOIN " +
            "    ENTERPRISE_ACCOUNT a ON c.ACCT_CODE = a.ACCT_CODE " +
            "WHERE " +
            "    a.IS_DUMMY != 1 " +
            "        AND (c.ACCT_CODE != '' AND c.ACCT_CODE != NULL) " +
            "GROUP BY c.ACCT_CODE")
    List<VoucherAccountMto> getCompanyBalanceAcctChecks();

    @Select("SELECT  " +
            "    c.ACCT_CODE as AccountCode, COUNT(1) as Count " +
            "FROM " +
            "    VOUCHER c " +
            "        LEFT JOIN " +
            "    ENTERPRISE_ACCOUNT a ON c.ACCT_CODE = a.AcctCode " +
            "WHERE " +
            "    a.IS_DUMMY != 1 " +
            "        AND (c.ACCT_CODE != '' AND c.ACCT_CODE != NULL) " +
            "GROUP BY c.ACCT_CODE")
    List<VoucherAccountMto> getVoucherAccountChecks();

    @Select("SELECT  " +
            "    VV.VID, " +
            "    VV.GROUP, " +
            "    VV.PERIOD, " +
            "    VV.CUSTOMER_CODE, " +
            "    VV.SUMMARY, " +
            "    VV.ACCT_CODE, " +
            "    VV.DEBIT, " +
            "    VV.CREDIT, " +
            "    VV.ITEMID " +
            "FROM " +
            "    VOUCHER VV " +
            "        JOIN " +
            "    (SELECT  " +
            "        V.VID, " +
            "            V.PERIOD, " +
            "            V.GROUP, " +
            "            MAX(V.DATE) AS `DATE`, " +
            "            SUM(V.DEBIT) AS DEBIT, " +
            "            SUM(V.CREDIT) AS CREDIT " +
            "    FROM " +
            "        VOUCHER V " +
            "    GROUP BY V.VID , V.PERIOD , V.GROUP " +
            "    HAVING DEBIT != CREDIT) Q ON VV.VID = Q.VID AND VV.PERIOD = Q.PERIOD " +
            "        AND VV.GROUP = Q.GROUP " +
            "")
    List<VoucherBalanceDto> getSingleVoucherCheck();
}