﻿infrastructureModule
   .controller('OrganizationListViewController', ['$location', '$scope', '$log', 'SweetAlert', '$translate', 'areaRegionService', 'exportService','uiGridTreeViewConstants', '$timeout', 'dimensionService', '$interval', 'orgService', '$q','loginContext','equityService',
        function ($location, $scope, $log, SweetAlert, $translate, areaRegionService, exportService,uiGridTreeViewConstants, $timeout, dimensionService, $interval, orgService, $q, loginContext,equityService) {

            $scope.expanded = false;
            var translate={
                Enabled:$translate.instant('BusinessUnitActive'),  //已启用
                Disabled: $translate.instant('BusinessUnitDisabled'),//已停用
            };
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
                // $('#showOperatePop').modal('show');
            };

            //初始化ack-pagination
            $scope.pagingOptions = {
                pageIndex: 1, //当前页码
                totalItems: 0, //总数据
                totalPages: 10, //总页数
                maxSize: 5, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
                pageSizeString: constant.page.pageSizeArrary[3].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage')
            };

            //添加过滤下拉列表
            var InitFilterList = function () {
                //初始化选择器为空
                $scope.filter = {};
                $scope.filter.selected = [];

                var datasource = constant.taxpayerNumberFilter.dataSource;

                datasource.forEach(function (row) {
                    row.value = $translate.instant(row.value);
                });
                $scope.taxPayerFilterList = datasource;
            };


            //筛选的时候，ng-check event will be triggered
            $scope.stateChanged = function ($event, data) {
                $scope.filter.selected = [];
                var checkbox = $event.target;
                if (checkbox.checked && $scope.filter.selected.indexOf(data.key) < 0) {
                    $scope.filter.selected.push(data.key);
                }

                taxPayerFilterChanged();
            };

            var taxPayerFilterChanged = function () {
                var selectedList = $scope.filter.selected;
                if (selectedList.length == 0) return;
                
                var selectedID = $scope.filter.selected[0] || constant.taxpayerNumberFilter.key_0;
                var oldData = angular.copy($scope.oldData);
                switch (selectedID) {
                    //所有对应状态,取默认值
                    case constant.taxpayerNumberFilter.key_0:  //all data
                        $scope.DataGridSource = oldData;
                        break;
                        //have taxpayerNumber
                    case constant.taxpayerNumberFilter.key_1:
                        var findResult = _.filter(oldData, function (item) {
                            return item.taxPayerNumber !== null && item.taxPayerNumber != '';
                        });
                        $scope.DataGridSource = findResult;
                        break;
                        //Don't have taxpayerNumber
                    case constant.espAccountFilter.key_2:
                        var findResult = _.filter(oldData, function (item) {
                            return item.taxPayerNumber == null || item.taxPayerNumber == '';
                        });
                        $scope.DataGridSource = findResult;
                        break;
                }

                $scope.orgTreeListInstance.refresh();
            };


            $scope.createOrg = function ()
            {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.selectedOrg = null;
                $scope.isOrgUpdate = false;
            };

            // 导出机构列表
            $scope.exportOrgList = function ()
            {
                var exportData = {
                    "type"  : "orgList",
                    "jsonData" : JSON.stringify($scope.DataGridSource)
                };
                orgService.downloadOrgListData(exportData).success(function (data, status, headers) {
                    if(status===204){
                        SweetAlert.warning("没有数据可以下载");
                        return;
                    }
                    exportToExcel(data, status, headers, '机构信息列表.xls');
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            };

            //下载服务器上的xls文件
            var exportToExcel = function (data, status, headers, defaultFileName) {
                $('#busy-indicator-container').show();

                var defer = $q.defer();
                var octetStreamMime = 'application/vnd.ms-excel';
                var success = false;

                // Get the headers
                headers = headers();

                // Get the filename from the x-filename header or default to "download.bin"
                var filename = decodeURI(headers['x-file-name']) + defaultFileName;

                // Determine the content type from the header or default to "application/octet-stream"
                var contentType = headers['content-type'] || octetStreamMime;

                try {
                    // Try using msSaveBlob if supported
                    //console.log("Trying saveBlob method ...");
                    var blob = new Blob([data], { type: contentType });
                    if (navigator.msSaveBlob)
                        navigator.msSaveBlob(blob, filename);
                    else {
                        // Try using other saveBlob implementations, if available
                        var saveBlob = navigator.webkitSaveBlob || navigator.mozSaveBlob || navigator.saveBlob;
                        if (saveBlob === undefined) throw "Not supported";
                        saveBlob(blob, filename);
                    }
                    //console.log("saveBlob succeeded");
                    success = true;
                } catch (ex) {
                    $log.debug("saveBlob method failed with the following exception:");
                    $log.debug(ex);
                }

                if (!success) {
                    // Get the blob url creator
                    var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                    if (urlCreator) {
                        // Try to use a download link
                        var link = document.createElement('a');
                        if ('download' in link) {
                            // Try to simulate a click
                            try {
                                // Prepare a blob URL
                                //console.log("Trying download link method with simulated click ...");
                                var blobdownload = new Blob([data], { type: contentType });
                                var urldownload = urlCreator.createObjectURL(blobdownload);
                                link.setAttribute('href', urldownload);

                                // Set the download attribute (Supported in Chrome 14+ / Firefox 20+)
                                link.setAttribute("download", filename);

                                // Simulate clicking the download link
                                var event = document.createEvent('MouseEvents');
                                event.initMouseEvent('click', true, true, window, 1, 0, 0, 0, 0, false, false, false, false, 0, null);
                                link.dispatchEvent(event);
                                //console.log("Download link method with simulated click succeeded");
                                success = true;

                            } catch (ex) {
                                $log.debug("Download link method with simulated click failed with the following exception:");
                                $log.debug(ex);
                                $q.reject();
                            }
                        }

                        if (!success) {
                            // Fallback to window.location method
                            try {
                                // Prepare a blob URL
                                // Use application/octet-stream when using window.location to force download
                                //console.log("Trying download link method with window.location ...");
                                var blobsuccess = new Blob([data], { type: octetStreamMime });
                                var urlsuccess = urlCreator.createObjectURL(blobsuccess);
                                window.location = urlsuccess;
                                //console.log("Download link method with window.location succeeded");
                                success = true;
                            } catch (ex) {
                                //console.log("Download link method with window.location failed with the following exception:");
                                $log.debug(ex);
                                $q.reject();
                            }
                        }
                    }
                }

                if (!success) {
                    // Fallback to window.open method
                    $log.debug("No methods worked for saving the arraybuffer, using last resort window.open");
                    window.open(httpPath, '_blank', '');
                }

                //Delete the file
                // deleteFile(encodeURI(filename));
                defer.resolve('success');
                $('#busy-indicator-container').hide();
                return defer.promise;
            };

            //下载完成后将服务器文件删除
            var deleteFile = function (filename) {
                return $http.get('/org/delete/file?filename=' + filename, apiConfig.create());
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    getOrgList();
                }
            });

            $scope.pagingService = {
                refreshOrgDataGrid: function () {
                    $log.debug("refreshOrgDataGrid");
                    getOrgList();
                }
            };



            var getOrgList = function () {
                orgService.getOrgInfoList().success(function (data) {
                    if (data) {
                        //data.forEach(function (row) {
                        //    if (row.userList) {
                        //        row.userListStr = _.map(row.userList, function (x) { return x.userName; }).join(constant.comma);
                        //    }
                        //});
                        //console.log("dat:" + JSON.stringify(data));
                        if (loginContext.userName && loginContext.userName.toLowerCase() === "simon") {
                            data = _.filter(data, function (row) {
                                return row && row.industryID === "10";
                            });
                        }
                        initPagingControl(data.length);

                        $scope.DataGridSource = data;
                        $scope.oldData = angular.copy(data);
                        $scope.setGridHeight();
                    }
                });
            };

            var initPagingControl = function (totalItemsCount) {
                $scope.pagingOptions.totalItems = totalItemsCount;
            };



            $scope.collapseAll = function () {
                var treeList = $scope.orgTreeListInstance;
                treeList.beginUpdate();
                treeList.collapseAll(-1);
                treeList.endUpdate();
                $scope.expanded = false;
            };
            $scope.expandAll = function () {
                var treeList = $scope.orgTreeListInstance;
                treeList.beginUpdate();
                $scope.DataGridSource.forEach(function (item) {
                    // item.name 对应options的keyExpr
                    treeList.expandRow(item.name);
                });
                treeList.endUpdate();
                $scope.expanded = true;
            };

            var loadDatagrid = function () {
                $scope.orgUserGridOptions = {
                    bindingOptions: {
                        dataSource: 'DataGridSource'
                    },
                    showBorders: true,
                   /* export: {
                        enabled: true,
                        fileName: "机构信息列表"
                    },*/
                    columnChooser: {
                        enabled: true
                    },
                    keyExpr: "name",
                    columns: [
                        {
                            dataField: "name",
                            caption: $translate.instant('OrganizationName'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    $('<a class="hyper-link">' + options.value + '</a>')
                                        .attr('href', '#/organization/' + options.row.data.id)
                                        .appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        }, {
                            dataField: "code",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('OrganizationCode')
                        },
                        {
                            dataField: "taxPayerNumber",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('TaxPayerNumber')
                            //headerFilter: {
                            //    dataSource: {
                            //        load: function () {
                            //            return [{
                            //                text: hasTaxpayNumer,
                            //                 value: [['taxPayerNumber', '<>', null],'and', ['taxPayerNumber', '<>', '']]
                            //            }, {
                            //                text: noTaxpayNumer,
                            //                value: [['taxPayerNumber', '=', null], 'or', ['taxPayerNumber', '=', '']]
                            //            }];
                            //        }
                            //    }
                            //},
                        },
                        {
                            dataField: "structureName",
                            caption: $translate.instant('OrganizationStructureDesc')
                        },
                        {
                            dataField: "regionName",
                            caption: $translate.instant('AreaRegionTitle'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessUnitName",
                            caption: $translate.instant('BusinessUnitTitleName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "areaName",
                            caption: $translate.instant('AreaTitleName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "industryName",
                            caption: $translate.instant('PIndustry'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "isActive",
                            caption: $translate.instant('EnableStatus'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.isActive) {
                                        $('<span>').text(translate.Enabled).appendTo(container);
                                    } else {
                                        $('<span style="color:gray">').text(translate.Disabled).appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "englishName",
                            caption: $translate.instant('OrganizationNameEn'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "abbreviation",
                            caption: $translate.instant('Abbreviation'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "foundationDate",
                            caption: $translate.instant('FoundationDate'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationLocation",
                            caption: $translate.instant('RegistrationLocation'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationLocationEn",
                            caption: $translate.instant('RegistrationLocationEn'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonName",
                            caption: $translate.instant('LegalPersonName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessScope",
                            caption: $translate.instant('BusinessScope'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regStatus",
                            caption: $translate.instant('RegStatus'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "architectureType",
                            caption: $translate.instant('ArchitectureType'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalEconomicIndustry",
                            caption: $translate.instant('NationalEconomicIndustry'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "engageNationalProhibitIndustry",
                            caption: $translate.instant('EngageNationalProhibitIndustry'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationCapital",
                            caption: $translate.instant('RegistrationCapital'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "paidInCapital",
                            caption: $translate.instant('PaidInCapital'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "numOfBranches",
                            caption: $translate.instant('NumOfBranches'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "unifiedSocialCreditCode",
                            caption: $translate.instant('UnifiedSocialCreditCode'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialAccountingType",
                            caption: $translate.instant('RegFinancialAccountingType'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxRegStatus",
                            caption: $translate.instant('TaxRegStatus'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxCreditRating",
                            caption: $translate.instant('TaxCreditRating'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "applicableAccountingRule",
                            caption: $translate.instant('ApplicableAccountingRule'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "lowValueConsumablesAmortizationMethod",
                            caption: $translate.instant('LowValueConsumablesAmortizationMethod'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "depreciationMethod",
                            caption: $translate.instant('DepreciationMethod'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "accountingSoftware",
                            caption: $translate.instant('AccountingSoftware'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "completeRecordTotalInstitutions",
                            caption: $translate.instant('CompleteRecordTotalInstitutions'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonName",
                            caption: $translate.instant('TaxClientPersonName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonPhoneNum",
                            caption: $translate.instant('TaxClientPersonPhoneNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonIdNum",
                            caption: $translate.instant('TaxClientPersonIdNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "ticketHolderName",
                            caption: $translate.instant('TicketHolderName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "ticketHolderPhoneNum",
                            caption: $translate.instant('TicketHolderPhoneNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxHallAddress",
                            caption: $translate.instant('NationalTaxHallAddress'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxAdministratorName",
                            caption: $translate.instant('NationalTaxAdministratorName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxAdministratorPhoneNum",
                            caption: $translate.instant('NationalTaxAdministratorPhoneNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxHallAddress",
                            caption: $translate.instant('LocalTaxHallAddress'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxAdministratorName",
                            caption: $translate.instant('LocalTaxAdministratorName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxAdministratorPhoneNum",
                            caption: $translate.instant('LocalTaxAdministratorPhoneNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "etaWebsite",
                            caption: $translate.instant('EtaWebsite'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "signTripartiteAgreement",
                            caption: $translate.instant('SignTripartiteAgreement'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "reportingCurrency",
                            caption: $translate.instant('ReportingCurrency'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "consolidationTime",
                            caption: $translate.instant('ConsolidationTime'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "fiscalYearDeadline",
                            caption: $translate.instant('FiscalYearDeadline'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxAgent",
                            caption: $translate.instant('TaxAgent'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxAgentContact",
                            caption: $translate.instant('TaxAgentContact'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "otherFacts",
                            caption: $translate.instant('OtherFacts'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxReturnBusinessType",
                            caption: $translate.instant('TaxReturnBusinessType'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "smallMeagerProfit",
                            caption: $translate.instant('SmallMeagerProfit'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "listedCompany",
                            caption: $translate.instant('ListedCompany'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "applicableAccountingStandardsOrAccountingSystems",
                            caption: $translate.instant('ApplicableAccountingStandardsOrAccountingSystems'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxPayerNumberVat",
                            caption: $translate.instant('TaxPayerNumberVat'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxPayerNumberCit",
                            caption: $translate.instant('TaxPayerNumberCit'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonEmailAddress",
                            caption: $translate.instant('TaxClientPersonEmailAddress'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "bankAccountName",
                            caption: $translate.instant('BankAccountName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "bankAccountNumber",
                            caption: $translate.instant('BankAccountNumber'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonPhoneNumber",
                            caption: $translate.instant('LegalPersonPhoneNumber'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonLandlineNum",
                            caption: $translate.instant('LegalPersonLandlineNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonEmailAddress",
                            caption: $translate.instant('LegalPersonEmailAddress'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerName",
                            caption: $translate.instant('RegFinancialOfficerName'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerPhoneNum",
                            caption: $translate.instant('RegFinancialOfficerPhoneNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerLandlineNum",
                            caption: $translate.instant('RegFinancialOfficerLandlineNum'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerEmailAddress",
                            caption: $translate.instant('RegFinancialOfficerEmailAddress'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "actualBusinessAddress",
                            caption: $translate.instant('ActualBusinessAddress'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "secondaryApprovalAmount",
                            caption: $translate.instant('SecondaryApprovalAmount'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessRegistrationNumber",
                            caption: $translate.instant('BusinessRegistrationNumber'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "parValue",
                            caption: $translate.instant('ParValue'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "issuedShares",
                            caption: $translate.instant('IssuedShares'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "directors",
                            caption: $translate.instant('Directors'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "logoutTime",
                            caption: $translate.instant('LogoutTime'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxRuleIntroduction",
                            caption: $translate.instant('TaxRuleIntroduction'),
                            visible : false ,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "auditRequirements",
                            caption: $translate.instant('AuditRequirements'),
                            visible : false ,
                            allowHeaderFiltering: false
                        }
                    ],
                    masterDetail: {
                        enabled: true,
                        template: "detail"
                    },
                    onContentReady: function (e) {
                        $scope.orgTreeList = e;
                        $scope.orgTreeListInstance = e.component;
                        var totalCount =e.component.totalCount();
                        if(totalCount>0)
                        {
                            $scope.totalCount=totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    // scrolling: {
                    //     mode: "virtual"
                    // },
                    // keyExpr: "id",
                    // parentIdExpr: "parentID",
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    // autoExpandAll:true,
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll'),
                        }
                    }
                    //columnHidingEnabled: true, //自定义显示列
                    //columnChooser: {
                    //    enabled: true,
                    //    mode: "select"
                    //},
                };

                $scope.getDetailGridSettings = function (key) {
                    return {
                        //todo 绑定数据
                        dataSource: new DevExpress.data.DataSource({
                            load: function (loadOptions) {
                                var deferred = $q.defer();
                                return equityService.getEquityListResp(key.data.id).success(function (response) {
                                    deferred.resolve({data: response, totalCount: response.length});
                                }).error(function () {
                                    deferred.reject("Data Loading Error");
                                });
                                return deferred.promise;
                            }
                        }),
                        columnAutoWidth: true,
                        showBorders: true,
                        columns: [
                        {
                            dataField: "payableShareholderName",
                            width : "150px",
                            caption: $translate.instant('PayableShareholderName')
                        },
                        {
                            dataField: "payableContributionProportion",
                            width : "150px",
                            caption: $translate.instant('PayableContributionProportion')
                        }]
                    };
                }

            };

            var getDimensionList = function () {
                dimensionService.getDimensionList().success(function (data) {
                    if (data) {
                        $scope.customDimensionList = data;

                        $log.debug($scope.customDimensionList);

                        $scope.businessName = dimension.getBusinessUnitName();
                        $scope.areaName = dimension.getAreaName();
                        loadDatagrid();
                    }
                });
            };

            var dimension = {
                getBusinessUnitName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionID.businessUnitID;
                    });
                    if (findResult) {
                        return findResult.name;
                    }
                    else {
                        return '';
                    }
                },
                getAreaName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionID.areaID;
                    });
                    if (findResult) {
                        return findResult.name;
                    }
                    else {
                        return '';
                    }
                }
            };

            var initData = function () {
                InitFilterList();
                getDimensionList();
                getOrgList();
            };

            var checkUserPermission = function () {

                var list = [];
                $scope.hasQueryPermission = false;
                $scope.hasAddPermission = false;
                $scope.hasEditPermission = false;

                var temp = constant.adminPermission.infrastructure.organizationManage;
                list.push(temp.queryCode);
                list.push(temp.addCode);
                list.push(temp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasQueryPermission = data[temp.queryCode];
                    $scope.hasAddPermission = data[temp.addCode];
                    $scope.hasEditPermission = data[temp.editCode];
                    if ($scope.hasQueryPermission) {
                        initData();
                    }
                });
            };


            (function initialize() {
                $log.debug('OrganizationListViewController.ctor()...');
      
                checkUserPermission();
            })();
        }
   ]);