﻿systemConfigurationModule
.controller('StandardSubjectCorrespondingController', ['$scope', '$log', 'uiGridConstants', 'SweetAlert', '$translate', 'stdAccountService', 'enterpriceAccountService', '$interval',
    function ($scope, $log, uiGridConstants, SweetAlert, $translate, stdAccountService, enterpriceAccountService, $interval) {
        'use strict';

        var InitStdSubjectLinkEtsSubject = function () {
            stdAccountService.getStdAccountLinkEtsAccount().success(function (data) {
                data.forEach(function (row) {
                    row.directionStr = _.find($scope.directionList, function (num) {
                        return num.id === row.direction
                    }).name;
                    row.subjectTypeStr = _.find($scope.acctPropList, function (num) {
                        return num.id === row.acctProp
                    }).name;
                });
                $scope.gridOptionsStdSubjectList.data = data;
            });
        };

        (function initialize() {
            $log.debug('StandardSubjectCorrespondingController.ctor()...');
            $scope.stdSubjectList = [];
            $scope.directionList = [
            { id: 1, name: $translate.instant('StandardAccountDebit') },
            { id: -1, name: $translate.instant('StandardAccountCredit') },
            ];

            $scope.acctPropList = [
            { id: 1, name: $translate.instant('StandardAccountAcctPropAsset') },
            { id: 2, name: $translate.instant('StandardAccountAcctPropDebt') },
            { id: 3, name: $translate.instant('StandardAccountAcctPropCommon') },
            { id: 4, name: $translate.instant('StandardAccountAcctPropInterest') },
            { id: 5, name: $translate.instant('StandardAccountAcctPropCost') },
            { id: 6, name: $translate.instant('StandardAccountAcctPropProfitAndLoss') },
            ];

            $scope.gridOptionsStdSubjectList = {
                rowHeight: 55,
                selectionRowHeaderWidth: 55,
                enableSorting: false,
                enableColumnMenus: false,
                enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                enableRowSelection: true,
                enableRowHeaderSelection: false,
                columnDefs: [
                  {
                      field: 'code', name: $translate.instant('StdSubjectCodeCol'), width: '20%', headerCellClass: '',
                      cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.code}}<span></div>'
                  },
                  {
                      field: 'name', name: $translate.instant('StdSubjectNameCol'), width: '25%', headerCellClass: '',
                      cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.name}}</span></div>'
                  },
                  {
                      field: 'directionStr', name: $translate.instant('SubjectDirectionCol'), width: '15%', headerCellClass: '',
                      cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.directionStr}}</span></div>'
                  },
                  {
                      field: 'subjectTypeStr', name: $translate.instant('SubjectTypeCol'), width: '15%', headerCellClass: '',
                      cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.subjectTypeStr}}</span></div>'
                  },
                  {
                      field: 'etsCode', name: $translate.instant('EtsSubjectNameCol'), width: '25%', headerCellClass: 'text-align-center',
                      cellTemplate: '<div class="text-align-center"><span><i class="material-icons map-status-flag" ng-if="row.entity.etsCode === null">flag</i>{{row.entity.etsCode === null ? "未对应" : (row.entity.etsCode + "-" + row.entity.etsName)}}</span></div>'
                  }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;
                    // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };

            InitStdSubjectLinkEtsSubject();
        })();
    }
]);