﻿systemConfigurationModule.controller('SubjectCorrespondingController', ['$scope', '$log', 'uiGridConstants', 'SweetAlert', '$translate', 'stdAccountService', 'enterpriseAccountService', '$interval', 'orgService', '$timeout', '$q', 'commonWebService', 'loginContext',
    function ($scope, $log, uiGridConstants, SweetAlert, $translate, stdAccountService, enterpriseAccountService, $interval, orgService, $timeout, $q, commonWebService, loginContext) {
        'use strict';

        var defaultSelectStandardAccount = {
            id: 0,
            name: '',
            fullName: '',
            code: '',
            parentCode: '',
            acctLevel: 0,
            selectValue: ' '
        };

        //初始化页面右侧可双击进行对应的标准科目表数据
        var InitStdSubject = function () {
            //stdAccountService.getStdAccountHierarchy($scope.selectedOrgID).success(function (stdAccountsCategories) {
            //    $scope.stdAccountsCategories = stdAccountsCategories;
            //    console.log(stdAccountsCategories);
            //    commonWebService.initFancyTree('treetable', stdAccountsCategories);
            //});
        };

        //初始化企业科目数据列表
        var InitEnterpriseSubject = function (rowIndexArray) {
            //企业账套ID
            var espID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';
            var orgID = $scope.selectedOrgID;

            //加载复制对应关系下的结构
            orgService.getOrgIvhTreeList(0, espID).success(function (treeData) {

                console.log(treeData);
                $scope.OrgMultiData = treeData;
                $scope.dsCheckBoxTreeView = treeData;
            });

            //Jacob
            getEspAccountList(espID, orgID, "-1");
        };

        ///根据标准科目code和name获取最终界面上应该显示的内容
        var getStdResult = function (stdCode, stdName) {
            var stdResult = stdCode === null ? $translate.instant('NotMapped') : (stdCode === "0000" ? "-" : stdCode + "-" + stdName);
            return stdResult;
        }

        var getEspAccountList = function (espID, orgID, filterType) {

            enterpriseAccountService.getEnterpriceAccountList(espID, orgID, filterType).success(function (data) {
                if (data === null) return;
                data.forEach(function (row) {

                    var direction = _.find($scope.directionList, function (num) {
                        return num.id === row.direction;
                    });

                    var acctProp = _.find($scope.acctPropList, function (num) {
                        return num.id === row.acctProp;
                    });

                    if (!direction || !acctProp) {
                        console.log('企业科目数据有问题！借贷方向或者科目类型不完全，请重新导入企业账套！ - ' + row.code);
                    }

                    row.directionStr = direction ? direction.name : '';
                    row.subjectTypeStr = acctProp ? acctProp.name : '';

                    if (row.treeLevel != null) {
                        row.$$treeLevel = parseInt(row.treeLevel);
                    }

                    row.stdResult = getStdResult(row.stdCode, row.stdFullName);

                });

                $scope.gridOptionsSubjectList.data = data;
                $scope.EnterpriceAccountList = data;
            });
        };

        //添加企业科目过滤下拉列表
        var InitFilterAccount = function () {

            var data = constant.espAccountFilter.data;
            data.forEach(function (row) {
                row.value = $translate.instant(row.value);
            });

            $scope.accountFilterList = data;
        };

        $scope.isSelected = function (id) {
            return $scope.filter.selected.indexOf(id) >= 0;
        };

        //筛选的时候，ng-check event will be triggered
        $scope.stateChanged = function ($event, data) {
            $scope.filter.selected = [];
            $scope.filterConditionDesc = '';
            var checkbox = $event.target;
            if (checkbox.checked && $scope.filter.selected.indexOf(data.key) < 0) {
                $scope.filter.selected.push(data.key);
                $scope.filterConditionDesc = data.value;
            }

            accountFilterChanged();
        };


        //根据不同的状态过滤，未对应，已对应，借贷方向不一致等
        //Jacob 
        var accountFilterChanged = function () {
            var selectArr = $scope.filter.selected;
            var data = $scope.EnterpriceAccountList;
            var key = $scope.filter.selected[0] || constant.espAccountFilter.key_0;
            var espID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';
            var orgID = $scope.selectedOrgID;

            switch (key) {
                //所有对应状态,取默认值
                case constant.espAccountFilter.key_0:
                    getEspAccountList(espID, orgID, "-1");
                    break;
                    //未对应
                case constant.espAccountFilter.key_1:
                    getEspAccountList(espID, orgID, "0");
                    break;
                    //已对应
                case constant.espAccountFilter.key_2:
                    getEspAccountList(espID, orgID, "1");
                    break;
                    //借贷方向不一致
                case constant.espAccountFilter.key_3:
                    getEspAccountList(espID, orgID, "2");
                    break;
                    //科目类型不一致
                case constant.espAccountFilter.key_4:
                    getEspAccountList(espID, orgID, "3");
                    break;
            }
        };


        var InitNgData = function () {
            $scope.stdCollapsed = true;
            $scope.accountFilterList = [];
            //初始化选择器为空
            $scope.filter = {};
            $scope.filter.selected = [];
            //初始化企业科目筛选列表
            InitFilterAccount();

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        }


        var getUITreeScope = function (uiTreeID) {
            return angular.element(document.getElementById(uiTreeID)).scope();
        };
        //如果没有全部展开，return false.
        var isExpandAll = function (uiTreeID) {
            var childNodes = getUITreeScope(uiTreeID).childNodes();

            var isCollapsed = function (c) {
                if (c.collapsed)
                    return true;

                var childs = c.childNodes();

                for (var i = 0; i < childs.length; i++) {
                    if (isCollapsed(childs[i])) {
                        return true;
                    }
                }
                return false;
            }

            return !_.some(childNodes, isCollapsed);
        };

        //ui tree 折叠或展开所有
        var uiTreeExpandOrCollase = function (uiTreeID, iscollapsed) {
            var childNodes = getUITreeScope(uiTreeID).childNodes();
            try {
                if (iscollapsed) {
                    PWC.uiTree.collapsedAll(childNodes);
                }
                else {
                    PWC.uiTree.expandAll(childNodes);
                }
            }
            catch (ex) {
                if (iscollapsed) {
                    $scope.$broadcast('angular-ui-tree:collapse-all');
                }
                else {
                    $scope.$broadcast('angular-ui-tree:expand-all');
                }
            }
        };


        //标准科目，单独展开或折叠
        $scope.toggle1 = function (scope) {
            scope.toggle();
            if (scope.collapsed) {
                $scope.stdCollapsed = true;
            }
            else {
                //如果全部展开，最顶层也要展开
                if (isExpandAll('tree-root')) {
                    $scope.stdCollapsed = false;
                }
            }
        };

        //标准科目，全部展开或折叠
        $scope.toggleStdSubject = function () {
            $scope.stdCollapsed = !$scope.stdCollapsed;
            commonWebService.expandCollapseAll('treetable', $scope.stdCollapsed);
        }

        var reset = function () {
            //清空企业科目列表grid
            $scope.gridOptionsSubjectList.data = [];
            //清空标准科目对应结果数据列表
            $scope.gridOptionsStdSubjectList.data = [];
            //清空过滤器选择为空
            $scope.filter.selected = [];

        };


        //清空右侧标准科目
        var resetstdAccount = function () {
            $scope.stdAccountsCategories = null;
            $scope.stdCollapsed = true;
        };

        //清空账套列表
        var resetEspAccountSet = function () {
            $scope.enterpriseAccountSetList = null;

        };

        var loadData = function () {
            //企业科目全部折叠
            gridOptionsSubjectListCollapseAllRows();
            //初始化企业科目
            InitEnterpriseSubject();
            //初始化对应结果列表
            //InitStdSubjectLinkEtsSubject();
        };

        //根据选择的账套,构造页面数据
        var LoadEtsSubjectBySelectedAccpSetID = function () {
            reset();
            loadData();

            $('.subject-corresponding-container').css('display', 'block');
            $('.std-subject-container').css('display', 'none');
        };

        //根据选择的组织机构，构造账套列表和标准科目
        var LoadEtsSubjectBySelectedOrg = function () {
            reset();
            resetEspAccountSet();
            resetstdAccount();
            InitStdSubject();
            loadEnterpriseAccountSetList();
        };

        //根据机构 获取企业账套
        var loadEnterpriseAccountSetList = function () {

            enterpriseAccountService.getEnterpriseAccountSetListByOrgID($scope.selectedOrgID).success(function (data) {
                if (data && data.length > 0) {
                    $scope.enterpriseAccountSetList = data;
                    $scope.enterpriseAccountSetSelect = data[0];
                    if ($scope.enterpriseAccountSetSelect != null) {
                        loadData();
                    }
                }
            });
        };

        //初始化标准科目对应结果数据列表
        var InitStdSubjectLinkEtsSubject = function () {
            var espID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';
            stdAccountService.getStdAccountLinkEtsAccount($scope.selectedOrgID, espID).success(function (data) {
                data.forEach(function (row) {
                    row.directionStr = _.find($scope.directionList, function (num) {
                        return num.id === row.direction;
                    }).name;
                    row.subjectTypeStr = _.find($scope.acctPropList, function (num) {
                        return num.id === row.acctProp;
                    }).name;
                    if (row.treeLevel != null) {
                        row.$$treeLevel = parseInt(row.treeLevel);
                    }

                    row.etsResult = row.etsCode === null ? $translate.instant('NotMapped') : (row.etsCode + "-" + row.etsName);
                });

                $scope.gridOptionsStdSubjectList.data = data;
            });
        };

        $scope.toggleRow = function (rowNum) {
            $scope.gridApiSubject.treeBase.toggleRowTreeState($scope.gridApiSubject.grid.renderContainers.body.visibleRowCache[rowNum]);
        };

        //手动对应，双击页面右侧的标准科目列表执行该事件
        var mapStdAccount = function (code, name, acctProp, direction) {
            if ($scope.selectedOrg && !$scope.selectedOrg.isHaveEditPermission) {
                SweetAlert.warning($translate.instant('NoEditPermission'));
                return;
            }

            var accountMap = {};
            var rowIndexArray = [];
            var isMapped = false;
            var isAcctPropMatched = false;
            var isDirectionMatched = false;

            accountMap.orgID = $scope.selectedOrgID;
            accountMap.enterpriseAccountCodes = [];
            accountMap.standardAccountCode = code;
            accountMap.accountSetID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';

            var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
            if (selectedRows.length === 0) {
                SweetAlert.warning($translate.instant('SelectOneAccountToMap'));
                return;
            }

            var stdAcctProp = acctProp;
            var stdDirection = direction;

            selectedRows.forEach(function (v) {
                accountMap.enterpriseAccountCodes.push(v['code']);
                var rowIndex = findIndexByKeyValue($scope.gridOptionsSubjectList.data, "code", v['code'])
                rowIndexArray.push(rowIndex);

                var stdCode = v['stdCode'];
                var acctProp = v['acctProp'];
                var direction = v['direction'];

                //判断企业科目是否已有对应的标准科目，如果有isMapped=true
                if (stdCode != null) {
                    isMapped = true;
                }

                //判断企业科目和标准科目的类型否一致，如果不一致，isAcctPropMatched=true
                if (acctProp != -1 && acctProp != null && stdAcctProp != acctProp) {
                    isAcctPropMatched = true;
                }

                //判断企业科目和标准科目的借贷方是否一致，如果不一致，isDirectionMatched=true
                if (stdDirection != direction) {
                    isDirectionMatched = true;
                }
            });

            //如果已经map过
            if (isMapped) {
                msgboxOptions.text = $translate.instant('ComfirmToReMap');
                SweetAlert.swal(msgboxOptions, function (isConfirm) {
                    if (isConfirm) {
                        //如果科目类型不一致
                        if (isAcctPropMatched) {
                            msgboxOptions.text = $translate.instant('ConfirmToMapForDiffAcctProp');
                            SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                if (isConfirm) {
                                    //如果科目类型一致，则判断借贷方向是否一致
                                    if (isDirectionMatched) {
                                        msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                                        SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                            if (isConfirm) {
                                                mapAccountParentChild(selectedRows, accountMap, code, name);
                                            } else {
                                                swal.close();
                                            }
                                        });
                                    } else {
                                        mapAccountParentChild(selectedRows, accountMap, code, name);
                                    }
                                } else {
                                    swal.close();
                                }
                            });
                        }
                        else {
                            //如果借贷方向不一致
                            if (isDirectionMatched) {
                                msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                                SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                    if (isConfirm) {
                                        mapAccountParentChild(selectedRows, accountMap, code, name);
                                    } else {
                                        swal.close();
                                    }
                                });
                            }
                            else {
                                mapAccountParentChild(selectedRows, accountMap, code, name);
                            }
                        }
                    } else {
                        swal.close();
                    }
                });
            }
            else {
                //如果没有map过，则判断科目类型是否一致
                if (isAcctPropMatched) {
                    msgboxOptions.text = $translate.instant('ConfirmToMapForDiffAcctProp');
                    SweetAlert.swal(msgboxOptions, function (isConfirm) {
                        if (isConfirm) {
                            //如果科目类型一致，则判断借贷方向是否一致
                            if (isDirectionMatched) {
                                msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                                SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                    if (isConfirm) {
                                        mapAccountParentChild(selectedRows, accountMap, code, name);
                                    } else {
                                        swal.close();
                                    }
                                });
                            } else {
                                mapAccountParentChild(selectedRows, accountMap, code, name);
                            }
                        } else {
                            swal.close();
                        }
                    });
                }
                else {
                    //如果借贷方向不一致
                    if (isDirectionMatched) {
                        msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                        SweetAlert.swal(msgboxOptions, function (isConfirm) {
                            if (isConfirm) {
                                mapAccountParentChild(selectedRows, accountMap, code, name);
                            } else {
                                swal.close();
                            }
                        });
                    } else {
                        mapAccountParentChild(selectedRows, accountMap, code, name);
                    }
                }
            }
        };

        //弹出框的默认配置项
        var msgboxOptions = {
            title: $translate.instant('ConfirmToContinue'),
            text: $translate.instant('ComfirmToReMap'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Confirm'),
            cancelButtonText: $translate.instant('Cancel'),
            closeOnConfirm: false,
            closeOnCancel: false
        };


        var mapAccountParentChild = function (selectedRows, accountMap, code, name) {
            enterpriseAccountService.mapAccount(accountMap).success(function (or) {
                if (or.result === true) {
                    $scope.gridApiSubject.selection.clearSelectedRows();

                    //如果重新从数据库加载，数据会重新绑定然后感觉界面被刷新
                    updateChildrenEnterpriseAccount(selectedRows, code, name);

                    //更新父级科目的状态
                    updateParentEnterpriseAccount(or.data.parentAccountMappingResult);

                    swal.close();
                }
                else {
                    SweetAlert.warning($translate.instant(or.resultMsg).formatObj({ code: or.data.standardAccountCode }));
                }
            });
        };

        var updateParentEnterpriseAccount = function (parentMapingDict) {

            for (var key in parentMapingDict) {
                $scope.gridApiSubject.grid.rows.forEach(function (row) {
                    if (row.entity.code === key) {
                        row.entity['stdCode'] = parentMapingDict[key][0];
                        row.entity['stdName'] = parentMapingDict[key][1];
                        row.entity['stdResult'] = getStdResult(row.entity['stdCode'], row.entity['stdFullName']);
                    }
                });
            }
        };

        //当在取消或者手动对应之后更新界面
        //selectedRows: uigrid中当前选中的行集合
        //codeToUpdate: 需要将旧的代码设置为该code
        //nameToUpdate: 需要将旧的科目名称设置为该name
        var updateChildrenEnterpriseAccount = function (selectedRows, codeToUpdate, nameToUpdate) {
            selectedRows.forEach(function (v) {
                v['stdCode'] = codeToUpdate;
                v['stdName'] = nameToUpdate;
                v['stdResult'] = getStdResult(codeToUpdate, nameToUpdate);
                //todo 需求不需要覆盖子节点
                //找出该选中节点的所有子节点，然后复制，避免再次从数据库获取数据
                // $scope.gridApiSubject.grid.rows.forEach(function (row) {
                //     if (row.entity.parentCode === v.code) {
                //         row.entity['stdCode'] = codeToUpdate;
                //         row.entity['stdName'] = nameToUpdate;
                //         row.entity['stdResult'] = getStdResult(codeToUpdate, nameToUpdate);
                //
                //         //再次更新该row下面的子节点如果存在的话
                //         updateChildrenMappedCodeNameRecursive($scope.gridApiSubject.grid.rows, row.entity['code'], codeToUpdate, nameToUpdate);
                //     }
                // });
            });
        };

        var updateChildrenMappedCodeNameRecursive = function (rows, filterCode, codeToUpdate, nameToUpdate) {
            $scope.gridApiSubject.grid.rows.forEach(function (row) {
                if (row.entity.parentCode === filterCode) {
                    row.entity['stdCode'] = codeToUpdate;
                    row.entity['stdName'] = nameToUpdate;
                    row.entity['stdResult'] = getStdResult(codeToUpdate, nameToUpdate);

                    //再次更新该row下面的子节点如果存在的话
                    updateChildrenMappedCodeNameRecursive($scope.gridApiSubject.grid.rows, row.entity['code'], codeToUpdate, nameToUpdate);
                }
            });
        }

        var findIndexByKeyValue = function (arrayToSearch, key, valueToSearch) {
            for (var i = 0; i < arrayToSearch.length; i++) {
                if (arrayToSearch[i][key] == valueToSearch) {
                    return i;
                }
            }
            return null;
        };


        //自动对应
        $scope.autoMap = function () {
            var espID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';
            enterpriseAccountService.autoMap($scope.selectedOrgID, espID).success(function (or) {
                if (or != null && or != undefined) {
                    if (or.result) {
                        // mapping success
                        SweetAlert.success($translate.instant('AutoMappingSuccess'));
                        InitEnterpriseSubject();
                        //InitStdSubjectLinkEtsSubject();
                    }
                    else {
                        SweetAlert.warning($translate.instant(or.resultMsg));
                    }
                }
                else {
                    SweetAlert.warning($translate.instant('AccountMapFailed'));
                }
            });
        };

        $scope.getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return {
                    height: $(".subject-corresponding-container #enterprizeAccount .subject-list-grid-warp").height() + "px"
                };
            }
        };

        //针对选中的取消对应
        var ClearMap = function () {
            var clearEnterpriseAccountIDs = [];

            var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
            if (selectedRows.length === 0) {
                SweetAlert.warning($translate.instant('SelectOneAccountToClearMap'));
                return;
            }

            selectedRows.forEach(function (v) {
                clearEnterpriseAccountIDs.push(v['id']);
            });

            enterpriseAccountService.clearMap(clearEnterpriseAccountIDs, $scope.selectedOrgID).success(function (or) {
                if (or != null && or != undefined) {
                    if (or.result) {
                        // clear mapping success
                        SweetAlert.success($translate.instant('ClearMapSuccess'));
                        //如果重新从数据库加载，数据会重新绑定然后感觉界面被刷新
                        updateChildrenEnterpriseAccount(selectedRows, null, '');
                        updateParentEnterpriseAccount(or.data.parentAccountMappingResult);
                        $scope.gridApiSubject.selection.clearSelectedRows();
                        //InitEnterpriseSubject(); 
                        //InitStdSubjectLinkEtsSubject();
                    }
                    else {
                        SweetAlert.warning($translate.instant(or.resultMsg));
                    }
                }
                else {
                    SweetAlert.warning($translate.instant('ClearMapFailed'));
                }
            });
        };

        var copyMappingCheck = function () {

            //判断当前选择的机构是否是同行业的，如果不是同一行业则给出提示
            var IsSameIndustry = true;
            if ($scope.selectedCopyOrgIndustryIDList.length > 0) {
                var fIndustryID = $scope.selectedCopyOrgIndustryIDList[0];

                $scope.selectedCopyOrgIndustryIDList.forEach(function (x) {
                    if (x != fIndustryID) {
                        IsSameIndustry = false;
                        return;
                    }
                });
            }

            //当前选中的账套ID
            var espID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';

            //行业不一致弹出框确认配置
            var industryDifferConfirmOptions = {
                title: $translate.instant('ConfirmToContinue'),
                text: $translate.instant('IndustryConfirmToMapping'),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55", confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: false,
                closeOnCancel: true
            };

            //行业不一致的时候需要弹框确认
            if (IsSameIndustry) {
                checkToCopyMapping(espID);
            } else {
                SweetAlert.swal(industryDifferConfirmOptions, function (isConfirmI) {
                    if (isConfirmI) {
                        checkToCopyMapping(espID);
                    }
                });
            }
        };

        //存在已经对应过的机构的确认配置
        var existedMapOrgOption = function (mappingExistOrg) {

            return {
                title: $translate.instant('ConfirmToContinue'),
                text: $translate.instant('ExistMappedOrg') + mappingExistOrg,
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55", confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: false,
                closeOnCancel: true
            }
        };

        //检查是否已有科目对应过的机构，并复制对应关系
        var checkToCopyMapping = function (espID) {

            //需要把当前机构的ID排除
            $scope.selectedCopyOrgIDList = _.filter($scope.selectedCopyOrgIDList, function (item) {
                return item !== $scope.selectedOrgID;
            });

            enterpriseAccountService.checkMapped($scope.selectedCopyOrgIDList, espID).success(function (data) {

                //检查是否可以复制对应关系，后端返回检查信息
                if (data && !data.result) {

                    //存在已对应过的机构，将对应过的机构组成字符串并弹框确认
                    var mappingExistOrg = '';
                    data.data.forEach(function (org) {
                        mappingExistOrg += org + ', ';
                    });
                    mappingExistOrg = '[' + mappingExistOrg + ']';

                    //弹框确认是否覆盖已对应过的机构
                    SweetAlert.swal(existedMapOrgOption(mappingExistOrg), function (isConfirmM) {
                        if (isConfirmM) {
                            copyMapping();
                        }
                    });

                } else if (data && data.result) {
                    copyMapping();
                } else {
                    console.log('data is undefined')
                }
            });
        };

        //复制对应关系到选中的组织机构
        var copyMapping = function () {

            var mappingParam = {};
            var espID = $scope.enterpriseAccountSetSelect && $scope.enterpriseAccountSetSelect.id || '';

            mappingParam.orgIDs = $scope.selectedCopyOrgIDList;
            mappingParam.selectedOrgID = $scope.selectedOrgID;
            mappingParam.selectedOrgSetID = espID;

            enterpriseAccountService.copyMapping(mappingParam).success(function (or) {
                if (or != null && or != undefined) {
                    if (or.result) {
                        SweetAlert.success($translate.instant('CopyMappingsSuccess'));
                    }
                    else {
                        SweetAlert.warning($translate.instant(or.resultMsg));
                    }
                }
                else {
                    SweetAlert.warning($translate.instant('CopyMappingsFailed'));
                }
            });
        };

        //点击明细数据弹出窗中的关联模型tab
        $scope.showLinkModal = function () {
            $scope.isShowLinkModal = true;
            $scope.isShowLinkReport = false;
        };

        //点击明细数据弹出窗中的关联报表tab
        $scope.showLinkReport = function () {
            $scope.isShowLinkReport = true;
            $scope.isShowLinkModal = false;

        };

        //加载明细数据中关联报表tab下的模板中的公式
        var loadTemplateFormula = function () {
            // 先清空上次记录
            $scope.reportGridOptions.data = [];
            if ($scope.selectStandardAccount && $scope.selectStandardAccount.code) {
                templateFormulaService.getByStandardCode($scope.selectStandardAccount.code).success(function (data) {
                    $scope.reportGridOptions.data = data;
                });
            }
        };

        //双击企业科目grid中的单条数据，显示明细数据
        var showDetail = function (entity) {
            $scope.dbSelectedModel = entity;
            //如果该条数据未进行对应，则不弹出明细窗口
            if (entity.stdCode === null) {
                $('.list').css('display', 'none');
            }
            else {
                $('.list').css('display', 'block');
            }
            // 选中
            enterpriseAccountService.get($scope.dbSelectedModel.id).success(function (data) {
                $scope.editModel = data;
                if (data.stdCode && data.stdName) {
                    $scope.editModel.standardAccount = data.stdCode + '-' + data.stdName;
                }
                else {
                    $scope.editModel.standardAccount = $translate.instant('NotMap');
                }

                $scope.isAdd = false;

                $scope.editModel.title = $translate.instant('EnterpriseAccount') + '-' + '(' + data.code + ' ' + data.name + ')';

                $scope.selectStandardAccount = _.find($scope.standardAccountList, function (num) {
                    return num.code === data.stdCode
                });

                if (!$scope.selectStandardAccount || !data.stdCode || data.stdCode === '') {
                    $scope.selectStandardAccount = defaultSelectStandardAccount;
                }

                $scope.selectDirection = _.find($scope.directionList, function (num) {
                    return num.id === data.direction
                });
                $scope.selectAcctProp = _.find($scope.acctPropList, function (num) {
                    return num.id === data.acctProp
                });

                $scope.isShowLinkModal = false;
                $scope.isShowLinkReport = true;
                $scope.iseditDetail = false;

                loadTemplateFormula();

                $('#enterpriseAccountDetailPopup').modal('show');
            });
        };


        //加载复制对应关系下的组织机构数据
        var loadOrgMultiData = function () {
            //orgService.getOrgIvhTreeList(0).success(function (data) {
            //    if (data.length > 0) {

            //        $scope.selectedOrgName = data[0].value.name;
            //        $scope.selectedOrgID = data[0].value.id;
            //    }
            //});
        };

        //勾选组织机构事件
        var checkboxCheckStateChangeHandling = function (node, disabled) {
            if (disabled) return;

            var isSelected = node.selected;
            var org = node.itemData.data.value;

            if (isSelected) {
                $scope.checkedSet[org.id] = org.industryID == constant.organization.EstateIndustryId ? org.industryID : constant.organization.NonEstateIndustryId;
            }
            else {
                delete $scope.checkedSet[org.id];
            }

            $scope.selectedCopyOrgIDList = _.keys($scope.checkedSet);
            $scope.selectedCopyOrgIndustryIDList = _.values($scope.checkedSet);
        };

        var otherAwesomeCallbackSpan = function (node, disabled) {
            if (disabled) return;
            node.selected = !node.selected;
            otherAwesomeCallback(node);
        };


        $scope.showOperateLogPop = function () {
            $scope.isShowLog = true;
            // $('#showOperatePop').modal('show');
        };

        var gridOptionsSubjectListCollapseAllRows = function () {

            $scope.gridApiSubject.treeBase.collapseAllRows();
        };

        $scope.$watch('selectedOrgID', function (newVal, oldVal) {
            if (newVal !== oldVal) {
                //初始化右侧标准科目的树,使用jquery fancytree的方式来显示树，所以需要用到ajax的方式
                var stdAccountUrl = '/stdAccount/stdAccountHierarchy?orgID=' + $scope.selectedOrgID;
                commonWebService.initAllFancyTreeAjax('treetable', stdAccountUrl, mapStdAccount);

                $scope.LoadEtsSubjectBySelectedOrg();
            }
        });

        //加载复制对应关系 机构选择树形结构
        var loadOrgCheckboxTreeViewSettings = function () {

            $scope.orgCheckboxTreeViewOptions = {

                bindingOptions: {
                    dataSource: 'dsCheckBoxTreeView',
                    searchValue: 'searchValue'
                },
                selection: {
                    mode: "multiple"
                },
                loadPanel: {
                    enabled: true
                },
                scrolling: {
                    mode: "virtual"
                },
                keyExpr: "id",
                showRowLines: true,
                showColumnLines: true,
                expandAllEnabled: true,
                rowAlternationEnabled: true,
                expandedRowKeys: [1],
                showBorders: true,
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                displayExpr: 'text', //显示的属性名称，默认为text
                itemsExpr: 'items', //子层的数组名称，默认为items 
                selectNodesRecursive: false, //级联选择
                showCheckBoxesMode: 'normal', //Accepted Values: 'none' | 'normal' | 'selectAll' 
                onInitialized: function (e) {
                    $scope.gridInstance = e.component;
                },
                onItemSelectionChanged: function (e) {
                    checkboxCheckStateChangeHandling(e.node);
                },
                //点击行，选中
                onItemClick: function (e) {
                    var data = e.itemData;
                },
                onContentReady: function (object, container) {
                    //object.element.find('.dx-checkbox-checked').addClass('dx-state-disabled');
                }
            };
        };

        //初始化企业科目grid的设置
        var loadStdAccountListOptions = function () {
            //标准科目对应结果列表grid
            $scope.gridOptionsStdSubjectList = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                enableSorting: false,
                enableColumnMenus: false,
                enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                enableRowSelection: true,
                enableSelectAll: true,
                enableRowHeaderSelection: false,
                enableFiltering: false,
                enableColumnResizing: true,
                showTreeExpandNoChildren: false,
                columnDefs: [
                    {
                        field: 'code', name: $translate.instant('StdSubjectCodeCol'), width: '20%', headerCellClass: '',
                        cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.code}}">{{row.entity.code}}<span></div>'
                    },
                    {
                        field: 'name', name: $translate.instant('StdSubjectNameCol'), width: '25%', headerCellClass: '',
                        cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.fullName}}">{{row.entity.fullName}}</span></div>'
                    },
                  {
                      field: 'directionStr', name: $translate.instant('SubjectDirectionCol'), width: '15%', headerCellClass: '',
                      cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.directionStr}}">{{row.entity.directionStr}}</span></div>'
                  },
                  {
                      field: 'subjectTypeStr', name: $translate.instant('SubjectTypeCol'), width: '15%', headerCellClass: '',
                      cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.subjectTypeStr}}">{{row.entity.subjectTypeStr}}</span></div>'
                  },
                    {
                        field: 'etsCode', name: $translate.instant('EtsSubjectNameCol'), width: '25%', headerCellClass: 'text-align-center',
                        cellTemplate: '<div class="text-align-left-padding" style="margin-right:40px"><i class="material-icons map-status-flag" ng-if="row.entity.etsCode === null">flag</i><span  title="{{row.entity.etsResult}}">{{row.entity.etsResult}}</span></div>'
                    }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApiStdSubject = gridApi;
                    // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                    $interval(function () {
                        $scope.gridApiStdSubject.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };
        };

        //初始化标准科目grid的设置
        var loadEnterpriseAccountListOptions = function () {

            //企业科目列表grid
            $scope.gridOptionsSubjectList = {
                enableColumnResizing: true,
                enableRowSelection: false,
                enableSelectAll: true,
                rowHeight: constant.UIGrid.rowHeight,
                enableRowHeaderSelection: true,
                modifierKeysToMultiSelect: false,
                enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
                enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
                selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                enableSorting: false,
                enableColumnMenus: false,
                enableFiltering: false,
                showTreeExpandNoChildren: false,
                enableFullRowSelection: true, //是否点击行任意位置后选中,默认为false
                multiSelect: true,// 是否可以选择多个,默认为true;
                columnDefs: [
                    {
                        field: 'code',
                        width: '17%',
                        name: $translate.instant('EnterpriseSubjectCodeCol'),
                        headerCellClass: '',
                        cellTemplate: '<div ng-if="row.entity.acctLevel==1" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>{{row.entity.code}}<span></div>' +
                                      '<div ng-if="row.entity.acctLevel==2" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>&nbsp;{{row.entity.code}}<span></div>' +
                                      '<div ng-if="row.entity.acctLevel==3" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>&nbsp;&nbsp{{row.entity.code}}<span></div>' +
                                      '<div ng-if="row.entity.acctLevel==4" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>&nbsp;&nbsp;&nbsp{{row.entity.code}}<span></div>' +
                                      '<div ng-if="row.entity.acctLevel==5" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>&nbsp;&nbsp;&nbsp;&nbsp;{{row.entity.code}}<span></div>' +
                                      '<div ng-if="row.entity.acctLevel==6" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{row.entity.code}}<span></div>' +
                                      '<div ng-if="row.entity.acctLevel==7" class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp{{row.entity.code}}<span></div>'
                    },
                        {
                            field: 'name',
                            name: $translate.instant('EnterpriseSubjectNameCol'),
                            headerCellClass: '',
                            width: '20%',
                            cellTemplate: '<div class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span title="{{row.entity.name}}">{{row.entity.name}}</span></div>'
                        },
                        {
                            field: 'directionStr',
                            name: $translate.instant('SubjectDirectionCol'),
                            headerCellClass: '',
                            cellTemplate: '<div class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span title="{{row.entity.directionStr}}">{{row.entity.directionStr}}</span></div>'
                        },
                        {
                            field: 'subjectTypeStr',
                            name: $translate.instant('SubjectTypeCol'),
                            headerCellClass: '',
                            cellTemplate: '<div class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span title="{{row.entity.subjectTypeStr}}">{{row.entity.subjectTypeStr}}</span></div>'
                        },
                        {
                            field: 'stdCode',
                            name: $translate.instant('StandardSubjectCol'),
                            headerCellClass: '',
                            width: '25%',
                            cellTemplate: '<div class="text-align-left-padding" ng-dblClick="grid.appScope.showDetail(row.entity)"><span title={{row.entity.stdResult}}><i class="material-icons map-status-flag" ng-if="row.entity.stdCode == null">flag</i>{{row.entity.stdResult}}</span></div>'
                        }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApiSubject = gridApi;
                    $scope.gridSelectCount = $scope.gridApiSubject.selection.getSelectedRows().length;
                    var onRowsRenderedOff = gridApi.core.on.rowsRendered(null, function () {
                        onRowsRenderedOff(); // run once
                        PWC.triggerRowSelectOnClick('#etsGrid'); // requires '.ui-grid-canvas'
                    });
                    // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                    $interval(function () {
                        $scope.gridApiSubject.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };
        };

        var loadReportGridOptions = function () {
            //明细数据弹出框中的关联报表tab下的grid
            $scope.reportGridOptions = {
                rowHeight: 28,
                selectionRowHeaderWidth: 28,
                enableFullRowSelection: false,
                enableRowSelection: false,
                enableSorting: false,
                enableFiltering: false,
                enableColumnMenus: false,
                enableColumnResizing: true,
                enableRowHeaderSelection: false,
                enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                columnDefs: [
                    {
                        field: 'templateName', name: $translate.instant('TemplateName'), width: '20%', headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.templateName}}">{{row.entity.templateName}}<span></div>'
                    },
                    {
                        field: 'serviceTypeName', name: $translate.instant('ServiceTypeName'), width: '20%', headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.serviceTypeName}}">{{row.entity.serviceTypeName}}<span></div>'
                    },
                    {
                        field: 'cell', name: $translate.instant('Cell'), width: '10%', headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.cell}}">{{row.entity.cell}}</span></div>'
                    },
                    {
                        field: 'rowName', name: $translate.instant('RowName'), width: '15%', headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.rowName}}">{{row.entity.rowName}}</span></div>'
                    },
                    {
                        field: 'columnName', name: $translate.instant('ColumnName'), width: '15%', headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.columnName}}">{{row.entity.columnName}}</span></div>'
                    },
                    {
                        field: 'formula', name: $translate.instant('Formula'), width: '20%', headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.formula}}">{{row.entity.formula}}</span></div>'
                    }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;
                    // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };
        };

        (function initializa() {

            $log.debug('SubjectCorrespondingController.ctor()...');

            $scope.stdAccountsCategories = [];
            $scope.selectedOrgName = '';
            $scope.selectedOrgID = '';
            $scope.checkedSet = {};
            $scope.selectedCopyOrgIDList = [];
            $scope.selectedOrg = {};

            $scope.directionList = [
                { id: 1, name: $translate.instant('StandardAccountDebit') },
                { id: -1, name: $translate.instant('StandardAccountCredit') },
            ];

            $scope.acctPropList = [
                { id: 1, name: $translate.instant('StandardAccountAcctPropAsset') },
                { id: 2, name: $translate.instant('StandardAccountAcctPropDebt') },
                { id: 3, name: $translate.instant('StandardAccountAcctPropCommon') },
                { id: 4, name: $translate.instant('StandardAccountAcctPropInterest') },
                { id: 5, name: $translate.instant('StandardAccountAcctPropCost') },
                { id: 6, name: $translate.instant('StandardAccountAcctPropProfitAndLoss') },
            ];

            loadEnterpriseAccountListOptions();
            loadStdAccountListOptions();
            loadReportGridOptions();
            loadOrgCheckboxTreeViewSettings();

            loadOrgMultiData();
            InitStdSubject();
            InitNgData();

            $scope.mapStdAccount = mapStdAccount;
            $scope.showDetail = showDetail;
            $scope.copyMappingCheck = copyMappingCheck;
            $scope.InitFilterAccount = InitFilterAccount;
            $scope.LoadEtsSubjectBySelectedOrg = LoadEtsSubjectBySelectedOrg;
            $scope.LoadEtsSubjectBySelectedAccpSetID = LoadEtsSubjectBySelectedAccpSetID;
            $scope.ClearMap = ClearMap;
            $scope.otherAwesomeCallbackSpan = otherAwesomeCallbackSpan;
            $scope.accountFilterChanged = accountFilterChanged;
            $scope.InitStdSubjectLinkEtsSubject = InitStdSubjectLinkEtsSubject;

            orgService.getOrgList(0).success(function (data) {
                if ($scope.selectNoOption) {
                    data.splice(0, 0, NoOptions);
                }
                $scope.selectedOrgName = data[0].name;
                $scope.selectedOrgID = data[0].id;
            });

            //初始化右侧标准科目的树,使用jquery fancytree的方式来显示树，所以需要用到ajax的方式
            //var stdAccountUrl = loginContext.apiHost + constant.webapi.prefix + '/stdAccount/stdAccountHierarchy?orgID=' + $scope.selectedOrgID;
            //commonWebService.initFancyTree('treetable', stdAccountUrl);

        })();
    }]);