﻿
citModule.controller('citCaculateDataController', ['$scope', '$log', '$timeout', '$q', '$http', '$sce', '$translate', 'loginContext',
    'apiInterceptor', 'Upload', 'dataImportService', 'ackMessageBox', 'vatReductionService', 'vatSessionService', 'citSessionService', 'uiGridConstants',
    'enums', 'modelConfigurationService', 'vatReportService', 'vatCommonService', 'vatWorkflowService', 'BSPLService', 'vatOperationLogService', 'apiConfig', 'dataProcessService',
function ($scope, $log, $timeout, $q, $http, $sce, $translate, loginContext, apiInterceptor, Upload, dataImportService, ackMessageBox,
    vatReductionService, vatSessionService, citSessionService, uiGridConstants, enums, modelConfigurationService, vatReportService, vatCommonService,
    vatWorkflowService, BSPLService, vatOperationLogService, apiConfig, dataProcessService) {
    'use strict';
    $log.debug('citCaculateDataController.ctor()...');

    $scope.serviceType = enums.serviceType.CIT;

    //********************************  SignalR 页面状态维护处理 Start  ********************************
    //页面唯一标识, 用来维护处理 项目状态信息的标识
    $scope.uid_page = PWC.newGuid();
    $scope.isStartProcData = false;//是否标识是当前页面在处理数据


    //启动状态更新任务
    dataProcessService.startJob();

    //进度条更新计算
    function calcProgress(name) {

        var curTaskProgress = _.findWhere(allTaskProgressList, { taskName: name });
        if (!_.isEmpty(curTaskProgress)) {
            setTaskProgress(curTaskProgress);
        }
    }

    function stateReset() {
        $scope.readonly = false;//正常可点击状态
        $scope.isStartProcData = false;
        $scope.curTaskProgress = null;
    }

    var hub = $.connection.reportUpdateHub;
    //接收服务端的消息，更新当前页面状态
    hub.client.reportUpdate = function (projectId, period, tplId, status) {
        if (projectId == vatSessionService.project.id && 0 == period) {

            if (vatSessionService.project.id == tplId) {
                //如果是项目开始按钮执行，禁用处理按钮
                if (status == enums.projectProcStatus.Normal) {
                    stateReset();
                } else if (status == enums.projectProcStatus.Processing) {
                    //如果是项目处理中状态，禁用处理按钮， 更新模板状态
                    $scope.readonly = true;
                } else if (status == enums.projectProcStatus.Generated) {
                    stateReset();
                }
                return;
            }

            var item = _.findWhere($scope.tasks, { name: tplId });
            if (item) {
                var statusTmp = "";
                switch (status) {
                    case enums.projectProcStatus.Error:
                        statusTmp = 'error';
                        break;
                    case enums.projectProcStatus.Normal:
                        statusTmp = 'unstarted';
                        break;
                    case enums.projectProcStatus.Processing:
                        statusTmp = 'processing';
                        break;
                    case enums.projectProcStatus.Generated:
                        statusTmp = 'completed';
                        break;
                    case enums.projectProcStatus.Audited:
                        statusTmp = 'audited';
                        break;
                    case enums.projectProcStatus.Done:
                        statusTmp = 'done';
                        break;
                }
                item.status = statusTmp;
                item.text = $translate.instant(statusTmp);

                calcProgress(item.name);
            }
        }
    };
    //正在处理中的页面异常中断，需要重新获取状态
    hub.client.procUnloadPage = function (projectId, period) {
        if (projectId == vatSessionService.project.id && 0 == period) {
            //setTimeout(getReportStatus, 1000);
            $scope.curTaskProgress = null;
        }
    };
    //启动
    $.connection.hub.start();


    //断线异常处理
    $.connection.hub.disconnected(function () {
        $log.warn("connection hub.server disconnected...");

        $scope.curTaskProgress = null;
    });
    //错误异常处理
    $.connection.hub.error(function (error) {
        console.log('SignalR error: ' + error);

        $scope.curTaskProgress = null;
    });



    //页面断开连接处理
    window.onbeforeunload = function (e) {
        //发送状态处理
        if ($scope.isStartProcData) {
            //如果是当前页面在处理数据，那么需要发出页面异常中断请求，通知其他客户端
            hub.server.procUnloadPage(vatSessionService.project.id, 0, vatSessionService.project.dbName + '@cn.pwc.com');
        }
    };

    //同步更新报表状态
    var updateStatusSync = function (tplId, status) {
        //当前客户端推送报表更新信息到 其他相同的客户端
        //项目id 和 period 
        //如果判断的是修改项目的处理状态
        var exceptSelf = true;
        //if (vatSessionService.project.id == tplId) {
        //    exceptSelf = false;//如果修改了项目状态本身，那么都要通知到每个页面的更新(包括自身页面)
        //}
        //添加新的需要更新状态的项目模板
        dataProcessService.addJob($scope.serviceType, tplId, 0, status);

        try {
            hub.server.reportUpdate(vatSessionService.project.id, 0, tplId, status, exceptSelf);
        } catch (e) {
            $log.warn("reportUpdate: hub.server disconnected...");
        }

    };

    function getStatus(strStatus) {
        var statusTmp;
        switch (strStatus) {
            case 'error':
                statusTmp = enums.projectProcStatus.Error;
                break;
            case 'unstarted':
                statusTmp = enums.projectProcStatus.Normal;
                break;
            case 'processing':
                statusTmp = enums.projectProcStatus.Processing;
                break;
            case 'completed':
                statusTmp = enums.projectProcStatus.Generated;
                break;
            case 'audited':
                statusTmp = enums.projectProcStatus.Audited;
                break;
            case 'done':
                statusTmp = enums.projectProcStatus.Done;
                break;
        }
        return statusTmp;
    }



    dataProcessService.startHeartBeat($scope.serviceType, vatSessionService.project.id, 0, getStatus('completed'), getReportStatus);


    //********************************  SignalR 页面状态维护处理 End  ********************************
    function getErrorMsg(data) {
        var res = "系统发生异常，请联系管理员！";
        //return data.data.Message;//可能这样写
        if (data) {
            if (data.message) {
                res = data.message;
            } else {
                res = data.statusText;
            }
        }
        return res;
    }
    var taskList = [];
    var reportTemplates = [];
    var allTaskProgressList = [];
    var reportSteps = ['DataProcessDataName_UpdateReportConfig', 'DataProcessDataName_CITFirstQuarterly',
            'DataProcessDataName_CITSecondQuarterly', 'DataProcessDataName_CITThirdQuarterly', 'DataProcessDataName_CITForthQuarterly',
            'DataProcessDataName_YearWorkPaper', 'DataProcessDataName_AnnualSettlement'];

    var initTasks = function () {
        var task = function (id, status, name, tasklevel, parentId, hasButton, seqNo) {
            this.id = id;
            this.name = _.isEmpty(name) ? id : name;
            this.status = status;
            this.text = $translate.instant(status);
            this.tasklevel = tasklevel;
            this.parentId = parentId;
            this.hasButton = hasButton;
            this.btTitle = '';
            this.isSelected = false;
            this.seqNo = seqNo; //seqNo控制执行的顺序：相同seqNo同时执行；seqNo越大越后面执行

            this.showError = false;
            this.errorMsg = "";
        };
        task.prototype.doTask = function ($event) {
            var _this = this;
            var intervalTime = 2 * 1000;
            var button = $event.target;
            var curTaskProgress = _.findWhere(allTaskProgressList, { taskName: _this.name });
            if (!_.isEmpty(curTaskProgress)) {
                setTaskProgress(curTaskProgress);
            }

            //执行任务时候，通知状态更新
            updateStatusSync(_this.name, getStatus('processing'));

            switch (_this.name) {
                //    case '生成标准科目余额表':
                //        setTimeout(function () { }, 5000);
                //        break;
                //    case '未开票销售对比':
                //        setTimeout(function () { }, 5000);
                //        break;
                //    case '未开票税额计算':
                //        setTimeout(function () { }, 5000);
                //        break;
                case 'DataProcessDataName_UpdateTB': // 科目对应
                    vatReductionService.submitAccountMappingNoLoading(enums.vatReMapType.ReMapVoucher, enums.vatReMapType.ReMapCust, -1).success(function (data) {
                        data.result = true;
                        updateProgress(data, _this, $event);
                    }).error(function (res) {
                        _this.errorMsg = getErrorMsg(res);

                        taskError(_this, $event);
                    });

                    break;
                case 'DataProcessDataName_ModelAnalysis': // 模型分析
                    // TODO: DCH Demo
                    if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                        setTimeout(function () { updateProgress(true, _this, $event); }, intervalTime);
                    }
                    else {
                        modelConfigurationService.getModelResult(vatSessionService.project.id, enums.serviceType.CIT).success(function (data) {
                            modelConfigurationService.migrateModelResult(vatSessionService.project.organizationID, vatSessionService.project.year, vatSessionService.project.id, vatSessionService.project.serviceTypeID).success(function (data) {
                                data.result = true;
                                updateProgress(data, _this, $event);
                            }).error(function (res) {
                                _this.errorMsg = getErrorMsg(res);
                                taskError(_this, $event);
                            });
                        }).error(function (res) {
                            _this.errorMsg = getErrorMsg(res);
                            taskError(_this, $event);
                        });
                    }

                    break;
                case 'DataProcessDataName_UpdateReportConfig': // 报表配置更新
                    //$timeout(function () {
                    //    $q.when().then(function () {
                    //        var data = { result: true };
                    //        updateProgress(data, _this, $event);
                    //    }, function () {
                    //        taskError(_this, $event);
                    //    });
                    //}, 10000);
                    // TODO: DCH Demo
                    if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                        setTimeout(function () { updateProgress(true, _this, $event); }, intervalTime);
                    }
                    else {
                        $log.info("报表配置更新 Start...");
                        vatReportService.citUpdateConfig(vatSessionService.project.id, $scope.ifDeleteManualDataSource, enums.wholeYearPeriod.report, vatSessionService.logUser.ID)
                            .then(function (data) {
                                $log.debug("vatReportService.citUpdateConfig");
                                if (data && data.data) {
                                    if (data.data.result) {
                                        calcValidationAfterReportGenerated(_this).then(function (data) {
                                            if (data && data.result) {
                                                $log.info("OK: 报表配置更新 Success..." );
                                                updateProgress(data.result, _this, $event);
                                            } else {
                                                taskError(_this, $event);
                                                $log.info("Error: calcValidationAfterReportGenerated Error..." + JSON.stringify(data));
                                            }
                                        });
                                    }
                                    else {
                                        if (data.data.resultMsg) {
                                            ackMessageBox.info($translate.instant(data.data.resultMsg));
                                            _this.errorMsg = data.data.resultMsg;
                                        }

                                        $log.info("Error: citUpdateConfig Error...");
                                        taskError(_this, $event);
                                    }
                                }
                            }, function (data) {
                                if (data && data.data && !data.data.result && data.data.resultMsg) {
                                    ackMessageBox.info($translate.instant(data.resultMsg));
                                }
                                $log.info("Error: 报表配置更新--" + data);
                                _this.errorMsg = getErrorMsg(data);
                                taskError(_this, $event);
                            });
                    }

                    break;
                case 'DataProcessDataName_FinanceReport': // 财务报表
                    // TODO: DCH Demo
                    if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                        setTimeout(function () { updateProgress(true, _this, $event); }, intervalTime);
                    }
                    else {
                        BSPLService.GenerateBSPLWithoutLoading(vatSessionService.project.id, enums.wholeYearPeriod.report)
                            .then(function (data) {
                                $log.debug("BSPLService.generateBSPLWithoutLoading");
                                if (data && data.data && data.data.result) {
                                    updateProgress(data.data.result, _this, $event);
                                } else {
                                    _this.errorMsg = data.data.resultMsg;
                                    taskError(_this, $event);
                                }
                            }, function (res) {
                                _this.errorMsg = getErrorMsg(res);
                                taskError(_this, $event);
                            });
                    }
                    break;
                case 'DataProcessDataName_CITFirstQuarterly': // 季度预缴表，报表类型为2
                    calcPrepay(_this, $event, 1);
                    break;
                case 'DataProcessDataName_CITSecondQuarterly': // 季度预缴表，报表类型为2
                    calcPrepay(_this, $event, 2);
                    break;
                case 'DataProcessDataName_CITThirdQuarterly': // 季度预缴表，报表类型为2
                    calcPrepay(_this, $event, 3);
                    break;
                case 'DataProcessDataName_CITForthQuarterly': // 季度预缴表，报表类型为2
                    calcPrepay(_this, $event, 4);
                    break;
                case 'DataProcessDataName_YearWorkPaper': // 工作底稿，报表类型为3
                case 'Schedule 1 - Tax Payable': // For DCH demo
                    // TODO: DCH Demo
                    if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                        setTimeout(function () { updateProgress(true, _this, $event); }, intervalTime);
                    }
                    else {
                        $log.info("工作底稿 Start...");
                        vatReportService.citGenerateByType(vatSessionService.project.id, $scope.ifDeleteManualDataSource, 3, vatSessionService.logUser.ID)
                            .then(function (data) {
                                $log.debug("vatReportService.citGenerateByType,工作底稿");
                                if (data && data.data) {
                                    if (data.data.result) {
                                        vatReportService.citCalculateKeyValue(vatSessionService.project.id, 3).then(function (data) {
                                            $log.debug("vatReportService.citCalculateKeyValue, 工作底稿");
                                            if (data && data.data && data.data.result) {
                                                calcValidationAfterReportGenerated(_this).then(function (data) {
                                                    if (data && data.result) {
                                                        updateProgress(data.result, _this, $event);
                                                        $log.debug("calcValidationAfterReportGenerated  updateProgress, 工作底稿 Success");
                                                    } else {
                                                        $log.debug("calcValidationAfterReportGenerated error:, 工作底稿 error");
                                                        taskError(_this, $event);
                                                    }
                                                });
                                            }
                                        });
                                    }
                                    else {
                                        if (data.data.resultMsg) {
                                            ackMessageBox.info($translate.instant(data.data.resultMsg));

                                            _this.errorMsg = data.data.resultMsg;
                                        }
                                        taskError(_this, $event);
                                    }
                                } else {
                                    if (data.data && data.data.resultMsg) {
                                        _this.errorMsg = data.data.resultMsg;
                                    }
                                    taskError(_this, $event);
                                }
                            }, function (data) {
                                if (data && data.data && !data.data.result && data.data.resultMsg) {
                                    ackMessageBox.info($translate.instant(data.data.resultMsg));
                                }

                                _this.errorMsg = getErrorMsg(data);
                                taskError(_this, $event);
                            });
                    }

                    break;
                case 'DataProcessDataName_AnnualSettlement': // 纳税申报表，报表类型为1
                case 'HK Profits Tax Return': // For DCH demo
                    // TODO: DCH Demo
                    if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                        setTimeout(function () { updateProgress(true, _this, $event); }, intervalTime);
                    }
                    else {
                        vatReportService.citGenerateByType(vatSessionService.project.id, $scope.ifDeleteManualDataSource, 1, vatSessionService.logUser.ID)
                            .then(function (data) {
                                $log.debug("vatReportService.citGenerateByType,纳税申报表");
                                if (data && data.data) {
                                    if (data.data.result) {
                                        vatReportService.citCalculateKeyValue(vatSessionService.project.id, 1).then(function (data) {
                                            $log.debug("vatReportService.citCalculateKeyValue, 纳税申报表");
                                            if (data && data.data && data.data.result) {
                                                calcValidationAfterReportGenerated(_this).then(function (data) {
                                                    if (data && data.result) {
                                                        updateProgress(data.result, _this, $event);
                                                    } else {
                                                        $log.debug("calcValidationAfterReportGenerated , 纳税申报表 Error...");
                                                        taskError(_this, $event);
                                                    }
                                                });
                                            }
                                        });
                                    }
                                    else {
                                        if (data.data.resultMsg) {
                                            ackMessageBox.info($translate.instant(data.data.resultMsg));
                                            _this.errorMsg = data.data.resultMsg;
                                        }

                                        taskError(_this, $event);
                                    }
                                } else {
                                    if (data.data && data.data.resultMsg) {
                                        _this.errorMsg = data.data.resultMsg;
                                    }
                                    taskError(_this, $event);
                                }
                            }, function (data) {
                                if (data && data.data && !data.data.result && data.data.resultMsg) {
                                    ackMessageBox.info($translate.instant(data.data.resultMsg));
                                }

                                _this.errorMsg = getErrorMsg(data);
                                taskError(_this, $event);
                            });
                    }

                    break;
                default:
                    setTimeout(function () { updateProgress(true, _this, $event); }, intervalTime);

                    break;
            };
        };

        task.prototype.name = null;
        task.prototype.id = null;
        task.prototype.status = null;
        task.prototype.text = null;
        task.prototype.tasklevel = 0;
        task.prototype.parentId = 0;
        task.prototype.hasButton = false;
        task.prototype.btTitle = '';
        task.prototype.isSelected = false;
        task.prototype.seqNo = -1;

        var result = [];
        var geMockData = vatSessionService.project.citDataProcessMockData;
        geMockData.forEach(function (item) {
            //switch (item.status) {
            //    case constant.DataProccessStatus.Unstarted:
            //        item.btTitle = $translate.instant('DataProcessData_Generate');
            //        if (item.name !== 'DataProcessDataName_GenerateReport'
            //            && item.name !== 'DataProcessDataName_CITQuarterly') {
            //            item.isSelected = true;
            //        }
            //        break;
            //    case constant.DataProccessStatus.ToUpdate:
            //        item.btTitle = $translate.instant('DataProcessData_Update');
            //        item.isSelected = true;
            //        break;
            //    case constant.DataProccessStatus.Completed:
            //        item.btTitle = $translate.instant('DataProcessData_Update');
            //        item.isSelected = false;
            //        break;
            //    case constant.DataProccessStatus.Error:
            //        item.btTitle = $translate.instant('DataProcessData_Update');
            //        item.isSelected = false;
            //        break;
            //    default:
            //        item.isSelected = false;
            //}

            var newTask = new task(item.id, constant.DataProccessStatus.Unstarted, item.name, item.tasklevel, item.parentId, item.hasButton, item.seqNo);
            newTask.btTitle = $translate.instant('DataProcessData_Generate');// item.btTitle;
            newTask.isSelected = true;//item.isSelected;
            result.push(newTask);
        });

        taskList = result;
        $scope.tasks = result;


        //检查当前项目的生成状态并同步状态
        getReportStatus();
    };

    var setTaskProgress = function (taskProgress) {
        if (_.isEmpty(taskProgress)) {
            $scope.curTaskProgress = null;
            return;
        }

        $scope.curTaskProgress = taskProgress.name;
        if (taskProgress.interval > 0) {
            $timeout(function () {
                if (taskProgress.name === $scope.curTaskProgress) {
                    var idx = _.findIndex(allTaskProgressList, { name: $scope.curTaskProgress });
                    if (idx >= 0 && idx < allTaskProgressList.length - 1) {
                        setTaskProgress(allTaskProgressList[idx + 1]);
                    }
                }
            }, taskProgress.interval);
        }
    };

    var startCaculate = function ($event) {
        //项目开始处理，发送通知
        updateStatusSync(vatSessionService.project.id, getStatus('processing'));
        $scope.readonly = true;

        var selectedTasks = _.where($scope.tasks, { isSelected: true });
        calValidation(selectedTasks).then(function () {
            return ackMessageBox.confirm($translate.instant('IfDeleteManualDataSource')).then(function (ifConfirm) {
                //开始日志
                writeLog({ name: $translate.instant('startCaculateData'), text: null });

                $scope.ifDeleteManualDataSource = !ifConfirm;
                _.each(selectedTasks, function (x) {
                    x.status = constant.DataProccessStatus.Unstarted;
                    x.text = $translate.instant(x.status);
                });

                //开始更新项目状态
                vatReportService.updateProjectStatus($scope.serviceType, vatSessionService.project.id, 0, enums.projectProcStatus.Normal, $scope.uid_page).then(function (resData) {
                    if (resData && resData.data.result) {
                        $scope.isStartProcData = true;
                        getReportStatus(function () {
                            var firstSelectedTask = selectedTasks[0];
                            if (!_.isUndefined(firstSelectedTask)) {
                                if (firstSelectedTask.status !== constant.DataProccessStatus.NoData) {
                                    firstSelectedTask.doTask($event);
                                    firstSelectedTask.status = constant.DataProccessStatus.Processing;
                                    firstSelectedTask.text = $translate.instant(firstSelectedTask.status);
                                }
                            }
                        });
                    } else {
                        SweetAlert.error($translate.instant('UpdateFailed'));
                    }
                });


            });
        }, function (reason) {
            if (!_.isEmpty(reason)) {
                ackMessageBox.warning(reason);
            }
        });
    };

    // TODO: I18N
    var initTaskProgressList = function () {
        // TODO: DCH Demo
        if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
            return;
        }

        allTaskProgressList = [{
            name: '清除旧报表模板数据', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '同步报表模板数据', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '将公式解析成公式块', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '获取报表间引用关系', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '初始化报表', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '清除旧报表数据', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '计算静态公式块', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '计算静态单元格', taskName: 'DataProcessDataName_UpdateReportConfig', interval: 2000
        }, {
            name: '整理静态公式计算结果', taskName: 'DataProcessDataName_UpdateReportConfig', interval: -1
        }, {
            name: '计算资产负债表', taskName: 'DataProcessDataName_FinanceReport', interval: 6000
        }, {
            name: '计算利润表', taskName: 'DataProcessDataName_FinanceReport', interval: 6000
        }, {
            name: '整理财务报表计算结果', taskName: 'DataProcessDataName_FinanceReport', interval: -1
        }, {
            name: '指标分析模型计算', taskName: 'DataProcessDataName_ModelAnalysis', interval: 25000
        }, {
            name: '分录比对模型计算', taskName: 'DataProcessDataName_ModelAnalysis', interval: 25000
        }, {
            name: '模型计算结果归集', taskName: 'DataProcessDataName_ModelAnalysis', interval: -1
        }, {
            name: '计算第一季度预缴表', taskName: 'DataProcessDataName_CITFirstQuarterly', interval: -1
        }, {
            name: '计算第二季度预缴表', taskName: 'DataProcessDataName_CITSecondQuarterly', interval: -1
        }, {
            name: '计算第三季度预缴表', taskName: 'DataProcessDataName_CITThirdQuarterly', interval: -1
        }, {
            name: '计算第四季度预缴表', taskName: 'DataProcessDataName_CITForthQuarterly', interval: -1
        }, {
            name: '生成标准科目余额表', taskName: 'DataProcessDataName_UpdateTB', interval: -1
        }];

        if (!_.isEmpty(reportTemplates)) {
            allTaskProgressList = allTaskProgressList.concat(_.chain(reportTemplates).where({ reportType: 3 }).map(function (x) {
                return {
                    name: '生成' + x.templateCode + '-' + x.templateName, taskName: 'DataProcessDataName_YearWorkPaper', interval: 5000
                };
            }).value());
            allTaskProgressList.push({
                name: '整理工作底稿计算结果', taskName: 'DataProcessDataName_YearWorkPaper', interval: -1
            });
            allTaskProgressList = allTaskProgressList.concat(_.chain(reportTemplates).where({ reportType: 1 }).map(function (x) {
                return {
                    name: '生成' + x.templateCode + '-' + x.templateName, taskName: 'DataProcessDataName_AnnualSettlement', interval: 5000
                };
            }).value());
            allTaskProgressList.push({
                name: '整理年度汇算清缴计算结果', taskName: 'DataProcessDataName_AnnualSettlement', interval: -1
            });
        }
    };

    var startRowCalculate = function (row, $event) {
        var selectedTasks = _.where($scope.tasks, { id: row.id });
        var selectedTask;
        if (_.isEmpty(selectedTasks)) {
            return;
        }

        var selectedTask = selectedTasks[0];
        calValidation(selectedTasks).then(function () {
            return ackMessageBox.confirm($translate.instant('IfDeleteManualDataSource')).then(function (ifConfirm) {
                $scope.ifDeleteManualDataSource = !ifConfirm;
                selectedTask.status = constant.DataProccessStatus.Unstarted;
                selectedTask.text = $translate.instant(selectedTask.status);
                selectedTask.doTask($event);
                selectedTask.status = constant.DataProccessStatus.Processing;
                selectedTask.text = $translate.instant(selectedTask.status);
            });
        }, function (reason) {
            if (!_.isEmpty(reason)) {
                ackMessageBox.warning(reason);
            }
        });
    };

    var caculateProgress = function (task, $event) {
        var allSelectedTasks = _.where($scope.tasks, { isSelected: true });
        if (_.isUndefined(allSelectedTasks))
            return;

        // 如果所有选中的项均已完成
        if (!_.some(allSelectedTasks, function (s) {
            return s.status !== constant.DataProccessStatus.Completed && s.status !== constant.DataProccessStatus.Error && s.id !== 2 && s.id !== 5;
        })) {
            var geMockData = vatSessionService.project.citDataProcessMockData;
            var ifComplete = false;
            // TODO: DCH Demo
            if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                ifComplete = _.some(geMockData, function (x) {
                    return (x.name === 'DataProcessDataName_UpdateReportConfig' || x.name.indexOf('Schedule ') === 0
                        || x.name === 'HK Profits Tax Return' || x.name.indexOf('DataProcessDataName_CIT') >= 0 && x.name.indexOf('Quarterly') >= 0)
                        && x.status === constant.DataProccessStatus.Completed;
                })
            }
            else {
                ifComplete = _.some(geMockData, function (x) {
                    return (x.name === 'DataProcessDataName_UpdateReportConfig' || x.name === 'DataProcessDataName_YearWorkPaper'
                        || x.name === 'DataProcessDataName_AnnualSettlement' || x.name.indexOf('DataProcessDataName_CIT') >= 0 && x.name.indexOf('Quarterly') >= 0)
                        && x.status === constant.DataProccessStatus.Completed;
                })
            }

            if (ifComplete) {
                vatCommonService.setProjectStatus(vatSessionService.project.dbName, enums.wholeYearPeriod.import, constant.ProjectStatusEnum.Generated,
                    constant.DictionaryDictKey.WFDataProcess, enums.FinishStatusEnum.Finished, true);

                $scope.readonly = false;//正常可点击状态
                //完成状态通知
                updateStatusSync(vatSessionService.project.id, getStatus('completed'));
            }
            else if (_.some(geMockData, function (x) {
                return x.name === 'DataProcessDataName_UpdateTB' && x.status === constant.DataProccessStatus.Completed;
            })) {
                vatCommonService.setProjectStatus(vatSessionService.project.dbName, enums.wholeYearPeriod.import, constant.ProjectStatusEnum.AccountMapSubmitted
                    , constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.Finished);
            }

            return;
        }

        var maxSeqNo = _.max(allSelectedTasks, function (s) { return s.seqNo });
        if (task.seqNo <= maxSeqNo.seqNo) {
            var currentTasks = _.filter($scope.tasks, function (s) {
                return s.seqNo === task.seqNo && s.isSelected === true && s.status !== constant.DataProccessStatus.NoData;
            });

            var unfinishedCurrentTasks = _.filter(currentTasks, function (s) {
                return s.id > task.id && s.status != constant.DataProccessStatus.Processing;
            });

            if (!_.isEmpty(unfinishedCurrentTasks)) {
                unfinishedCurrentTasks[0].doTask($event);
                unfinishedCurrentTasks[0].status = constant.DataProccessStatus.Processing;
                unfinishedCurrentTasks[0].text = $translate.instant(unfinishedCurrentTasks[0].status);
            }

            //只有点击'开始处理'按钮时，才会执行后续任务
            if ($event.target.id === 'calAll') {
                var finish = currentTasks.every(function (s) {
                    return s.status != constant.DataProccessStatus.Processing;
                });

                if (finish) {
                    for (var i = task.seqNo; i < maxSeqNo.seqNo; i++) {
                        var t = _.find($scope.tasks, function (s) {
                            return s.seqNo === i + 1 && s.isSelected === true && s.status !== constant.DataProccessStatus.NoData
                                && s.status !== constant.DataProccessStatus.Processing && s.id !== 2 && s.id !== 5; //'生成报表'和'所得税季度预缴表'只是个label,不用执行
                        });
                        if (!_.isUndefined(t)) {
                            t.doTask($event);
                            t.status = constant.DataProccessStatus.Processing;
                            t.text = $translate.instant(t.status);
                            break;
                        }
                    }
                }
            }
        }
    };

    var updateProgress = function (data, task, $event) {
        if (data) { //任务执行成功
            task.status = constant.DataProccessStatus.Completed;
            task.text = $translate.instant(task.status);
            task.btTitle = $translate.instant('DataProcessData_Update');
        }
        else {//失败
            task.status = constant.DataProccessStatus.Error;
            task.text = $translate.instant(task.status);
            task.btTitle = $translate.instant('DataProcessData_Update');
        }

        updateStatusSync(task.name, getStatus(task.status));

        var crtData = _.where(vatSessionService.project.citDataProcessMockData, { id: task.id })[0];
        if (!_.isUndefined(crtData)) {
            crtData.status = task.status;
            vatSessionService.updateObjectProperty('project', 'citDataProcessMockData', vatSessionService.project.citDataProcessMockData);
        }
        setTaskProgress(null);
        caculateProgress(task, $event);

        writeLog(task);

    };

    var taskError = function (task, $event) {
        task.status = constant.DataProccessStatus.Error;
        task.text = $translate.instant(task.status);
        //
        $log.info("Error: " + task.name + "--" + task.status);
        updateStatusSync(task.name, getStatus(task.status));

        setTaskProgress(null);
        caculateProgress(task, $event);
        //SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        writeLog(task);
    };

    var stateChanged = function ($event, row) {
        //$scope.filter.selected = [];
        var checkbox = $event.target;
        var selectedRow = _.where($scope.tasks, { id: row.id })[0];
        if (!_.isUndefined(selectedRow)) {
            if (checkbox.checked) {
                selectedRow.isSelected = true;
            }
            else {
                selectedRow.isSelected = false;
            }
            selectChildRecursively(selectedRow);
            updateParent(selectedRow);
        }
    };

    var onCheckAllStateChanged = function ($event) {
        var checkbox = $event.target;
        $scope.tasks.forEach(function (item) {
            item.isSelected = checkbox.checked;
        });
    };

    var calcPrepay = function (task, $event, period) {
        // TODO: DCH Demo
        if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
            setTimeout(function () { updateProgress(true, task, $event); }, intervalTime);
        }
        else {
            vatReportService.citGeneratePrepay(vatSessionService.project.id, $scope.ifDeleteManualDataSource, period, vatSessionService.logUser.ID)
                .then(function (data) {
                    $log.debug("vatReportService.citGeneratePrepay, 季度预缴表: " + period);
                    if (data && data.data) {
                        if (data.data.result) {
                            calcValidationAfterReportGenerated(task).then(function (data) {
                                if (data && data.result) {
                                    updateProgress(data.result, task, $event);
                                } else {
                                    task.errorMsg = data.resultMsg;
                                    taskError(task, $event);
                                }
                            });
                        }
                        else {
                            if (data.data.resultMsg) {
                                ackMessageBox.info($translate.instant(data.data.resultMsg));
                            }

                            task.errorMsg = data.data.resultMsg;
                            taskError(task, $event);
                        }
                    }
                }, function (data) {
                    if (data && data.data && !data.data.result && data.data.resultMsg) {
                        ackMessageBox.info($translate.instant(data.data.resultMsg));
                    }

                    task.errorMsg = getErrorMsg(data);
                    taskError(task, $event);
                });
        }
    };

    // 当勾选了报表且报表数据均已生成完成，计算校验
    var calcValidationAfterReportGenerated = function (task) {
        if (!_.some($scope.tasks, function (x) {
            return x.isSelected && reportSteps.indexOf(x.name) >= 0 && x !== task
                && x.status !== constant.DataProccessStatus.Completed
                && x.status !== constant.DataProccessStatus.Error
        })) {
            return vatReportService.calculateValidation(vatSessionService.project.id, enums.serviceType.CIT, 0).then(function (data) {
                return $q.when(data && data.data);
            });
        }
        else {
            return $q.when({ result: true });
        }
    };

    var getAlertReportMsg = function (warningReports) {
        var submittedReports = _.where(warningReports, { 'operationTypeID': enums.vatLogOperationTypeEnum.SubmitReport });
        var approvedReports = _.where(warningReports, { 'operationTypeID': enums.vatLogOperationTypeEnum.ApproveReport });
        var reportListStr = '';
        if (!_.isEmpty(approvedReports)) {
            reportListStr += '<div>' + $translate.instant('CheckListOTApproved') + ':</div><ul>';
            reportListStr += _.reduce(approvedReports, function (memo, x) {
                memo = memo + '<li>' + x.templateCode + '-' + x.templateName + '</li>';
                return memo;
            }, '');
            reportListStr += '</ul>';
        }
        if (!_.isEmpty(submittedReports)) {
            reportListStr += '<div>' + $translate.instant('CheckListOTSubmitted') + ':</div><ul>';
            reportListStr += _.reduce(submittedReports, function (memo, x) {
                memo = memo + '<li>' + x.templateCode + '-' + x.templateName + '</li>';
                return memo;
            }, '');
            reportListStr += '</ul>';
        }
        reportListStr = '<div class="report-list">' + reportListStr + '</div>';
        return reportListStr;
    };

    function calValidation(selectedTasks) {
        if (!_.isEmpty(selectedTasks)) {
            var reportTypes = [];

            // TODO: DCH Demo
            if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                if (_.some(selectedTasks, function (x) {
                    return x.name === 'Schedule 1 - Tax Payable';
                })) {
                    reportTypes.push(enums.reportType.taxReturn);
                }

                if (_.some(selectedTasks, function (x) {
                    return x.name === 'HK Profits Tax Return';
                })) {
                    reportTypes.push(enums.reportType.workingPaper);
                }
            }
            else {
                if (_.some(selectedTasks, function (x) {
                    return x.name === 'DataProcessDataName_AnnualSettlement';
                })) {
                    reportTypes.push(enums.reportType.taxReturn);
                }

                if (_.some(selectedTasks, function (x) {
                    return x.name === 'DataProcessDataName_CITFirstQuarterly'
                        || x.name === 'DataProcessDataName_CITSecondQuarterly'
                        || x.name === 'DataProcessDataName_CITThirdQuarterly'
                        || x.name === 'DataProcessDataName_CITForthQuarterly';
                })) {
                    reportTypes.push(enums.reportType.prepay);
                }

                if (_.some(selectedTasks, function (x) {
                    return x.name === 'DataProcessDataName_YearWorkPaper';
                })) {
                    reportTypes.push(enums.reportType.workingPaper);
                }
            }

            if (!_.isEmpty(reportTypes)) {
                var reportTypeStr = reportTypes.join(',');
                var deferred = $q.defer(); // 是否继续保存，如果弹出框选否，则不继续
                vatWorkflowService.getWorkflowApproveReportLogs(vatSessionService.project.dbName, enums.wholeYearPeriod.import,
                    null, enums.serviceType.CIT, reportTypeStr).then(function (approvedReport) {
                        if (approvedReport && approvedReport.data && approvedReport.data.data) {
                            var warningReports = _.filter(approvedReport.data.data, function (x) {
                                return x.operationTypeID === enums.vatLogOperationTypeEnum.ApproveReport
                                    || x.operationTypeID === enums.vatLogOperationTypeEnum.SubmitReport;
                            });
                            if (_.isEmpty(warningReports)) { // 无已审核关联报表，直接保存
                                deferred.resolve(warningReports);
                            }
                            else {
                                var reportListStr = getAlertReportMsg(warningReports);
                                ackMessageBox.confirmWithContinue($translate.instant('IsConfirmRecalcuateRelatedApproved'), reportListStr, 'approval-report-confirm')
                                    .then(function (isConfirm) {
                                        if (isConfirm) {
                                            deferred.resolve(warningReports);
                                        } else {
                                            deferred.reject();
                                        }
                                    });
                            }
                        }
                        else {
                            deferred.reject();
                        }
                    }, function () {
                        deferred.reject();
                    });
                return deferred.promise;
            }
            else {
                return $q.when();
            }
        }
        else {
            return $q.reject($translate.instant('PleaseSelectAtLeastOneItem'));
        }
    }

    function getTopParent(row) {
        var parent = _.where($scope.tasks, { id: row.parentId })[0];
        if (!_.isUndefined(parent)) {
            if (parent.parentId > 0) {
                getTopParent(parent);
            }
            else {
                return parent;
            }
        }
    }

    function selectChildRecursively(row) {
        var children = _.where($scope.tasks, { parentId: row.id });
        if (children.length > 0) {
            children.forEach(function (item) {
                item.isSelected = row.isSelected;
                selectChildRecursively(item);
            });
        }
    };

    function updateParent(row) {
        var siblings = _.where($scope.tasks, { parentId: row.parentId });
        var parent = _.where($scope.tasks, { id: row.parentId })[0];
        var siblingsUnSelectedRows = _.where(siblings, { isSelected: false })[0];
        if (!_.isUndefined(parent)) {
            parent.isSelected = !_.isUndefined(siblingsUnSelectedRows) ? false : true;
            if (parent.tasklevel > 1) {
                updateParent(parent);
            }
        }
    }
    $scope.serviceType = enums.serviceType.CIT;
    $scope.period = 0;
    $scope.moduleid = enums.vatModuleEnum.Import_CalculateData;
    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    var writeLog = function (task) {
        var logDto = {};
        logDto.ModuleID = $scope.moduleid;
        logDto.CreatorID = vatSessionService.logUser.ID;
        logDto.OperationObject = $translate.instant('vatCaculateDataDesc');

        if (task.status == 'error') {
            logDto.Comment = task.errorMsg;
        } else {
            logDto.Comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年";
        }

        logDto.Period = 0;

        logDto.ServiceType = $scope.serviceType;

        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = task.name;
        logDto.OperationName = task.name;
        logDto.OperationType = enums.vatLogOperationTypeEnum.CalculateData;
        logDto.UpdateState = task.text == null ? '' : task.text;
        vatOperationLogService.addOperationLog(logDto);

    };

    var showItemName = function (itemName) {
        return $sce.trustAsHtml($translate.instant(itemName));
    };


    //获取当前项目的报表的实时生成状态
    function getReportStatus(callback) {
        vatReportService.getReportStatus(vatSessionService.project.id, 0).then(function (res) {
            if (res && res.data.result) {
                if (res.data.returnCode == enums.projectProcStatus.Processing) {
                    //生成中
                    $scope.readonly = true;
                } else if (res.data.returnCode == enums.projectProcStatus.Generated) {
                    //生成完成
                    $scope.readonly = false;
                    $scope.isStartProcData = false;
                }

                _.each($scope.tasks, function (itemTask) {
                    var item = _.findWhere(res.data.data, { templateId: itemTask.name });
                    if (item) {
                        var statusTmp = "";
                        switch (item.status) {
                            case enums.projectProcStatus.Normal:
                                statusTmp = 'unstarted';
                                break;
                            case enums.projectProcStatus.Processing:
                                statusTmp = 'processing';
                                break;
                            case enums.projectProcStatus.Generated:
                                statusTmp = 'completed';
                                break;
                            case enums.projectProcStatus.Audited:
                                statusTmp = 'audited';
                                break;
                            case enums.projectProcStatus.Done:
                                statusTmp = 'done';
                                break;
                        }
                        itemTask.status = statusTmp;//"error";
                        itemTask.text = $translate.instant(statusTmp);
                    }
                });
                //calcProgress();
            } else {
                //未生成
                $scope.readonly = false;
                $scope.isStartProcData = false;
            }
            if (callback) {
                callback();
            }
        });
    }

    var showMsg = function (t) {
        if (t.errorMsg == undefined || t.errorMsg == '' || t.errorMsg == null) {
            //
            vatOperationLogService.getErrorMsg(t.name).success(function (data) {
                if (data && data.result) {
                    t.errorMsg = data.resultMsg;
                }
            });
        }
        t.showError = true;
    };

    var hideMsg = function (t) {
        t.showError = false;
    };

    (function initialize() {
        $scope.readonly = false;
        $scope.progress = 0;
        $scope.ifDeleteManualDataSource = true;
        vatReportService.citGetTemplate(vatSessionService.project.id, enums.wholeYearPeriod.report).then(function (report) {
            if (report && report.data && report.data.data) {
                reportTemplates = _.sortBy(report.data.data, function (x) {
                    return x.templateCode;
                });

                reportTemplates.reverse();
            }

            initTasks();
            initTaskProgressList();
            var maxLevel = 0;
            var levels = _.pluck($scope.tasks, 'tasklevel');
            if (levels.length > 0) {
                maxLevel = _.max(levels);
            }
            _.each($scope.tasks, function (task) {
                if (task.tasklevel === maxLevel) {
                    updateParent(task);
                }
            });
        });

        $scope.startCaculate = startCaculate;
        $scope.onCheckAllStateChanged = onCheckAllStateChanged;
        $scope.stateChanged = stateChanged;
        $scope.startRowCalculate = startRowCalculate;
        $scope.showItemName = showItemName;
        $scope.showMsg = showMsg;
        $scope.hideMsg = hideMsg;

    })();
}
]);