﻿citModule.controller('citReportLayoutController', ['$scope', '$log', '$q', '$timeout', '$compile', 'loginContext',
    '$translate', '$location', 'vatSessionService', 'vatReportService', '$state', 'enums', 'checkListService',
    function ($scope, $log, $q, $timeout, $compile, loginContext, $translate, $location, vatSessionService, 
        vatReportService, $state, enums, checkListService) {
        'use strict';
        $log.debug('citReportLayoutController.ctor()...');

        $scope.$on('refreshCitGenerateReport', function (event, data) {
            loadTemplateMenu();
            $scope.isFirstMenu = false;
        });
        $scope.isFirstMenu = false;
        //var baseDFFilePath = '/app/df/code/pages/';
        var isLeaveTab = function () {
            var returnUrl = false;
            var project = vatSessionService.getProperty("project");
            if (project.hasDirtyReportData) {
                var a = confirm($translate.instant("LeaveReport"));
                if (a == true) {
                    project.hasDirtyReportData = false;
                    vatSessionService.setProperty("project", project);
                    returnUrl = true;
                }
                else {
                    returnUrl = false;
                }
            } else {
                returnUrl = true;
            }
            return returnUrl;

        };

        var gvalue = 1;
        var isCancel = false;
        $scope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
            var project = vatSessionService.getProperty("project");
            if (project.hasDirtyReportData) {
                if (gvalue == 1) {
                    gvalue = 0;
                    var a = confirm($translate.instant("LeaveReport"));
                    isCancel = a;
                    $timeout(function () {
                        gvalue = 1;
                    }, 1000)
                    if (a == true) {
                        project.hasDirtyReportData = false;
                        vatSessionService.setProperty("project", project);
                    } else {
                        event.preventDefault();
                    }
                } else if (!isCancel) {
                    event.preventDefault();
                }
            }

            _.each($scope.menuTreeDataSource, function (item) {
                item.selected = false;
        });


            if (toState.name != 'cit.generateReport.performOCR') {
                var id = _.find($scope.menuTreeDataSource, function (item) { return item.id == toParams.id });
                if (id) {
                    id.selected = true;
                }
            }
            else {
                var id = _.find($scope.menuTreeDataSource, function (item) { return item.id == 'performOCR' });
                if (id) {
                    id.selected = true;
                    $("[data-item-id='performOCR']").addClass('dx-state-selected');
                    $("[aria-label='" + fromParams.name + "']").removeClass('dx-state-selected');
                }
            }

        });

        var getNodeLeavel = function (treeNode) {
            if (!(treeNode && treeNode.hasOwnProperty("parent")))
                throw "参数 treeNode 无效";

            if (null === treeNode.parent)
                return 1;

            return getNodeLeavel(treeNode.parent) + 1;
        }

        $scope.menuTreeOption = {
            bindingOptions: {
                dataSource: 'menuTreeDataSource'
            },
            dataStructure: "plain",
            //selectByClick: true,
            selectionMode: "single",
            //selectedExpr: 'selected',
            height: "100%",
            width: "100%",
            keyExpr: "id",
            parentIdExpr: "parentId",
            itemTemplate: 'itemTemplate',
            onItemRendered: function (e) {
                if (!(e && e.node))
                    return;

                // 如果是在初始化时渲染，则自动进入展开可见的第一个表
                if (!$scope.isManualClicking) {

                // TODO: For DCH Demo
                if (vatSessionService.project.id === '612a3872-b6ed-408c-8b7e-09eb6909437f' && window.location.href.indexOf("reportView") === -1
                    && e.node.code && e.node.code.indexOf("SCH03") >= 0) {
                    $state.go('cit.generateReport.reportView', {
                        id: e.node.reportId,
                        templateid: e.node.templateId,
                        name: e.node.text,
                        templatecode: e.node.code,
                        initrow: null,
                        initcol: null,
                        parentviewid: e.node.parentId
                    });
                }
                //else if (window.location.href.indexOf("reportView") === -1 && e.node.code && e.node.code.indexOf("BS") === 0) {
                    else if (e.node.code && !PWC.isNullOrEmpty(e.node.reportId) && !$scope.isFirstMenu) {
                    $scope.isFirstMenu = true;
                    $state.go('cit.generateReport.reportView', {
                        id: e.node.reportId,
                        templateid: e.node.templateId,
                        name: e.node.text,
                        templatecode: e.node.code,
                        initrow: null,
                        initcol: null,
                        parentviewid: e.node.parentId
                    });
                }
                }

                var leavel = getNodeLeavel(e.node.internalFields.publicNode);
                var PLS = 15;
                var pl = (leavel - 2) * PLS;
                e.itemElement.css("padding-left", ((pl < 0 ? PLS + 8 : pl) + 5) + "px");

                switch (leavel) {
                    case 1:
                        e.itemData.icon = "";
                        break;
                    case 2:
                        e.itemData.icon = "fa fa-file-text";
                        break;
                    case 3:
                        e.itemData.icon = "fa fa-file-text-o";
                        break;
                    default:
                        e.itemData.icon = "fa fa-file-o";
                        break;
                }
            },
            onItemClick: function (e) {
                if (e && e.itemData && isLeaveTab()) {
                    $scope.isManualClicking = true;
                    $(e.itemElement).parent().find('.dx-treeview-toggle-item-visibility').click();
                    $timeout(function () {
                        // TODO: DCH Demo
                        if (e && e.itemData && e.itemData.id === 'performOCR') {
                            $state.go('cit.generateReport.performOCR');
                        }
                        else if (e && e.itemData && e.itemData.templateId) {
                            $state.go('cit.generateReport.reportView', {
                                id: e.itemData.reportId,
                                templateid: e.itemData.templateId,
                                name: e.itemData.text,
                                templatecode: e.itemData.code,
                                initrow: null,
                                initcol: null,
                                parentviewid: e.itemData.parentId,
                            });
                        }


                        var node = _.find($scope.menuTreeDataSource, function (item) { return item.id === e.itemData.id });
                        if (node) {
                            node.selected = true;
                        }

                    }, 300);

                    //$('#dfiframe').attr("src", baseDFFilePath + 'WorkingPaper1.html' + '?t_' + Math.random() + '&dataFileName=' + e.itemData.dataFileName);
                }
            }
        }

        $scope.dongfengGo = function (menu) {

            parent.PWC.simulateProgress();

            $scope.selectedTemplateId = menu.id;

            if (_.isUndefined(menu.fileName)) {
                $scope.reportType = enums.reportType.prepay;
                $state.go('cit.generateReport.reportView', {
                    id: menu.reportId,
                    templateid: menu.id,
                    name: menu.name,
                    templatecode: menu.code,
                    initrow: null,
                    initcol: null,
                    parentviewid: null,
                });

            } else {
                $scope.reportType = enums.reportType.taxReturn;
                $log.debug('new file name:' + menu.fileName);
                $timeout(function () {
                    //$('#dfiframe').attr("src", baseDFFilePath + menu.fileName + '?t_' + Math.random());
                }, 500);
            }
        };

        $scope.checkListModal = {
            dataSource: [],
            modalTitel: null,
            isOpen: false,
            open: function (parentId) {
                var parentIdMapConfig = {
                    "2": {
                        reportType: 1,
                        titel: "CheckListOTTaxReturnCheckList"
                    },
                    "4": {
                        reportType: 3,
                        titel: "CheckListOTWorkingPaperCheckList"
                    }
                };

                var cfg = parentIdMapConfig[parentId.toString()];
                if (!cfg)
                    throw "parent Id is invalid";

                $scope.checkListModal.modalTitel = $translate.instant(cfg.titel);

                var apiFun = checkListService.getCheckListViewData;
                apiFun(vatSessionService.project.serviceTypeID, cfg.reportType, 0).then(function (response) {
                    var rst = response.data;
                    $scope.checkListModal.isOpen = rst.result;
                    $scope.checkListModal.dataSource = rst.result ? rst.data : [];
                });
            }
        };

        var loadTemplateMenu = function () {
            var projectID = vatSessionService.project.id;
            vatReportService.citGetTemplateTree(projectID).success(function (data) {
                if (!data || !data.data) {
                    return;
                }

                var i = 0;
                var data;

                // TODO: For DCH Demo
                if (projectID === '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                    data = _.filter(data.data, function (item) {
                        return !item.reportType || item.reportType === enums.reportType.taxReturn || item.reportType === enums.reportType.workingPaper;
                    });
                }
                else {
                    data = _.filter(data.data, function (item) {
                        return !item.reportType || item.reportType !== enums.reportType.documentList;
                    });
                }

                _.each(data, function (item, index) {
                    item.text = item.text.replace('CIT.', '');
                    if (index < 2 && !item.parentId && (item.code.indexOf("BS") >= 0 || item.code.indexOf("PL") >= 0)) { // 前两张报表如果Code包含BS或PL，说明是财务报表
                        item.parentId = '1';
                        if (/(BS|PL)[0-9]+/.test(item.text)) {
                            item.text = item.text.replace(/(BS|PL)[0-9]+/, '');
                        }
                        if (item.code.indexOf("BS") === 0) {
                            item.selected = true;
                        }
                    } else if (!item.parentId) {
                        
                        if (item.reportType == enums.reportType.taxReturn) {
                            item.parentId = '2';
                        } else if (item.reportType == enums.reportType.prepay) {
                            var prepayPeriod = item && item.code && PWC.tryParseStringToNum(item.code.substr(-3));
                            if (_.isNumber(prepayPeriod)) {
                                item.parentId = '3' + prepayPeriod.toString();
                            }
                        } else if (item.reportType == enums.reportType.workingPaper) {
                            item.parentId = '4';
                        } else if (item.reportType == enums.reportType.others) {
                            item.parentId = '5';
                        }
                    }
                });

                // TODO: For DCH Demo
                if (projectID !== '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                    //财务报表权限
                    if ($scope.hasBsPlPermission) {
                        data.push({
                            id: '1',
                            parentId: null,
                            text: $translate.instant('FinancialReport'),
                            expanded: true,
                            reportId: null,
                            templateGrouptId: null
                        });
                    }
                    if ($scope.quarterlyFilingReturnTypePermission) {
                        data.push({
                            id: '3',
                            parentId: null,
                            text: $translate.instant('QuarterlyFilingReturnType'),
                            reportId: null,
                            templateGrouptId: null
                        });
                        data.push({
                            id: '31',
                            parentId: '3',
                            text: $translate.instant('1stQuarterlyCITFilingReturn'),
                            reportId: null,
                            templateGrouptId: null
                        });
                        data.push({
                            id: '32',
                            parentId: '3',
                            text: $translate.instant('2ndQuarterlyCITFilingReturn'),
                            reportId: null,
                            templateGrouptId: null
                        });
                        data.push({
                            id: '33',
                            parentId: '3',
                            text: $translate.instant('3rdQuarterlyCITFilingReturn'),
                            reportId: null,
                            templateGrouptId: null
                        });
                        data.push({
                            id: '34',
                            parentId: '3',
                            text: $translate.instant('4thQuarterlyCITFilingReturn'),
                            reportId: null,
                            templateGrouptId: null
                        });
                    }
                        if ($scope.workingPaperTypePermission) {
                            data.push({
                                id: '4',
                                parentId: null,
                                text: $translate.instant('WorkingPaperType'),
                                reportId: null,
                                templateGrouptId: null
                            });
                        } 
                    } 
                else {
                    data.push({
                        id: 'performOCR',
                        parentId: null,
                        text: $translate.instant('PerformOCR'),
                        expanded: false,
                        reportId: null,
                        templateGrouptId: null
                    });

                    if ($scope.workingPaperTypePermission) {
                        data.push({
                            id: '4',
                            parentId: null,
                            text: $translate.instant('WorkingPaperType'),
                            expanded: true,
                            reportId: null,
                            templateGrouptId: null
                        });
                    }                   
                }
                if ($scope.taxReturnPermission) {
                    data.push({
                        id: '2',
                        parentId: null,
                        text: $translate.instant('TaxReturnType'),
                        reportId: null,
                        templateGrouptId: null
                    });
                }               

                // TODO: For DCH Demo
                if (projectID !== '612a3872-b6ed-408c-8b7e-09eb6909437f') {
                    if ($scope.otherReportPermission) {
                        data.push({
                            id: '5',
                            parentId: null,
                            text: $translate.instant('Others'),
                            reportId: null,
                            templateGrouptId: null
                        });
                    }                    
                }

                if (!$scope.hasBsPermission) {
                    data = _.reject(data, function (m) {
                        return m.parentId === '1' && m.text.indexOf("资产负债表") > -1
                    });
                }
                if (!$scope.hasPlPermission) {
                    data = _.reject(data, function (m) {
                        return m.parentId === '1' && m.text.indexOf("利润表") > -1
                    });
                }

                var urlParam = GetUrlParms();
                var currentReportId = urlParam["templateid"];
                if (currentReportId) {
                    var id = _.find(data, function (item) { return item.id == currentReportId });
                    if (id) {
                        id.selected = true;
                    }
                }
                $scope.menuTreeDataSource = data;

            });
        };

        function GetUrlParms() {
            var args = new Object();
            var query = location.href.substring(1);//获取查询串   
            var pairs = query.split("&");//在逗号处断开   
            for (var i = 0; i < pairs.length; i++) {
                var pos = pairs[i].indexOf('=');//查找name=value   
                if (pos == -1) continue;//如果没有找到就跳过   
                var argname = pairs[i].substring(0, pos);//提取name   
                var value = pairs[i].substring(pos + 1);//提取value   
                args[argname] = unescape(value);//存为属性   
            }
            return args;
        }

        //检查用户机构权限
        var getUserPermission = function () {
            var list = [];
            var reportTemp = constant.citPermission.reportView;
            //bspl
            list.push(reportTemp.bsplCode);
            list.push(reportTemp.bspl.bsCode);
            list.push(reportTemp.bspl.plCode);
            //纳税申报表 
            list.push(reportTemp.taxReturn.queryCode); 
            //季度预缴表 
            list.push(reportTemp.quarterlyFilingReturnType.queryCode); 
            //工作底稿 
            list.push(reportTemp.workingPaperType.queryCode); 
            //其他 
            list.push(reportTemp.otherReport.queryCode); 

            $scope.hasBsPlPermission = false;
            $scope.hasBsPermission = false;
            $scope.hasPlPermission = false;
            $scope.taxReturnPermission = false;
            $scope.quarterlyFilingReturnTypePermission = false;
            $scope.workingPaperTypePermission = false;
            $scope.otherReportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasBsPlPermission = data[reportTemp.bsplCode];
                $scope.hasBsPermission = data[reportTemp.bspl.bsCode];
                $scope.hasPlPermission = data[reportTemp.bspl.plCode];
                $scope.taxReturnPermission = data[reportTemp.taxReturn.queryCode];
                $scope.quarterlyFilingReturnTypePermission = data[reportTemp.quarterlyFilingReturnType.queryCode];
                $scope.workingPaperTypePermission = data[reportTemp.workingPaperType.queryCode];
                $scope.otherReportPermission = data[reportTemp.otherReport.queryCode];
            });
        };
        var toggleGroup = function (group) {
            group.isExpand = !group.isExpand;
        };
        (function initialize() {
            getUserPermission();
            loadTemplateMenu();
            $scope.expend = true;
            $scope.reportType = 1;
            $scope.toggleGroup = toggleGroup;
            $scope.isManualClicking = false;
        })();

    }]);