﻿commonModule.directive('accountVoucherGridFilter', ['$log',
    function ($log) {
        'use strict';
        $log.debug('vatParentCodeModal.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/account-voucher-grid-filter/account-voucher-grid-filter.html' + '?_=' + Math.random(),
            replace: true,
            controller: 'accountVoucherGridFilterController',
            scope:
            {   
                isSearching: "=?",    
                periodId: '=?',
                enterpriseCode: '=?',
                selectedVouchers: "=?",
                processTypeId: "=?",
                reMapItem: "=?"
            },
            link: function ($scope, element) {       
                $scope.$watch("isSearching", function (newValue, oldValue) {
                        if (!_.isUndefined(newValue) && !_.isUndefined(oldValue)) {
                            if (!_.isEqual(newValue, oldValue) && newValue) {
                                $log.debug("start account-voucher-grid-filter.js watching: isSearching");             
                                $scope.initGridView($scope.periodId, $scope.enterpriseCode);                     
                            }
                        }                                      
                });                

            }
        };
    }
]);