﻿commonModule.
controller('editUserModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', 'areaRegionService', '$filter', 'SweetAlert', 'regionService', 'userService', 'enums',
    function($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, areaRegionService, $filter, SweetAlert, regionService, userService, enums) {

        // newUser
        var newUser = function() {
            $scope.isAdd = true;
            $scope.editUserModel = {};
            $scope.editUserModel.isAdmin = false;
            resetErrorStatus();
            $('.edit-user-modal-wrapper .modal').modal('show');
        };

        // loadUser
        var loadUser = function(userId) {
            $scope.isAdd = false;
            resetErrorStatus();
            userService.getSingleUser(userId).success(function(userData) {
                $scope.editUserModel = {};
                $scope.editUserModel.ID = userData.id;
                $scope.editUserModel.UserName = userData.userName;
                $scope.editUserModel.Status = userData.status;
                $scope.editUserModel.OrganizationID = userData.organizationID;
                $scope.editUserModel.Email = userData.email;
                $scope.editUserModel.OrgName = userData.orgName;
                $scope.editUserModel.RoleIDs = userData.roleIDs;
                $scope.editUserModel.RoleNames = userData.roleNames;
                $scope.editUserModel.CreateTime = userData.createTime;
                $scope.editUserModel.Password = userData.password;
                $scope.editUserModel.isAdmin = userData.isAdmin;

            });
            $('.edit-user-modal-wrapper .modal').modal('show');
        };

        // Save role info
        var saveUser = function() {
            var hasError = false;
            if (!($('#userForm').valid())) {
                hasError = true;
            }

            if (!$scope.editUserModel.OrganizationID) {
                $scope.editUserModel.organizationIDError = $translate.instant('SelectOrg');
                $('#dropdownMenu1').addClass('error-button');
                hasError = true;
            }

            // if (!$scope.editUserModel.isAdmin) {
            if (!$scope.editUserModel.RoleIDs || $scope.editUserModel.RoleIDs.length === 0) {
                //$('.selector-input').addClass('error-button');
                $scope.editUserModel.RoleIDsError = $translate.instant('selectOneRoleDesc');
                //hasError = true;
            }
            // }

            if (hasError) {
                return;
            }

            if ($scope.isAdd) {

                userService.addUser($scope.editUserModel).success(function(or) {
                    if (or) {
                        if (or.result === true) {
                            SweetAlert.success($translate.instant('AddUserSuccess'));
                            $scope.editUserModel = {};
                            $scope.isUpdate = true;
                            $('.edit-user-modal-wrapper .modal').modal('hide');
                        } else {
                            SweetAlert.warning($translate.instant(or.resultMsg));
                        }
                    }

                    $scope.operateType = null;
                });
            } else {

                userService.updateUser($scope.editUserModel).success(function(or) {
                    if (or) {
                        if (or.result === true) {
                            SweetAlert.success($translate.instant('UpdateUserSuccess'));
                            $scope.editUserModel = {};
                            $scope.isUpdate = true;
                            $('.edit-user-modal-wrapper .modal').modal('hide');
                        } else {
                            SweetAlert.warning($translate.instant(or.resultMsg));
                        }

                    }

                    $scope.operateType = null;
                });
            }


        };

        // disable user account
        var disableUser = function(user) {
            console.log(JSON.stringify(user));
            SweetAlert.swal({
                    title: $translate.instant('Confirm') + $translate.instant('StopUse') + '?',
                    text: $translate.instant('Confirm') + $translate.instant('StopUse') + user.userName,
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Confirm'),
                    cancelButtonText: $translate.instant('Cancel'),
                    closeOnConfirm: false,
                    closeOnCancel: true
                },
                function(isConfirm) {
                    if (isConfirm) {
                        // 选中
                        userService.enableOrDisableUser(user.id, 0).success(function(or) {
                            if (or) {
                                if (or.result === true) {
                                    $scope.selectedUser.status = enums.userStatus.disabled;
                                    $scope.selectedUser.statusName = $translate.instant('StopUse');
                                    SweetAlert.success($translate.instant('DisableUserSuccess'));
                                    $scope.isUpdate = true;
                                } else {
                                    SweetAlert.warning($translate.instant(or.resultMsg));
                                }
                            }
                        });
                    }

                    $scope.operateType = null;
                });

        };

        //enable user account
        var enableUser = function(userId) {
            userService.enableOrDisableUser(userId, enums.userStatus.active).success(function(or) {
                if (or) {
                    if (or.result === true) {
                        $scope.selectedUser.status = enums.userStatus.active;
                        $scope.selectedUser.statusName = $translate.instant('Enable');
                        SweetAlert.success($translate.instant('EnableUserSuccess'));
                        $scope.isUpdate = true;
                    } else {
                        SweetAlert.warning($translate.instant(or.resultMsg));
                    }
                }

                $scope.operateType = null;
            })
        };

        // operate Type
        $scope.$watch('operateType', function(newValue, oldValue) {
            if (newValue) {

                if (newValue === constant.Operation.Add) {
                    // add

                    newUser();
                } else if (newValue === constant.Operation.Edit && $scope.selectedUser && $scope.selectedUser.id) {

                    loadUser($scope.selectedUser.id);
                } else if (newValue === constant.Operation.Disable) {
                    // 禁用
                    disableUser($scope.selectedUser);
                } else if (newValue === constant.Operation.Enable) {
                    enableUser($scope.selectedUser.id);
                }
            }
        });


        $scope.$watch('editUserModel.OrganizationID', function(newValue, oldValue) {
            if (newValue) {
                $scope.editUserModel.organizationIDError = null;
            }
        });

        $scope.$watch('editUserModel.RoleIDs', function(newValue, oldValue) {
            if (newValue) {
                $scope.editUserModel.RoleIDsError = null;
            }
        });

        // close modal
        $scope.closeModal = function() {
            $scope.operateType = null;
        };

        $(".addUserPop").on("hidden.bs.modal", function() {
            $scope.operateType = null;
        });

        var resources = {
            userNameRequired: $translate.instant('RequireUserName'),
            userEmailRequired: $translate.instant('RequireEmail'),
            userEmailCheck: $translate.instant('RequireCorrectEmail'),
            userOrgRequired: $translate.instant('RequireOrganization')
        };

        var validator = $('#userForm').validate({
            errorClass: "has-error",
            rules: {
                inputUserName: {
                    required: true
                },
                inputUserEmail: {
                    required: true,
                    email: true
                },
                selectedOrgName: {
                    required: true
                }
            },
            messages: {
                inputUserName: {
                    required: resources.userNameRequired
                },
                inputUserEmail: {
                    required: resources.userEmailRequired,
                    email: resources.userEmailCheck
                },
                selectedOrgName: {
                    required: resources.userOrgRequired
                }
            },
            errorPlacement: function(error, element) {
                setErrorStyle(error, element);
            }
        });

        var setErrorStyle = function(error, element) {
            if (element.hasClass('has-error')) {
                element.parent().addClass('has-error');
                error.insertAfter(element);
                error.addClass('label');
            }
            if (element[0].name === 'orgName') {
                element.parent().addClass('col-xs-9');
                element.parent().addClass('padding-left-zero');
            }
        };

        var resetErrorStatus = function() {
            validator.resetForm();
            var currentForm = $('#userForm');
            $(currentForm).find('.has-error').removeClass('has-error');
            $('#dropdownMenu1').removeClass('error-button');
            $('.selector-input').removeClass('error-button');
        };


        (function initialize() {
            $log.debug('editRegionModalController.ctor()...');

            //Save user info
            $scope.saveUser = saveUser;

            //Load user info by userId
            $scope.loadUser = loadUser;

            //Clear user model
            $scope.newUser = newUser;

            //Enable user 
            $scope.enableUser = enableUser;

            //Disable user
            $scope.disableUser = disableUser;
        })();
    }
]);
