﻿commonModule.controller('importIRController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums', 'vatOperationLogService'
    , 'projectService', 'vatCommonService','orgService','templateService',
    function ($scope, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums, vatOperationLogService
        , projectService, vatCommonService,orgService,templateService) {
        'use strict';

        var successCount = 0;
        var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
        var resumable = true;
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        var servicePeriods = [];
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;      
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        $scope.validationType = 0;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.balanceInputList = [];
        $scope.toInputList = [];
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 }; //导入方式
        $scope.selectedPeriod = null;
        $scope.showTotalSecondRow = false;
        $scope.maxTitleLength = constant.maxButtonTitleLength;

        $scope.importIRExcelFile = apiInterceptor.webApiHostUrl + '/DataImport/IRExcelFile';

        $scope.companyList = [];
        $scope.checkedCompanyList = [];
        $scope.checkedCompanyCodeList = [];
        $scope.checkedCompanyTypeList = "";

        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth();
        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.viewMode = 1;
        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');

        $scope.importExcelFile = null;
        $scope.UploadPeriodTime = null;



        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('ProfitAndLossStatement'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        $scope.totalData = {
            totalNumber: 0,
            begDebitTotal: 0,
            begCreditTotal: 0,
            endDebitTotal: 0,
            endCreditTotal: 0,
            begBalTotal: 0,
            endBalTotal: 0,
            debitTotal: 0,
            creditTotal: 0,
        };

        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
            }
        };

        //转换没有选中的列值
        var undefinedStringToNull = function (i, stringName) {
            var data = $scope.sheetData.dataList[i][$.inArray($translate.instant(stringName), $scope.selectedMappingList)];
            if (_.isUndefined(data)) {
                return null;
            }
            else {
                if (PWC.isNullOrEmpty(data)) {
                    return "";
                }
                else {
                    return data;
                }
            }
        }


        //转换没有选中的列值
        var undefinedNumToNull = function (i, stringName) {
            var data = $scope.sheetData.dataList[i][$.inArray($translate.instant(stringName), $scope.selectedMappingList)];
            if (_.isUndefined(data)) {
                return null;
            }
            else {
                if (PWC.isNullOrEmpty(data)) {
                    return 0;
                }
                else {
                    return data;
                }
            }
        };

        var downloadTemplate = function () {
            templateService.downloadTemplate(constant.importFileType.invoiceRecord).success(function (data, status, headers) {
                var octetStreamMime = 'application/octet-stream';
                var contentType = headers('content-type') || octetStreamMime;
                if (window.navigator.msSaveBlob) {
                    var blob = new Blob([data], {
                        type: contentType
                    });
                    navigator.msSaveBlob(blob, "InvoiceRecord");
                } else {
                    var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                    if (urlCreator) {
                        var a = document.createElement('a');
                        var blob = new Blob([data], {
                            type: contentType
                        });
                        var url = urlCreator.createObjectURL(blob);
                        a.href = url;
                        a.target = '_blank';
                        a.download = "InvoiceRecord.xlsx";
                        document.body.appendChild(a);
                        a.click();
                    }
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        //导入事件
        var doUploadIR = function (importType) {

            var impExl = $scope.importExcelFile;
            var deferred = $q.defer();
            var token = $('input[name="__RequestVerificationToken"]').val();


            if (!impExl) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }

            //列名对应验证
            /*if (validationColumnMapping()) {
                //数据类型验证
                validationTbData().then(function (isSuccess) {
                    if (isSuccess) {

                });
            }*/
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            } else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            } else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportProfitLoss');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            var period = $scope.UploadPeriodTime;
            var orgIds = JSON.stringify($scope.checkedCompanyCodeList);

            Upload.upload({
                url: $scope.importIRExcelFile,
                data: {
                    orgIds : orgIds,
                    periodDate : period,
                    importType : importType
                },
                file: impExl,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function(resp) {
                var ret = resp.data;
                $('#busy-indicator-container').hide();
                deferred.resolve();
                if (ret.result) {
                    logDto.UpdateState = $translate.instant('ImportSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.success($translate.instant('ImportSuccess'));
                } else {
                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        SweetAlert.warning($translate.instant(ret.resultMsg));
                    }else{
                        SweetAlert.error($translate.instant('ImportFailed'));
                    }
                    logDto.UpdateState = $translate.instant('ImportFail');
                    vatOperationLogService.addOperationLog(logDto);
                }
                getImportIRStatus();

            }, function(resp) {
                deferred.resolve();
                if (resp.statusText === 'HttpRequestValidationException') {
                    SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                } else {
                    SweetAlert.warning('SaveFail');
                }
                logDto.UpdateState = $translate.instant('ImportFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.error($translate.instant('ImportFail'));
                console.log('Error status: ' + resp.status);
            }, function(evt) {
                deferred.resolve();
                var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
            });
        };

        //显示图标
        var errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            }
            else {
                return '/app-resources/images/vat/tips.png';
            }
        };

        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };


        var getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return { height: y + "px" };
                } else {

                    return { height: '0px' };
                }
            }
            return {};
        };

        var loadImportIRStatusInfoDatagrid = function () {

            $scope.importIRStatusGridOptions = {
                bindingOptions: {
                    dataSource: 'ImportIRStatusGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "taxpayerIdNum",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('TaxpayerIdNum')
                }, {
                    dataField: "companyCode",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyCode'),
                    width: '15%'
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    width: '27%',
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "periodYear",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('YearPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('TMSPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('Period')
                }, {
                    dataField: "recordSize",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('RecordSize')
                }, {
                    dataField: "errorMsg",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('Status')
                }
                ],
                onContentReady: function (e) {
                    $scope.accountingRateListInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };
            getImportIRStatus();
        };

        var getImportIRStatus = function () {
            vatImportService.displayImportLog(constant.importFileType.invoiceRecord).success(function (data) {
                if (data) {
                    $scope.ImportIRStatusGridSource = data;
                    for (var i = 1; i <= $scope.ImportIRStatusGridSource.length; i++) {
                        $scope.ImportIRStatusGridSource[i - 1].index = i;
                    }
                }
            });
        };

        var initImportIRStatusFromDB = function () {
            getImportIRStatus();
        };

        //显示验证信息
        var toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');

                    $('#topIcon').css({ bottom: '-381px' });

                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };


        var setErrorWrapCssDefault = function () {
            $('#content-resizer').css('bottom', '0px');

            $('#topIcon').css({ bottom: '-501px' });

            $('.error-info-wrapper').css('height', '0px');
        };

        var showErrTab = function() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });
        };

        //加载文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            //初始化数据
            $scope.selectedMappingList = [];
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
        }


        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };


        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };


        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {

            var list = [];

            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };


        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };


        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        $scope.selectOne = function () {
            $scope.checkedCompanyList = [];
            angular.forEach($scope.companyList , function (i) {
                var index = $scope.checkedCompanyList.indexOf(i.id);
                if(i.checked && index === -1) {
                    $scope.checkedCompanyList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedCompanyList.splice(index, 1);
                }
            });

            $scope.selectedAll = $scope.companyList.length === $scope.checkedCompanyList.length;

            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name+";";
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectAll = function () {
            if($scope.selectedAll) {
                $scope.selectedOne = true;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    $scope.checkedCompanyList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOne = false;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name;
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };

        var initDatePicker = function () {
            var ele1 = $("#periodDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.selectedDate);
        };

        var initCompanyList = function () {
            orgService.getOrgListByUserId().success(function (data) {
                if (data) {
                    $scope.companyList = data;
                }
            });
        };

        //开始
        (function initialize() {
            $log.debug('ImportTBController.ctor()...');
            checkUserOrganizationPermissionList();
            $scope.doUploadIR = doUploadIR;
            $scope.downloadTemplate = downloadTemplate;
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.errorLevelToString = errorLevelToString;
            $scope.getGridHeight = getGridHeight;
            $scope.getErrorGridHeight = getErrorGridHeight;
            $scope.toggleErrorTab = toggleErrorTab;
            $scope.showOperateLogPop = showOperateLogPop;

            $scope.setGridStyle = setGridStyle;

            getUserPermission();
            initCompanyList();
            loadImportIRStatusInfoDatagrid();
            initDatePicker();

            $scope.$watch('importExcelFile', function (newValue, oldValue) {
                if (newValue !== null && newValue !== oldValue) {
                    initImportFile(newValue);
                }
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);