﻿commonModule.directive('orgCityAreaUser', ['$log', '$compile', '$timeout', '$interval',
    function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('orgCityAreaUser.ctor()...');

        return {
            restrict: 'AE',
            templateUrl: '/app/common/controls/org-city-area-user/org-city-area-user.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                orgIdCityAreaUser: '=',
                isRenderCompletedCityAreaUser: '='
            },
            controller: 'OrgCityAreaUserController',
            link: function (scope, element) {
                scope.$watch('orgIdCityAreaUser', function (newValue, oldValue) {
                    if (newValue !== oldValue) {

                        var orgId = newValue.substring(0, newValue.indexOf('|'));
                        //refresh ui grid with new data
                        scope.getOrgCityAreaUserCountList(orgId).then(function () {
                            scope.isRenderCompletedCityAreaUser = true;
                        });
                    }

                    //点击弹出的面板，禁止冒泡事件
                    $("#orgCityAreaUserPop").on("click", function (e) {
                        e.stopPropagation();
                    });
                     
                })
            }
        };
    }
]);