﻿commonModule.directive('standardAccountGridFilterModal', ['$log','$translate','$uibModal',
    function ($log, $translate,$uibModal) {
        'use strict';
        $log.debug('standardAccountGridFilterModal.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/standard-account-grid-filter-modal/standard-account-grid-filter-modal.html' + '?_=' + Math.random(),
            replace: true,
            controller: 'standardAccountGridFilterModalController',
            scope:
            {            
                isShowStdFilter: "=",
                stdAccountList: "=?",
                selectedStdCode: "=?"
            },
            link: function ($scope, element) {
                var selectedStdItem;
                $scope.closeModal = function () {
                    $scope.isShowStdFilter = false;
                    $('#stdAccountFilterModel').modal('hide');
                }

                $scope.selectStdCode = function () {
                    if (!_.isUndefined(selectedStdItem)) {
                        $scope.selectedStdCode = selectedStdItem[0].code;
                    }

                    $scope.closeModal();
                }

                $scope.showStdGridFilter = function () {
                    $scope.stdAccountList = _.sortBy($scope.stdAccountList, 'code');
                    $scope.treeListOptions = {
                        dataSource: $scope.stdAccountList,
                        keyExpr: "code",
                        parentIdExpr: "parentCode",
                        columns: [
                            {
                                dataField: "code",
                                caption: $translate.instant('StdSubjectCodeCol'),
                            },
                            {
                                dataField: "fullName",
                                caption: $translate.instant('StdSubjectNameCol'),
                            },
                            {
                                dataField: "directionDesc",
                                caption: $translate.instant('SubjectDirectionCol'),
                            },
                            {
                                dataField: "parentCode",
                                caption: $translate.instant('ParentCode'),
                            },
                            {
                                dataField: "hasChildren",
                                caption: $translate.instant('DoesHasChildren'),
                                visible:false
                            }
                        ],
                        scrolling: {
                            mode: "virtual"
                        },
                        sorting: {
                            mode: 'single'
                        },
                        filterRow: {
                            visible: true,
                            applyFilter: "auto",
                            showOperationChooser: false //filterRow是否出现放大镜的筛选条件
                        },
                        searchPanel: {
                            placeholder: $translate.instant('Search'),
                            visible: true,
                            width: 200
                        },
                        selection: {
                            allowSelectAll: false,
                            mode: "single"
                        },
                        allowColumnResizing: true,
                        columnAutoWidth: true,
                        showRowLines: true,
                        showColumnLines: true,
                        rowAlternationEnabled: true, //单双行颜色
                        showBorders: true,
                        expandedRowKeys: [1],
                        //onInitialized: function (e) {
                        //    $scope.treeViewInstance = e.component;
                        //},
                        onSelectionChanged: function (e) {                       
                            selectedStdItem = e.component.getSelectedRowsData();                                                                     
                        }
                    };

                    $('#stdAccountFilterModel').modal('show');
                }


                $scope.$watch("isShowStdFilter", function (newValue, oldValue) {
                    $log.debug("standard-account-grid-filter-modal.js   isShow watching:");
                    $log.debug("newValue:" + newValue + " oldValue:" + oldValue);
                    $log.debug($scope.stdAccountList);
                    if (newValue) {
                        $scope.showStdGridFilter();
                    }
                });


            }
        };
    }
]);