﻿commonModule.controller('uploaderContoller', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload) {

    	'use strict';

    	$log.debug('uploaderContoller.ctor()...');
    	var uploadUrl = apiInterceptor.webApiHostUrl + '/FileUpload/NewFile';
    	$scope.chunkSize = 100000;
    	$scope.success = false;

    	var resumable = true;
    	var allFilesCount = 0;
    	var successCount = 0;
    	var updateProgressToZero = function () {
    	    $scope.percentNumber = '0%';
    	    $scope.showLoading = false;
    	};
    	var uploadSuccess = function (resp) {
    	    successCount++;

    	    if (successCount === allFilesCount) {
    	        $scope.tempFileName = resp.data;
    	        changeSheet(0);
    	        $scope.showLoading = false;
    	    }
    	};


    	var updateProgress = function (evt) {
    	    $scope.showLoading = true;
    	    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
    	    $scope.percentNumber = progressPercentage + '%';
    	};
    	var uploadfile = function (files) {
    		if (files && files.length) {
    			allFilesCount = files.length;
    			successCount = 0;
    			var uploadSuccessCallBack = function () {
    				updateProgressToZero();
    			}
    			for (var i = 0; i < files.length; i++) {
    				var file = files[i];

    				if (!file.$error) {
    					var tempFileName = PWC.newGuid() + '.dat';
    					updateProgressToZero();
    					Upload.upload({
    						url: uploadUrl,
    						data: {
    							cancel: false,
    							filename: file.name,
    							tempFileName: tempFileName,
    							FileTypeID: $scope.fileType,
    							ProjectID: $scope.projectID,
    							Remark: $scope.remark,
    							file: file
    						},
    						resumeChunkSize: resumable ? $scope.chunkSize : null,
    						headers: {
    							'Access-Control-Allow-Origin': '*',
    							Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
    						}
    					}).then(uploadSuccess, uploadSuccessCallBack, updateProgress);
    				}
    			}
    		}
    	};

    	var changeloadingTitle = function (title) {
    		$scope.loadingTitle = $translate.instant(title);
    	};

    	

    	var doUploadFile = function () {

    		$scope.pageStatus = pageStatusEnum.Mapping;
    		changeloadingTitle('fileUploading');

    		uploadfile($scope.fileNameWrapper);
    	};

    	var updateFileName = function (newValue) {
    		$scope.fileName = '';
    		_.each(newValue, function (item) {
    			$scope.fileName = item.name;
    		});
    	};

    	$scope.$watch('fileNameWrapper', function (newValue, oldValue) {
    		if (newValue !== oldValue) {
    			updateFileName(newValue);
    			doUploadFile();
    		}
    	});
    }
]);