﻿webservices.factory('BSPLService', ['$log', '$http', 'apiConfig',
    function ($log,$http,apiConfig) {
        'use strict';
        $log.debug('BSPLService.ctor()...');
        return {

            //CIT Remove(可以直接使用vat已有的):
            //    citSwitchPeriod: function (templateID, period)
            //    citGetCellDetailInfo: function (keyValueDataID)
            //    citGetCellInfo: function (templateId,col,row)
            //    citGenerateBSPL: function (projectId, period)
            //    citGenerateBSPLWithoutLoading: function (projectId, period)
            //    citGetReportData: function (projectId, templateId, period, generator)

            GetCellDetailInfo: function (keyValueDataID) {
                return $http.get('/bspl/cellDetail/' + keyValueDataID, apiConfig.createVat());
            },
            GetCellInfo: function (templateId,col,row) {
                return $http.get('/bspl/cellDetail?templateId=' + templateId + '&col=' + col + '&row=' + row, apiConfig.createVat({ignoreLoadingBar:true}));
            },
            SwitchPeriod: function (templateID, period) {
                return $http.get('/bspl/filter', apiConfig.createVat());
            },
            GenerateBSPL: function (projectId, period) {
                return $http.get('/bspl/generate?projectId=' + projectId + '&period=' + period, apiConfig.createVat());
            },
            GenerateBSPLWithoutLoading: function (projectId, period) {
                return $http.get('/bspl/generate?projectId=' + projectId + '&period=' + period, apiConfig.createVat({ ignoreLoadingBar: true }));
            },
            getReportData: function (projectId, templateId, period, generator) {
                return $http.get('/bspl/reportData?templateId=' + templateId + '&projectID=' + projectId + '&period=' + period + '&generator=' + generator, apiConfig.createVat());
            }
        };

}]);