﻿// web service proxy for org
webservices.factory('areaService', ['$http', 'apiConfig', 'httpCacheService',
function ($http, apiConfig, httpCacheService) {
    'use strict';
     
    return {
        tree: function (type) {
            return $http.get('/area/tree?type=' + type, apiConfig.create()); 
        },
        add: function (model) {
            return $http.post('/area/add', model, apiConfig.create());
        },
        update: function (model) {
            return $http.post('/area/update', model, apiConfig.create());
        },
        deleteArea: function (model) {
            return $http.post('/area/delete', model, apiConfig.create());
        },
        isactive: function (model) {
            return $http.post('/area/isactive', model, apiConfig.create());
        },
        getAreaList: function (type) {
            return $http.get('/area/getAreaList?type=' + type, apiConfig.create());
        },
        getAreaTreeByID: function (id) {
            return $http.get('/area/getAreaTreeByID?id=' + id, apiConfig.create());
        }
    };
}]);