﻿webservices.factory('equityService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getEquityList: function (orgId) {
            return $http.get('/equity/getEquityListByOrgId?orgId=' + orgId, apiConfig.create());
        },
        getEquityListResp: function (orgId) {
            return $http.get('/equity/getEquityListRespByOrgId?orgId=' + orgId, apiConfig.create());
        },
        getEquityById: function (id) {
            return $http.get('/equity/getEquityListById?id=' + id, apiConfig.create());
        },
        getEquityHisById: function (id) {
            return $http.get('/equity/getEquityHisListById?id=' + id, apiConfig.create());
        },
        insert: function (equityInfoDtos) {
            return $http.post('/equity/insert', equityInfoDtos, apiConfig.create());
        },
        update: function (equityInfoDto) {
            return $http.post('/equity/update', equityInfoDto, apiConfig.create());
        },
        delete: function (id, eNums) {
            return $http.post('/equity/delete?id=' + id, eNums, apiConfig.create());
        },
        change: function (orgName, comment, equityInfoDtos) {
            return $http.post('/equity/change?orgName=' + orgName + '&comment=' + comment, equityInfoDtos, apiConfig.create());
        },
        getChangeLogByOrgName: function (orgName) {
            return $http.get('/equity/getChangeLogByOrgName?orgName=' + orgName , apiConfig.create());
        },
        cancelChange: function (oldId, newId) {
            return $http.get('/equity/cancelChange?oldId=' + oldId + '&newId=' + newId, apiConfig.create());
        }
    }
}]);