﻿// web service proxy for org
webservices.factory('landManageService', ['$http', 'apiConfig',
function ($http, apiConfig) {
    'use strict';

    return {
        addLand: function (land) {
            return $http.post('/landManage/land', land, apiConfig.create());
        },
        updateLand: function (land) {
            return $http.put('/landManage/land', land, apiConfig.create());
        },
        disableOrEnableLand: function (land) {
            return $http.put('/landManage/disable', land, apiConfig.create());
        },
        loadAll: function () {
            return $http.get('/landManage/land',apiConfig.create());
        },
        loadAllTax: function (landID) {
            return $http.get('/landManage/taxbasic/' + landID, apiConfig.create());            
        },
        addTaxBasic: function (tax) {
            return $http.post('/landManage/taxbasic', tax, apiConfig.create());
        },
        updateTaxBasic: function (tax) {
            return $http.put('/landManage/taxbasic', tax, apiConfig.create());
        },
        deleteTaxBasic: function (taxID) {
            return $http.delete('/landManage/taxbasic/' + taxID, apiConfig.create());
        }
    };
}]);