﻿// web service proxy for standard account
webservices.factory('templateGroupService', ['$http', 'apiConfig', 'httpCacheService', function ($http, apiConfig, httpCacheService) {
    'use strict';
    return {
        getall: function () {
            return $http.get('/templateGroup/getall', apiConfig.create());
        },
        getByServiceType: function (serviceTypeID,taxPayType) {
            return $http.get('/templateGroup/getByServiceType/' + serviceTypeID + '/' + taxPayType , apiConfig.create());
        },
        addTemplateGroup: function (templateGroup) {
            return $http.post('/templateGroup/addTemplateGroup', templateGroup, apiConfig.create());
        },
        addTemplateGroupWithoutTemplate: function (templateGroup) {
            return $http.post('/templateGroup/templateGroup/withoutTemplate', templateGroup, apiConfig.create());
        },
        getTemplateList: function (templateGroupID, reportType) {
            return $http.get('/template/get?templateGroupID=' + templateGroupID + '&reportType=' + reportType, apiConfig.create());
        },
        getGroupTemplate: function (projectID, serviceType) {
            return $http.get('/template/getGroupTemplate?projectID=' + projectID + '&serviceType=' + serviceType, apiConfig.create());
        },
        getGroupTemplateByGroupID: function (templateGroupID, projectID) {
            return $http.get('/template/getGroupTemplateByGroupID?templateGroupID=' + templateGroupID + '&projectID=' + projectID, apiConfig.create());
        },
        getTemplateByTree:function (projectID, serviceType) {
            return $http.get('/template/getGroupTemplateTree?projectID=' + projectID + '&serviceType=' + serviceType, apiConfig.create());
        },
        getByIndustry: function (serviceTypeID, taxPayType, industryID) {
            return $http.get('/templateGroup/getByIndustry/' + serviceTypeID + '/' + industryID + '?taxPayType=' + (taxPayType || ''), apiConfig.create());
        }
        ,
        getTemplateUniqList:function(serviceTypeID,payTaxType,reportType,industryIDs){
            return $http.get('/template/getTemplateUniqList?serviceTypeID=' + serviceTypeID + '&payTaxType='+payTaxType + '&reportType=' + reportType + '&industryIDs='+industryIDs , apiConfig.create());
        }
        ,addExistTemplate:function(model){
            return $http.post('/template/addExistTemplate', model, apiConfig.create());
        }
        ,deleteTemplate:function(model){
            return $http.post('/template/deleteTemplate', model, apiConfig.create());
        }
        ,updateTemplateName:function(model){
            return $http.post('/template/updateTemplateName', model, apiConfig.create());
        },
        deleteTemplateGroup:function(model){
            return $http.post('/templateGroup/deleteTemplateGroup', model, apiConfig.create());
        },
        updateTemplateGroupName:function(model){
            return $http.post('/templateGroup/updateTemplateGroupName', model, apiConfig.create());
        }
    };
}]);