﻿dataImpModule.controller('extractFinancialDataController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums', 'vatOperationLogService'
    , 'projectService', 'vatCommonService','orgService',
    function ($scope, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums, vatOperationLogService
        , projectService, vatCommonService , orgService) {
        'use strict';

        var successCount = 0;
        var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
        var resumable = true;
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        var servicePeriods = [];
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;      
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false;
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        $scope.validationType = 0;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.balanceInputList = [];
        $scope.toInputList = [];
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2, ApiImport: 2 }; //导入方式
        $scope.selectedPeriod = null;
        $scope.showTotalSecondRow = false;
        $scope.maxTitleLength = constant.maxButtonTitleLength;

        $scope.companyList = [];
        $scope.checkedCompanyList = [];
        $scope.checkedCompanyCodeList = [];
        $scope.checkedCompanyTypeList = "";

        $scope.fileTypeList = constant.fileTypeList;
        $scope.checkedFileList = [];
        $scope.checkedFileCodeList = [];
        $scope.checkedFileTypeList = "";

        $scope.importATExcelFile = apiInterceptor.webApiHostUrl + '/DataImport/ATExcelFile';


        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth();
        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.viewMode = 1;
        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');

        $scope.importExcelFile = null;
        $scope.UploadPeriodTime = null;



        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('redLetterInformationTable'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };

        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
            }
        };

        //根据PeriodId过滤数据
        var filterImportData = function (m) {
            var filterData = false;
            if ($scope.serviceTypeId === constant.serviceType.VAT+"") {
                filterData = m.MonthId === m.PeriodId
                    && m.PeriodId === $scope.period.toString();

            } else if ($scope.serviceTypeId === constant.serviceType.CIT+"") {
                filterData = m.MonthId === m.PeriodId;
            }

            return filterData;
        };

        //导入事件
        var callApi = function () {


        };

        //显示图标
        var errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            }
            else {
                return '/app-resources/images/vat/tips.png';
            }
        }

        //刷新操作
        var refreshTbData = function () {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = '';
            logDto.OperationName = $translate.instant('RefreshValidationData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
            refreshByService.callRefresh($scope.serviceTypeId, enums.optionType.Refresh);
        };

        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };


        var getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return { height: y + "px" };
                } else {

                    return { height: '0px' };
                }
            }
            return {};
        };

        var loadImportATStatusInfoDatagrid = function () {

            $scope.importATStatusGridOptions = {
                bindingOptions: {
                    dataSource: 'ImportATStatusGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "taxpayerIdNum",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('TaxpayerIdNum')
                }, {
                    dataField: "companyCode",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyCode'),
                    width: '15%'
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    width: '27%',
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "periodYear",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('YearPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('TMSPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('Period')
                }, {
                    dataField: "recordSize",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('RecordSize')
                }, {
                    dataField: "errorMsg",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('Status')
                }
                ],
                onContentReady: function (e) {
                    $scope.accountingRateListInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };
            getImportATStatus();
        };

        var getImportATStatus = function () {
            vatImportService.displayImportLog(constant.importFileType.adjustmentTable).success(function (data) {
                if (data) {
                    $scope.ImportATStatusGridSource = data;
                    for (var i = 1; i <= $scope.ImportATStatusGridSource.length; i++) {
                        $scope.ImportATStatusGridSource[i - 1].index = i;
                    }
                }
            });
        };

        var initImportATStatusFromDB = function () {
            getImportATStatus();
        };

        //获取验证信息
        var GetValidationList = function () {
            vatImportService.getServiceValidationList($scope.validationType, $scope.period, $scope.serviceTypeId, $scope.projectID).success(function (data) {
                if (data.length > 0) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = data;
                    $scope.gridOptionsErrorMsg.data = data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }


        //显示验证信息
        var toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');

                    $('#topIcon').css({ bottom: '-381px' });

                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };


        var setErrorWrapCssDefault = function () {
            $('#content-resizer').css('bottom', '0px');

            $('#topIcon').css({ bottom: '-501px' });

            $('.error-info-wrapper').css('height', '0px');
        };


        var showErrTab = function() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });
        };


        //加载文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            //初始化数据
            $scope.selectedMappingList = [];
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
        }


        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };


        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };


        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {

            var list = [];

            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };


        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };


        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };

        var refreshByService = {
            //VAT刷新数据,重新计算
            vatRefresh: function (operation) {
                vatImportService.refreshTrialBalance($scope.period, $scope.serviceTypeId).success(function (data) {
                    if (data === true) {
                        refreshByService.refreshSuccess(operation);
                    }
                    else {
                        refreshByService.refreshFail();

                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            },

            //CIT刷新数据，重新计算
            citRefresh: function (operation) {
                vatImportService.getTBImportedPeriods($scope.projectID, $scope.serviceTypeId).success(function (data) {
                    if (!_.isUndefined(data)) {
                        var citImportedPeriods = [];
                        var id = 1;
                        $.each(data, function (index, item) {
                            citImportedPeriods.push(item);
                        });
                        var importDto = { periods: citImportedPeriods, serviceTypeId: $scope.serviceTypeId };
                        vatImportService.refreshTrialBalancePeriods(importDto)
                            .success(function (data) {
                                if (data) {
                                    refreshByService.refreshSuccess(operation);
                                }
                                else {
                                    refreshByService.refreshFail();
                                }
                            }).error(function () {
                                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                            });
                    }

                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                })
            },

            //只获取TB数据，不计算
            refreshSuccess: function (operation) {
                var successMsg = "";
                if (operation === enums.optionType.DeleteDuplicate) {
                    $('#duplicatedValidationModal').modal('hide');
                    successMsg = $translate.instant('DeleteSuccess');
                }

                if (operation === enums.optionType.Refresh) {
                    logDto.UpdateState = $translate.instant('RefreshSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    successMsg = $translate.instant('RefreshSuccess');
                }

                if (operation === enums.optionType.Clear) {
                    logDto.UpdateState = $translate.instant('ClearSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    successMsg = $translate.instant('ClearSuccess');
                }

                if (operation === enums.optionType.Import) {
                    logDto.UpdateState = $translate.instant('ImportSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    successMsg = $translate.instant('ImportSuccess');
                }

                SweetAlert.success(successMsg);
                initImportATStatusFromDB();
            },

            refreshFail: function () {
                logDto.UpdateState = $translate.instant('RefreshTbFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('RefreshTbFail'));
            },

            callRefresh: function (serviceTypeId, operation) {
                if (serviceTypeId === constant.serviceType.VAT) {
                    refreshByService.vatRefresh(operation);
                }

                if (serviceTypeId === constant.serviceType.CIT) {
                    refreshByService.citRefresh(operation);
                }
            },
        };

        var initDatePicker = function () {
            var ele1 = $("#periodDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.selectedDate);
        };

        var initCompanyList = function () {
            orgService.getOrgListByUserId().success(function (data) {
                if (data) {
                    $scope.companyList = data;
                }
            });
        };

        $scope.selectOne = function () {
            $scope.checkedCompanyList = [];
            angular.forEach($scope.companyList , function (i) {
                var index = $scope.checkedCompanyList.indexOf(i.id);
                if(i.checked && index === -1) {
                    $scope.checkedCompanyList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedCompanyList.splice(index, 1);
                }
            });

            $scope.selectedAll = $scope.companyList.length === $scope.checkedCompanyList.length;

            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name+";";
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectAll = function () {
            if($scope.selectedAll) {
                $scope.selectedOne = true;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    $scope.checkedCompanyList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOne = false;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name;
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectOneFileType = function () {
            $scope.checkedFileList = [];
            angular.forEach($scope.fileTypeList , function (i) {
                var index = $scope.checkedFileList.indexOf(i.code);
                if(i.checked && index === -1) {
                    $scope.checkedFileList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedFileList.splice(index, 1);
                }
            });

            $scope.selectedAllFileType = $scope.fileTypeList.length === $scope.checkedFileList.length;

            $scope.checkedFileTypeList = "";
            $scope.checkedFileCodeList = [];
            angular.forEach($scope.checkedFileList,function (i) {
                $scope.checkedFileTypeList += i.type+";";
                $scope.checkedFileCodeList.push(i.code);
            });
            console.log($scope.checkedFileList);
        };

        $scope.selectAllFile = function () {
            if($scope.selectedAllFileType) {
                $scope.selectedOneFile = true;
                $scope.checkedFileList = [];
                angular.forEach($scope.fileTypeList, function (i, index) {
                    $scope.checkedFileList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOneFile = false;
                $scope.checkedFileList = [];
                angular.forEach($scope.fileTypeList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedFileTypeList = "";
            $scope.checkedFileCodeList = [];
            angular.forEach($scope.checkedFileList,function (i) {
                $scope.checkedFileTypeList += i.type+";";
                $scope.checkedFileCodeList.push(i.code);
            });
            console.log($scope.checkedFileList);
        };

        //开始
        (function initialize() {
            $log.debug('ImportTBController.ctor()...');
            checkUserOrganizationPermissionList();
            $scope.callApi = callApi;
            $scope.refreshTbData = refreshTbData;
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.errorLevelToString = errorLevelToString;
            $scope.getGridHeight = getGridHeight;
            $scope.getErrorGridHeight = getErrorGridHeight;
            $scope.toggleErrorTab = toggleErrorTab;
            $scope.showOperateLogPop = showOperateLogPop;

            $scope.setGridStyle = setGridStyle;

            getUserPermission();
            initCompanyList();

            loadImportATStatusInfoDatagrid();
            initDatePicker();

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);