﻿vatModule.controller('VatImportAutoMappingController', ['$scope', '$log', 'loginContext', '$translate', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatImportService', '$timeout', '$q', 'enums', 'uiGridConstants', '$interval', 'vatSessionService', 'vatOperationLogService', 'projectService', 'vatCommonService',
function ($scope, $log, loginContext, $translate, apiInterceptor, Upload, dataImportService, SweetAlert, vatImportService, $timeout, $q, enums, uiGridConstants, $interval, vatSessionService, vatOperationLogService, projectService, vatCommonService) {
    'use strict';
   

    $scope.importFileName = 'Book.xlsx';
    $scope.importFileSheets = ['sheet1', 'sheet2', 'sheet3'];
    $scope.startRows = [1, 2, 3, 4, 5, 6, 7];
    $scope.currentSheet = 'sheet1';
    $scope.startRow = 1;
    $scope.systemSuggestNames = ['未识别', '序号', '凭证日期', '期间', '凭证的日期', '凭证类型', '凭证号', '科目代码', '摘要', '借方金额', '贷方金额', '客户代码', '分录号'];

    $scope.mapDetails = [
        { importColName: '序号', systemSuggestName: '序号', mapReuslt: 1, importColContent: '1' },
        {
            importColName: '序列日期', systemSuggestName: '未识别', mapReuslt: 2, importColContent: '13212506122',showDetail:true,
            failReason: '系统识别 导入列名【凭证日期】所在列内容“123212321” 与列名内容不符，与系统列名【凭证日期】应包含内容不符。',
            systemSuggests: {
                suggestsByCol: ['凭证日期', '凭证的日期', '期间'],
                suggestsByContent: ['科目代码','分录号'],
            }
        },
        { importColName: '期间', systemSuggestName: '期间', mapReuslt: 1, importColContent: '2' },
        { importColName: '凭证类型', systemSuggestName: '凭证类型', mapReuslt: 1, importColContent: '记账凭证' },
        { importColName: '凭证号', systemSuggestName: '凭证号', mapReuslt: 1, importColContent: '1111111' },
        { importColName: '科目代码', systemSuggestName: '科目代码', mapReuslt: 1, importColContent: '022010' },
        {
            importColName: '摘抄', systemSuggestName: '未识别', mapReuslt: 2, importColContent: '2015.08.31中行POS清算入账',
            failReason: '系统无法识别 导入列【摘抄】',
            systemSuggests: {
                suggestsByCol: ['摘要', '凭证日期', '期间'],
                suggestsByContent: ['摘要'],
            }
        },
        { importColName: '借方金额', systemSuggestName: '借方金额', mapReuslt: 1, importColContent: '500,000,000' },
        { importColName: '贷方金额', systemSuggestName: '贷方金额', mapReuslt: 1, importColContent: '500,000,000' },
        { importColName: '客户代码', systemSuggestName: '客户代码', mapReuslt: 1, importColContent: '江苏010111' },
        { importColName: '分录号', systemSuggestName: '分录号', mapReuslt: 1, importColContent: '0901110222' },
    ];


    function updateMapInfo() {
        $scope.matchedFailCount = $scope.mapDetails.filter(function (mapDetail) {
            return mapDetail.mapReuslt !== 1;
        }).length;

        $scope.matchedSuccessCount = $scope.mapDetails.filter(function (mapDetail) {
            return mapDetail.mapReuslt === 1;
        }).length;


        $scope.matchedPercentage = ($scope.matchedSuccessCount / $scope.mapDetails.length * 100).toFixed(0) + '%';

    }
    

    $scope.addMap = function (mapDetail, colName) {
        mapDetail.mapReuslt = 1;
        mapDetail.systemSuggestName = colName;
        updateMapInfo();
        swal({
            title: "是否记住此次匹配关系？",
            showCancelButton: true,
            closeOnConfirm: true,
            icon:'warning',
            confirmButtonText: '是，下次默认执行',
            cancelButtonText:'不，仅做单次修改'
        });

    };

    $scope.showDetail = function (md) {
        $scope.mapDetails.forEach(function (mapDetail) {
            mapDetail.showDetail = false;
        });
        md.showDetail = true;
    };

    updateMapInfo();
}]);