﻿vatModule.controller('uploadFileModalController', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', '$uibModal',
    'vatOutputInvoiceManageService',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload, $uibModal, vatOutputInvoiceManageService) {

        var uploadFileController = function () {
            $scope.uploadOption = {};
            $scope.uploadOption.uploadFiles = null;

            $scope.confirmUpload = function () {
                $scope.uploadFileOption.files = $scope.files;
                $scope.modalInstance.dismiss('confirm');
                $scope.uploadFileType = null;

            };

            $scope.concelUpload = function () {
                $scope.modalInstance.dismiss('cancel');

                $scope.uploadFileType = null;
            };

            $scope.$watch('uploadOption.uploadFiles', function (newValue, oldValue) {
                if (newValue && newValue !== oldValue) {
                    doUploadFile();
                }
            });
        };

        $scope.chunkSize = 10 * 1024 * 1024;
        $scope.success = false;

        var resumable = true;
        var allFilesCount = 0;
        var successCount = 0;

        var updateProgressToZero = function () {
            $scope.percentNumber = '0%';
            $scope.showLoading = false;
        };

        $scope.files = [];
        var uploadSuccess = function (resp) {
            successCount++;
            $scope.files.push(resp);
            if (successCount === allFilesCount) {
                $scope.showLoading = false;
            }
        };

        var changeloadingTitle = function (title) {
            $scope.loadingTitle = $translate.instant(title);
        };

        var doUploadFile = function () {
            changeloadingTitle('fileUploading');
            uploadfile($scope.uploadOption.uploadFiles);
            $scope.uploadOption.uploadFiles = null;
        };

        //更新滚动条
        var updateProgress = function (evt) {
            $scope.showLoading = true;


            // console.log(evt.loaded + '/' + evt.total);
            var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);

            // 不知道为什么evt.loaded有可能比evt.total还要大---julius 2017/11/7
            if (progressPercentage > 100){
                progressPercentage = 100;
            }

            $scope.percentNumber = progressPercentage + '%';
        };

        //执行上传文件操作。
        var uploadfile = function (files) {
            if (files && files.length) {
                allFilesCount = files.length;
                successCount = 0;
                var uploadSuccessCallBack = function () {
                    updateProgressToZero();
                }
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];

                    if (!file.$error) {
                        var tempFileName = PWC.newGuid() + '.dat';
                        var token = $('input[name="__RequestVerificationToken"]').val();
                        updateProgressToZero();
                        Upload.upload({
                            url: apiInterceptor.webApiHostUrl + '/outputInvoicePrinted/uploadEvidenceFile',
                            data: {
                                cancel: false,
                                filename: file.name,
                                tempFileName: tempFileName,
                                file: file,
                                period: $scope.period
                            },
                            resumeChunkSize: resumable ? $scope.chunkSize : null,
                            headers: {
                                'Access-Control-Allow-Origin': '*',
                                Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                            },
                            __RequestVerificationToken: token,
                            withCredentials: true
                        }).then(uploadSuccess, uploadSuccessCallBack, updateProgress);
                    }
                }
            }
        };

        //删除证据文件
        $scope.deleteEvidenceFile = function (fileId) {
            var fileList = [fileId];
            vatOutputInvoiceManageService.deleteEvidenceFile(fileList).then(function () {
                $scope.files = _.filter($scope.files, function (item) {
                    return item.data.fileID != fileId;
                });
            });
        }

        //下载证据文件
        $scope.downloadEvidenceFile = function (data) {
            var queryDto = {};
            queryDto.fileName = data.fileName;
            queryDto.filePath = data.filePath;
            vatOutputInvoiceManageService.downloadEvidenceFile(queryDto);
        }

        $scope.$watch('uploadFileType', function (newValue,oldValue) {
            if (newValue) {
                if (newValue === 'multiple') {
                    $scope.isMultiple = true;
                } else {
                    $scope.isMultiple = false;
                }
                $scope.files = [];
                if ($scope.uploadFileOption.files) {
                    _.each($scope.uploadFileOption.files, function (item) {
                        $scope.files.push(item);
                    });
                }

                var parentElem = angular.element($('#upload-file-modal-wrapper'));
                $scope.modalInstance = $uibModal.open({
                    backdrop: 'static',
                    templateUrl: 'uploadFileModal.html',
                    controller: uploadFileController,
                    appendTo: parentElem,
                    scope: $scope
                });
            }
        });
    }]);