﻿vatModule.controller('VatPreviewCoupaPurchasingReportController', ['$rootScope','$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatPreviewService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($rootScope,$scope, $log, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, vatPreviewService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;
        $scope.totalMoneyAmount = 0;
        $scope.totalTaxAmount = 0;

        var minDate = [1, vatSessionService.project.year];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;


            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
        };

        /*var countTotal = function(){
            $scope.queryParams.pageInfo = {
                totalCount: -1,
                pageIndex: 1,
                pageSize: -1,
                totalPage: 0,
            };
            vatPreviewService.queryInputInvoiceAllList($scope.queryParams).success(function (data) {
                if (data) {
                    var totalMoneyAmount = 0;
                    var totalTaxAmount = 0;
                    _.each(data, function (x) {
                        totalMoneyAmount = totalMoneyAmount + parseFloat(x.hjje.replace(/,/g, ""));
                        totalTaxAmount = totalTaxAmount + parseFloat(x.hjse.replace(/,/g, ""));
                    })
                    $scope.totalMoneyAmount = totalMoneyAmount.toLocaleString();
                    $scope.totalTaxAmount = totalTaxAmount.toLocaleString();
                }
            });
        };*/

        //从数据库中load数据
        var loadCoupaPurchasingReportDataFromDB = function (pageIndex) {
            initCoupaPurchasingReportPagination();

            $scope.curCoupaPurchasingReportPage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryCoupaPurchasingReportResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryCoupaPurchasingReportResult.pageInfo.pageSize,
                totalPage: 0
            };
            $scope.getDataFromDatabase($scope.queryParams);
        };

        $scope.getDataFromDatabase = function (queryParams){
            vatPreviewService.getCPRDataForDisplay(queryParams).success(function (data) {
                if (data) {
                    // minDate = data.
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryCoupaPurchasingReportResult.pageInfo = data;
                    computeCoupaPurchasingReportPage();
                    $scope.ledgerName = data.list[0].ledgerName;
                    $scope.currencyCode = data.list[0].ledgerCurrencyCode;
                    $scope.status = data.list[0].status;
                    $scope.importDate = $filter('date')(data.list[0].date, "yyyy-MM-dd hh:mm:ss");
                }
            });
        };

        //点击任意一页加载数据事件
        var loadCoupaPurchasingReportDataByPage = function (pageIndex) {
            loadCoupaPurchasingReportDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeCoupaPurchasingReportPage = function () {

            if ($scope.queryCoupaPurchasingReportResult.pageInfo && $scope.queryCoupaPurchasingReportResult.pageInfo.total > 0) {

                var totalPage = parseInt($scope.queryCoupaPurchasingReportResult.pageInfo.total / $scope.queryCoupaPurchasingReportResult.pageInfo.pageSize);
                totalPage = $scope.queryCoupaPurchasingReportResult.pageInfo.totalCount % $scope.queryCoupaPurchasingReportResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryCoupaPurchasingReportResult.pageInfo.pageNum === totalPage) {
                    $scope.curPageItemCount = $scope.queryCoupaPurchasingReportResult.pageInfo.total % $scope.queryCoupaPurchasingReportResult.pageInfo.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.queryCoupaPurchasingReportResult.pageInfo.pageSize;
                }

                $scope.queryCoupaPurchasingReportResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curCoupaPurchasingReportPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadCoupaPurchasingReportDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curCoupaPurchasingReportPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadCoupaPurchasingReportDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initCoupaPurchasingReportPagination = function () {
            $scope.queryCoupaPurchasingReportResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0,
                }
            }

            $scope.curCoupaPurchasingReportPage = 1;
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
            $scope.criteriaList = [];
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            // countTotal();
            loadCoupaPurchasingReportDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        var prepareSummary = function () {
            // do something before show popover
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);
        };

        //导出进项发票数据
        var downloadInputInvoice = function () {
            vatPreviewService.getExportInputInvoiceList($scope.queryParams).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, '进项发票信息.xls');
            });
        };


        (function initialize() {
            $log.debug('VatPreviewCoupaPurchasingReportController.ctor()...');
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.startMonth = startMonth;
                 $scope.endMonth = endMonth;

                 $scope.queryParams.periodStart = vatSessionService.year * 100 + vatSessionService.month;
                 $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
                 // countTotal();
                 $scope.queryParams.orgId = vatSessionService.project.organizationID;
                 loadCoupaPurchasingReportDataFromDB(1);
             });


            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: [
                 { name: $translate.instant('CoupaInvoiceNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceNum}}<span></div>' },
                 // { name: $translate.instant('InvoiceQJ'), width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodID}}<span></div>' },
                 { name: $translate.instant('CoupaLineNum'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.lineNum}}<span></div>' },
                 { name: $translate.instant('HeadUpStatus'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.headUpStatus}}</span></div>' },
                 { name: $translate.instant('CoupaInvoiceDate'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('InvoiceReceiptDate'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceReceiptDate | date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('PayExpiration'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.payExpiration}}</span></div>' },
                 { name: $translate.instant('PurchaseOrderNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.purchaseOrderNum}}</span></div>' },
                 { name: $translate.instant('PurchaseOrderLineNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.purchaseOrderLineNum}}</span></div>' },
                 { name: $translate.instant('CoupaDescription'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.description}}</span></div>' },
                 { name: $translate.instant('SupplierNumber'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.supplierNum}}</span></div>' },
                 { name: $translate.instant('Supplier'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.supplier}}</span></div>' },
                 { name: $translate.instant('Total'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.totalAmount}}</span></div>' },
                 { name: $translate.instant('Currency'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.currency}}</span></div>' },
                 { name: $translate.instant('Bill'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.billNum}}</span></div>' },
                 { name: $translate.instant('Paid'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.paid}}</span></div>' },
                 { name: $translate.instant('Prepayments'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.prepayments}}</span></div>' },
                 { name: $translate.instant('ReviewReason'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.reviewReason}}</span></div>' },
                 { name: $translate.instant('Commodity'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.commodity}}</span></div>' },
                 { name: $translate.instant('CommodityCode'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.commodityCode}}</span></div>' },
                 { name: $translate.instant('Founder'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.founder}}</span></div>' },
                 { name: $translate.instant('CreationDate'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.createDate | date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('CurrentApprover'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.currentApprover}}</span></div>' },
                 { name: $translate.instant('CoupaBillingDate'),width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.billingDate | date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('LastUpdatedDate'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.lastUpdatedDate | date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('LastUpdatedPerson'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.lastUpdatedPerson}}</span></div>' },
                 { name: $translate.instant('CoupaTotalTaxAmount'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.totalTaxAmount}}</span></div>' },
                 { name: $translate.instant('TotalTaxAmountHeader'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.totalTaxAmountHeader}}</span></div>' },
                 { name: $translate.instant('BillingNote'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.billingNote}}</span></div>' }
                 ]
            };

            $scope.doDataFilterReset = doDataFilterReset;
            $scope.prepareSummary = prepareSummary;
            $scope.showPopover = showPopover;
            $scope.downloadInputInvoice = downloadInputInvoice;

            initPeriods();
            initCoupaPurchasingReportPagination();
            //初始化查询条件-期间范围
            if($rootScope.currentLanguageDesc = $rootScope.currentLanguage === 'en-us'){
                $('.periodInput')[0].style.left = "280px";
            }else{
                $('.periodInput')[0].style.left = "170px";
            }
            $scope.queryParams.periodStart = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
            // countTotal();
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            // countTotal();
            loadCoupaPurchasingReportDataFromDB(1);

        })();
    }
]);




