﻿vatModule.controller('VatPreviewInvoiceRecordController', ['$rootScope','$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatPreviewService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($rootScope,$scope, $log, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, vatPreviewService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;
        $scope.totalMoneyAmount = 0;
        $scope.totalTaxAmount = 0;

        var minDate = [1, vatSessionService.project.year];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;


            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
        };

        /*var countTotal = function(){
            $scope.queryParams.pageInfo = {
                totalCount: -1,
                pageIndex: 1,
                pageSize: -1,
                totalPage: 0,
            };
            vatPreviewService.queryInputInvoiceAllList($scope.queryParams).success(function (data) {
                if (data) {
                    var totalMoneyAmount = 0;
                    var totalTaxAmount = 0;
                    _.each(data, function (x) {
                        totalMoneyAmount = totalMoneyAmount + parseFloat(x.hjje.replace(/,/g, ""));
                        totalTaxAmount = totalTaxAmount + parseFloat(x.hjse.replace(/,/g, ""));
                    })
                    $scope.totalMoneyAmount = totalMoneyAmount.toLocaleString();
                    $scope.totalTaxAmount = totalTaxAmount.toLocaleString();
                }
            });
        };*/

        //从数据库中load数据
        var loadInvoiceRecordItemDataFromDB = function (pageIndex) {
            initInvoiceRecordItemPagination();

            $scope.curInvoiceRecordItemPage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryInvoiceRecordResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryInvoiceRecordResult.pageInfo.pageSize,
                totalPage: 0
            };
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            $scope.getDataFromDatabase($scope.queryParams);
        };

        $scope.getDataFromDatabase = function (queryParams){
            vatPreviewService.getIRDataForDisplay(queryParams).success(function (data) {
                if (data) {
                    // minDate = data.
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryInvoiceRecordResult.pageInfo = data;
                    computeInvoiceRecordItemPage();
                    $scope.ledgerName = data.list[0].ledgerName;
                    $scope.currencyCode = data.list[0].ledgerCurrencyCode;
                    $scope.status = data.list[0].status;
                    $scope.importDate = $filter('date')(data.list[0].date, "yyyy-MM-dd hh:mm:ss");
                }
            });
        };

        //点击任意一页加载数据事件
        var loadInvoiceRecordDataByPage = function (pageIndex) {
            loadInvoiceRecordItemDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeInvoiceRecordItemPage = function () {

            if ($scope.queryInvoiceRecordResult.pageInfo && $scope.queryInvoiceRecordResult.pageInfo.total > 0) {

                var totalPage = parseInt($scope.queryInvoiceRecordResult.pageInfo.total / $scope.queryInvoiceRecordResult.pageInfo.pageSize);
                totalPage = $scope.queryInvoiceRecordResult.pageInfo.totalCount % $scope.queryInvoiceRecordResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryInvoiceRecordResult.pageInfo.pageNum === totalPage) {
                    $scope.curPageItemCount = $scope.queryInvoiceRecordResult.pageInfo.total % $scope.queryInvoiceRecordResult.pageInfo.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.queryInvoiceRecordResult.pageInfo.pageSize;
                }

                $scope.queryInvoiceRecordResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curInvoiceRecordItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadInvoiceRecordDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curInvoiceRecordItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadInvoiceRecordDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initInvoiceRecordItemPagination = function () {
            $scope.queryInvoiceRecordResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0
                }
            };

            $scope.curInvoiceRecordItemPage = 1;
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
            $scope.criteriaList = [];
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            // countTotal();
            loadInvoiceRecordItemDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);


            //初始化已选择的发票类型和认证结果
            $scope.InvoiceType.selected = _.find($scope.invoiceTypeList, function (v) {
                return v.id == $scope.queryParams.invoiceType;
            })

            $scope.CertificationStatus.selected = _.find($scope.cetificationResultList, function (v) {
                return v.id == $scope.queryParams.certificationStatus;
            })
        };

        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.startMonth = startMonth;
                 $scope.endMonth = endMonth;

                 $scope.queryParams.periodStart = startMonth;
                 $scope.queryParams.periodEnd = endMonth;
                 $scope.queryParams.orgId = vatSessionService.project.organizationID;
                 // countTotal();
                 loadInvoiceRecordItemDataFromDB(1);
             });

            var downloadIR = function () {
                vatPreviewService.initExportIRData($scope.queryParams).success(function (data, status, headers) {
                    if(status===204){
                        SweetAlert.warning("没有数据可以下载");
                        return;
                    }
                    vatExportService.exportToExcel(data, status, headers, '日记账信息.xls');
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            };


            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: [
                 { name: $translate.instant('VatInvoiceRecordNoCol'),width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.seqNo}}<span></div>' },
                 // { name: $translate.instant('InvoiceQJ'), width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodID}}<span></div>' },
                 { name: $translate.instant('BillingBody'),width: 200,   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.billingBody }}<span></div>' },
                 { name: $translate.instant('CustomerCompanyName'),width: 200,   cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.fpdm}}">{{row.entity.customerCompanyName}}</span></div>' },
                 { name: $translate.instant('InvoiceType'),width: 200,   cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.fphm}}">{{row.entity.invoiceType}}</span></div>' },
                 { name: $translate.instant('BillingContent'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.xfsh}}">{{row.entity.billingContent}}</span></div>' },
                 { name: $translate.instant('InvoiceAmount'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.fplx}}">{{row.entity.invoiceAmount}}</span></div>' },
                 { name: $translate.instant('Applicant'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents "><span>{{row.entity.applicant}}</span></div>' },
                 { name: $translate.instant('OAApplicationNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents "><span>{{row.entity.oaApplicationNum}}</span></div>' },
                 { name: $translate.instant('ContractNo'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.contractNo }}</span></div>' },
                 { name: $translate.instant('ContractAmount'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.contractAmount}}</span></div>' },
                 { name: $translate.instant('Department'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.department}}</span></div>' },
                 { name: $translate.instant('ApplicationDate'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.applicationDate| date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('BillingDate'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.billingDate| date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('BillingMonth'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.billingMonth| date:"MM"}}</span></div>' },
                 { name: $translate.instant('invoiceCode'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceCode}}</span></div>' },
                 { name: $translate.instant('InvoiceNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceNum}}</span></div>' },
                 { name: $translate.instant('InvoicePaperNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoicesAmount}}</span></div>' },
                 { name: $translate.instant('CustomerCompanyTaxNum'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.customerCompanyTaxNum}}</span></div>' },
                 { name: $translate.instant('CustomerSourceSystem'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.contractSourceSystem}}</span></div>' },
                 { name: $translate.instant('TaxRate'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxRate}}</span></div>' },
                 { name: $translate.instant('TaxAmount'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxAmount}}</span></div>' },
                 { name: $translate.instant('InvoiceStatus'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceStatus}}</span></div>' },
                 { name: $translate.instant('InvoiceSource'), width: 200,  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.source}}</span></div>' },
                 { name: $translate.instant('InvoiceRemarks'), width: 200, cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.remarks}}</span></div>' }
                 ]
            };

            $scope.doDataFilterReset = doDataFilterReset;
            $scope.showPopover = showPopover;
            $scope.downloadIR = downloadIR;


            initPeriods();
            initInvoiceRecordItemPagination();
            //初始化查询条件-期间范围
            $scope.queryParams.periodStart = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            if($rootScope.currentLanguageDesc = $rootScope.currentLanguage === 'en-us'){
                $('.periodInput')[0].style.left = "280px";
            }else{
                $('.periodInput')[0].style.left = "150px";
            }
            loadInvoiceRecordItemDataFromDB(1);

        })();
    }
]);




